/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 2 "src/mup/gram.y"


/*
 Copyright (c) 1995-2019  by Arkkra Enterprises.
 All rights reserved.

 Redistribution and use in source and binary forms,
 with or without modification, are permitted provided that
 the following conditions are met:

 1. Redistributions of source code must retain
 the above copyright notice, this list of conditions
 and the following DISCLAIMER.

 2. Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and
 the following DISCLAIMER in the documentation and/or
 other materials provided with the distribution.

 3. Any additions, deletions, or changes to the original files
 must be clearly indicated in accompanying documentation,
 including the reasons for the changes,
 and the names of those who made the modifications.

	DISCLAIMER

 THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* This file contains the parser code for the Mup music publication program.
 * It uses lex to get the tokens.
 */


#include "rational.h"
#include "globals.h"
#include "defines.h"
#include "structs.h"
#include <errno.h>

#define YYDEBUG 1


/* how many items to allocate at a time for
 * "with" list, and location lists, etc */
#define ITEMS	(4)

/* Shorter way to refer to the current entry when building an entry from
 * accidentals context */
#define CURR_ACC_ENTRY	Acc_contexts_list_p->info[Curr_acc_index]

/* It user gives consecutive restoreparms with no intervening saveparms,
 * all but the last are pointless, as the last overwrites. So we have simple
 * state machine to catch this and print a warning. Even with an intervening
 * saveparms, multiple restoreparms is dubious, because really all you could
 * do is save something that you had already saved, but under a different
 * name. But we distinguish those cases. These value record what was
 * the previous control {Save|Restore}parms command type.
 * Once we see warn case, we stay in that state
 * to avoid duplicate warnings for the same issue.
 */
#define SR_SAVE		(0)
#define SR_RESTORE	(1)
#define SR_WARN	(2)


static struct MAINLL *Currstruct_p;	/* main list struct being filled in */
static struct BLOCKHEAD *Currblock_p;	/* current block, if non-zero */

static struct INPCOORD *Curr_loc_info_p; /* location info being collected */
static struct USER_SYMBOL *Curr_usym_p;	/* user-defined symbol being defined */


static short Saw_restoreparms;		/* Yes if we have seen a restoreparms
					 * in the current control context */
static short Prev_control_parms;	/* Previous {save|restore}parms */
static short Getting_tup_dur;		/* YES if currently collection tuplet
					 * duration rather than GRPSYL dur */

static struct GRPSYL *Curr_grpsyl_p;	/* current GRPSYL struct being filled in */
static struct GRPSYL *Last_grpsyl_p;	/* previous GRPSYL struct filled in (contains
					 * defaults for the current one */
static struct TIMELIST *Extra_time_p;	/* If user enters times to be added
					 * together, like 2.+16 this points to
					 * a linked list of the extra times */
static struct TIMELIST *Curr_timelist_p;/* current additive time, used to know
					 * where to link items to the list */
static struct TIMELIST *Last_alloced_timelist_p; /* Most recently allocated
					 * list. Keeping track of this lets us
					 * avoid trying to free the list
					 * when Extra_time_p is pointing
					 * to a list from an SSV. */
static struct GRPSYL *Prev_grpsyl_p;	/* Like Last_grpsyl_p except in the
					 * case of additive times,
					 * in which case it points to the
					 * first group. This is needed in case
					 * the following group is to get its
					 * time value by defaulting to that
					 * of its previous group. */
static int Extra_basictime;		/* for saving basictime, when doing
					 * additive times */
static int Doing_timeunit = NO;		/* YES if gathering timeunit param */
static struct GRPSYL *Lyrics_p;		/* pointer to current list of lyrics */
static struct WITH_ITEM *Curr_marklist;	/* current "with" list */
static int Mark_start;			/* Index into Curr_marklist at which
					 * the currently-being-gathered list
					 * began, since user could do things
					 * like [with - above;with . below][with "sfz"]
					 * Since we don't know the place till
					 * the end of a list, this lets us
					 * know how far back in the list to
					 * update with above or below.
					 */
static struct PRINTDATA **Next_print_link_p_p;	/* points to where to attach next
						 * print command that we get */
static int Item_count;			/* items in current list */
static int Max_items;			/* current amount of space in lists
					 * "with" list, curve locations, etc) */

static int Plus_minus;			/* if 1 add, if -1 subtract offset */
static int Defining_multiple = NO;	/* if defining multiple voices at once */
static int Chord_at_a_time = NO;	/* YES for chord-at-a-time,
					 * NO for voice-at-a-time */
static int EM_staff;			/* Staff number of most recent
					 * emptymeas parameter usage */
static short Endingloc;			/* if current bar starts or ends an
					 * ending, etc (STARTITEM, ENDITEM, etc) */
static short Endending_type;		/* EE_* value. Only relevent if
					 * Endingloc == ENDITEM */
static short Got_ending;		/* YES if got ending on this bar */

static int Til_bars;			/* number of bars in "til" clause */
static int Bar_between;                 /* YES or NO, if to put bar lines
                                         * between staffs rather than on then */
static struct SUBBAR_APPEARANCE *Subbar_app_p;	/* Info for subbartype parameter */
static double Dist;			/* dist for a specific STUFF */
static int Dist_usage;			/* meaning of Dist field */
static int Aligntag = NOALIGNTAG;	/* align tag number for STUFF */
static short User_meas_time;		/* YES if user specified a time for
					 * an 'm' item. Only valid on mr */
static int Order_place;			/* PL_* for markorder in SSV */
static int Order_prio;			/* value in markorder in SSV */
static int Start_gracebackup;		/* how many grace notes to back up
					 * before starting a "stuff" */
static int End_gracebackup;		/* how many grace notes to back up
					 * before ending a "stuff" */
static float Til_offset;		/* beat count in "til" clause */
static float Til_steps;			/* stepsize offset of "til" clause */
static int Linetype;			/* L_DOTTED, L_DASHED, or L_NORMAL */

static char *String1, *String2;		/* to temporarily keep track
					 * of labels and other temporary
					 * strings */
static char Tmpbuff[20];		/* temporary buffer for converting
					 * float numbers */
static char Stringbuff[100];		/* temporary string storage */
static int Titlefont, Titlesize;	/* font/size for title command */
static double Extra;			/* extra vertical space for prints */
static short Good_till_canceled = NO;	/* if [] things should be continued
					 * until turned off */
static short Curr_paratype = J_JUSTPARA; /* current paragraph type */
static char Curr_accs[2*MAX_ACCS];	/* list of current note's accidentals */
static int Acc_offset;			/* Current place in Curr_accs */
static int Curr_acc_index;		/* Current place in info array of
					 * current accidentals context */
static struct TIMEDSSV *Curr_tssv_p;	/* current mid-measure param change */
static char Timerep[MAXTSLEN];		/* Internal representation of time
					 * signature being collected */
static int Tsig_offset;			/* Current place in Timerep while
					 * collecting a time signature */
static struct TAG_REF *Curr_timeref_tag_p; /* Time offsets are relative
					 * to the most recent horizontal tag.
					 * This points to that tag,
					 * or is zero if no such tag yet */

/* Row index values must match the PS_* value definitions in defines.h.
 * Column [0] is height in portrait mode, and column [1] is height. */
double pagesztbl[7][2] = {
	{ 8.5, 11.0 },		/* PS_LETTER */
	{ 8.5, 14.0 },		/* PS_LEGAL */
	{ 8.5, 13.0 },		/* PS_FLSA */
	{ 5.5, 8.5 },		/* PS_HALFLETTER */
	{ 8.26, 11.69 },	/* PS_A4 */
	{ 5.84, 8.26 },		/* PS_A5 */
	{ 4.12, 5.84 }		/* PS_A6 */
};



/* static functions */
static char *stripquotes P((char *string));	/* rmv double quotes
						 * from string */
static void chkdup_headfoot P((int bit, char *which, struct BLOCKHEAD *block_p));
static void chkdup_topbot P((struct BLOCKHEAD **block_p_p, char *blocktype));
static void end_prev_context P((void));
static void clone_staff_ssvs P((struct MAINLL *insert_p));
static void clone_voice_ssvs P((struct MAINLL *insert_p));
static void clone1ssv P((struct SSV *clone_src_p, struct MAINLL *insert_p,
		int staffno, int voiceno));
static void chk_ssv_ranges P((UINT32B context));
static void var_valid P((void));	 /* check if okay to set location var */
static void proc_printcmd P((int justifytype, struct INPCOORD *inpc_p,
		char *str, int font, int size, int got_nl,
		int isPostScript, int ps_usage, int isfilename, 
		struct VAR_EXPORT *export_p, double extra));
static struct VAR_EXPORT *add_export P((char *varname, int index));
static double extra_needed P((int font, int size, char **string_p));
static void keyword_notes P((char *str));
static void free_extra_time P((void));
static void tsig_item P((int item));
static struct EXPR_NODE *newnode P((int op));
static void clear_curr_accs P((void));
static void add_acc P((char *acc_name));
static void new_acc_entry P((char *acc_name));
static void add_acc_offset P((int letter, double offset));
#ifdef __STDC__
static int comp_subbar P((const void *item1_p, const void *item2_p));
#else
static int comp_subbar P((char *item1_p, char *item2_p));
#endif



/* Line 371 of yacc.c  */
#line 305 "src/mup/ytab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "ytab.h".  */
#ifndef YY_YY_SRC_MUP_YTAB_H_INCLUDED
# define YY_YY_SRC_MUP_YTAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_1ARG_FUNC = 258,
     T_2ARG_FUNC = 259,
     T_2FNUMVAR = 260,
     T_ACCIDENTALS = 261,
     T_ADDSUB_OP = 262,
     T_ALIGN = 263,
     T_ALL = 264,
     T_ALT = 265,
     T_AMPERSAND = 266,
     T_ANY = 267,
     T_ARRAYVAR = 268,
     T_AUTO = 269,
     T_BARSTLISTVAR = 270,
     T_BARTYPE = 271,
     T_BBOX = 272,
     T_BLOCKHEAD = 273,
     T_BM = 274,
     T_BULGE = 275,
     T_CENTS = 276,
     T_CLEF = 277,
     T_CLEFVAR = 278,
     T_COLON = 279,
     T_COMMA = 280,
     T_COMMON = 281,
     T_CONTROL = 282,
     T_CUE = 283,
     T_CURVE = 284,
     T_CUT = 285,
     T_DASH = 286,
     T_DBLFLAT = 287,
     T_DIAM = 288,
     T_DOT = 289,
     T_DOWN = 290,
     T_DRUM = 291,
     T_EBM = 292,
     T_EM_BEGIN = 293,
     T_EM_END = 294,
     T_ENDENDING = 295,
     T_ENDING = 296,
     T_ENDSTYLE = 297,
     T_ENDTYPE = 298,
     T_EPH = 299,
     T_EQUAL = 300,
     T_ESBM = 301,
     T_EVERY = 302,
     T_EXCLAM = 303,
     T_FAMILY = 304,
     T_FFAMILY = 305,
     T_FILE = 306,
     T_FIRSTPAGE = 307,
     T_FNUMVAR = 308,
     T_FONT = 309,
     T_FONTVAR = 310,
     T_GRACE = 311,
     T_GRIDS = 312,
     T_HAT = 313,
     T_HEADSHAPES = 314,
     T_HIDECHANGES = 315,
     T_HO = 316,
     T_HS = 317,
     T_INPUTDIR = 318,
     T_KEY = 319,
     T_KEYMAP = 320,
     T_KEYMAPVAR = 321,
     T_LBRACE = 322,
     T_LBRACKET = 323,
     T_LEN = 324,
     T_LET = 325,
     T_LETTER = 326,
     T_LET_M = 327,
     T_LET_N = 328,
     T_LET_R = 329,
     T_LET_S = 330,
     T_LET_U = 331,
     T_LET_X = 332,
     T_LINE = 333,
     T_LINETYPE = 334,
     T_LPAREN = 335,
     T_LVAR = 336,
     T_LYRICS = 337,
     T_L_ANGLE = 338,
     T_L_DBLANGLE = 339,
     T_MEASNUM = 340,
     T_MIDDLE = 341,
     T_MIDI = 342,
     T_MNUM = 343,
     T_MODIFIER = 344,
     T_MULDIV_OP = 345,
     T_MULTIREST = 346,
     T_MULTIWHOLE = 347,
     T_MUSIC = 348,
     T_MUSSYM = 349,
     T_NEWLINE = 350,
     T_NL = 351,
     T_NONE = 352,
     T_NONNAT = 353,
     T_NOWHERE_SLIDE = 354,
     T_NUM = 355,
     T_NUMBER = 356,
     T_NUMVAR = 357,
     T_OCTAVE = 358,
     T_OPTSTRVAR = 359,
     T_ORDER = 360,
     T_ORIENTATION = 361,
     T_OTHERTEXT = 362,
     T_PAD = 363,
     T_PAGESIDE = 364,
     T_PAGESIZE = 365,
     T_PARAGRAPH = 366,
     T_PARATYPE = 367,
     T_PEDAL = 368,
     T_PEDSTAR = 369,
     T_PEDSTYLE = 370,
     T_PH = 371,
     T_PHRASE = 372,
     T_PITCH = 373,
     T_PLACE = 374,
     T_PLUS = 375,
     T_POSTSCRIPT = 376,
     T_PRINTTYPE = 377,
     T_PSHOOKLOC = 378,
     T_PSVAR = 379,
     T_QUESTION = 380,
     T_RANGELISTVAR = 381,
     T_RATNUMLISTVAR = 382,
     T_RBRACE = 383,
     T_RBRACKET = 384,
     T_REHEARSAL = 385,
     T_REHTYPE = 386,
     T_REH_STYLE = 387,
     T_REPEATDOTS = 388,
     T_RESTOREPARMS = 389,
     T_ROLL = 390,
     T_RPAREN = 391,
     T_RPT = 392,
     T_R_ANGLE = 393,
     T_R_DBLANGLE = 394,
     T_SAVEPARMS = 395,
     T_SCORE = 396,
     T_SCOREFEED = 397,
     T_SCOREPAD = 398,
     T_SCORESEP = 399,
     T_SEMICOLON = 400,
     T_SHARP = 401,
     T_SHORTEN = 402,
     T_SLASH = 403,
     T_SLASHMARK = 404,
     T_SLOPE = 405,
     T_SLUR = 406,
     T_STAFF = 407,
     T_STAFFLINES = 408,
     T_STANDARD = 409,
     T_STAR = 410,
     T_STEMOFFSET = 411,
     T_STRING = 412,
     T_STRVAR = 413,
     T_SUBBARSTYLE = 414,
     T_SWINGUNIT = 415,
     T_SYMBOL = 416,
     T_TAB = 417,
     T_TICKS = 418,
     T_TIE = 419,
     T_TIL = 420,
     T_TILDE = 421,
     T_TIME = 422,
     T_TIMEUNIT = 423,
     T_TITLE = 424,
     T_TO = 425,
     T_TRANSPOSE = 426,
     T_TRANSUSAGE = 427,
     T_TUNINGTYPE = 428,
     T_TUNINGVAR = 429,
     T_UNARY_OP = 430,
     T_UNITS = 431,
     T_UNITTYPE = 432,
     T_UNSET = 433,
     T_UP = 434,
     T_USEACCS = 435,
     T_USING = 436,
     T_VCOMBINE = 437,
     T_VCOMBVAL = 438,
     T_VISVAR = 439,
     T_VOICE = 440,
     T_VVAR = 441,
     T_WHEREUSED = 442,
     T_WITH = 443,
     T_XNOTE = 444,
     T_XPOS_INT = 445,
     T_YESNOVAR = 446
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 242 "src/mup/gram.y"

int	intval;		/* for tokens/nonterminals that return int values */
char	*stringval;	/* for tokens/nonterminals that return strings */
float	floatval;	/* for nonterminals that return floats */
RATIONAL ratval;	/* for nonterminals that return rational numbers */
struct INPCOORD *inpcoord_p;	/* for nonterminals that return coord info */
struct EXPR_NODE *expr_p;/* for nonterminals that return coord expression */
struct TAG_REF *tag_p;	/* for nonterminals that return a tag reference */
struct VAR_EXPORT *export_p;	/* for Mup variables to be passed to user PostScript */


/* Line 387 of yacc.c  */
#line 551 "src/mup/ytab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_SRC_MUP_YTAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 579 "src/mup/ytab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  224
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1645

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  192
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  338
/* YYNRULES -- Number of rules.  */
#define YYNRULES  776
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1186

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   446

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    15,    17,    19,
      22,    24,    26,    29,    33,    35,    38,    40,    42,    44,
      46,    48,    50,    52,    54,    57,    61,    62,    68,    69,
      75,    77,    81,    83,    85,    89,    92,    93,    94,    97,
      99,   101,   105,   106,   108,   112,   114,   117,   119,   122,
     126,   130,   132,   136,   139,   141,   144,   147,   151,   153,
     156,   158,   160,   162,   165,   168,   170,   172,   177,   180,
     185,   190,   196,   201,   205,   210,   211,   216,   221,   226,
     232,   237,   242,   247,   251,   255,   259,   263,   267,   271,
     275,   279,   284,   288,   292,   296,   299,   300,   305,   309,
     314,   319,   323,   327,   331,   338,   342,   346,   350,   354,
     358,   362,   366,   376,   382,   384,   386,   388,   389,   391,
     392,   394,   396,   398,   401,   402,   404,   406,   407,   408,
     410,   412,   414,   418,   422,   423,   428,   433,   435,   436,
     438,   439,   442,   445,   447,   449,   450,   451,   453,   455,
     459,   463,   464,   467,   468,   473,   474,   477,   479,   480,
     481,   483,   488,   491,   492,   494,   496,   499,   500,   502,
     512,   513,   514,   516,   518,   519,   521,   529,   531,   533,
     534,   537,   539,   543,   545,   547,   551,   553,   555,   557,
     559,   561,   565,   569,   571,   573,   575,   577,   579,   581,
     583,   585,   587,   590,   592,   593,   597,   599,   600,   605,
     607,   609,   613,   617,   619,   621,   625,   627,   628,   630,
     631,   633,   637,   641,   644,   645,   647,   649,   651,   654,
     657,   660,   666,   667,   669,   671,   673,   676,   681,   682,
     684,   685,   687,   689,   691,   693,   694,   697,   700,   701,
     705,   706,   710,   711,   716,   718,   720,   722,   725,   726,
     728,   729,   732,   733,   735,   737,   739,   741,   743,   744,
     746,   748,   751,   753,   755,   756,   758,   765,   768,   769,
     771,   772,   774,   775,   779,   781,   784,   788,   796,   797,
     799,   801,   803,   805,   807,   809,   811,   813,   815,   817,
     819,   821,   823,   825,   827,   829,   831,   833,   835,   837,
     839,   841,   843,   845,   847,   849,   851,   853,   855,   857,
     859,   861,   863,   865,   867,   869,   871,   873,   875,   877,
     879,   883,   886,   891,   895,   897,   898,   900,   902,   904,
     907,   911,   913,   915,   917,   921,   923,   927,   929,   931,
     934,   936,   938,   942,   945,   946,   949,   952,   957,   958,
     961,   963,   966,   968,   974,   975,   977,   979,   982,   987,
     989,   991,   993,   995,   999,  1003,  1007,  1011,  1014,  1016,
    1021,  1028,  1029,  1033,  1034,  1039,  1040,  1041,  1043,  1045,
    1049,  1054,  1056,  1058,  1060,  1062,  1066,  1069,  1072,  1075,
    1078,  1080,  1082,  1085,  1086,  1088,  1089,  1091,  1093,  1097,
    1099,  1103,  1106,  1109,  1111,  1115,  1119,  1120,  1121,  1123,
    1124,  1126,  1127,  1131,  1133,  1137,  1139,  1141,  1143,  1145,
    1147,  1149,  1151,  1153,  1155,  1157,  1159,  1161,  1163,  1166,
    1168,  1170,  1171,  1173,  1174,  1178,  1180,  1182,  1183,  1186,
    1191,  1192,  1193,  1195,  1196,  1199,  1201,  1205,  1206,  1208,
    1210,  1212,  1215,  1218,  1219,  1221,  1225,  1228,  1232,  1235,
    1238,  1240,  1241,  1244,  1247,  1248,  1252,  1254,  1255,  1259,
    1261,  1263,  1265,  1268,  1270,  1272,  1274,  1276,  1278,  1280,
    1282,  1284,  1288,  1291,  1297,  1303,  1307,  1313,  1321,  1327,
    1332,  1339,  1344,  1350,  1355,  1356,  1358,  1360,  1361,  1363,
    1364,  1366,  1367,  1369,  1373,  1374,  1375,  1378,  1380,  1382,
    1384,  1386,  1388,  1392,  1394,  1396,  1398,  1400,  1402,  1404,
    1406,  1408,  1410,  1413,  1415,  1418,  1424,  1426,  1427,  1429,
    1431,  1433,  1436,  1439,  1442,  1444,  1446,  1448,  1450,  1452,
    1454,  1456,  1458,  1460,  1464,  1466,  1475,  1476,  1478,  1480,
    1482,  1484,  1486,  1487,  1489,  1490,  1493,  1499,  1503,  1505,
    1506,  1509,  1513,  1514,  1516,  1517,  1519,  1521,  1523,  1527,
    1530,  1531,  1534,  1537,  1538,  1539,  1545,  1547,  1549,  1551,
    1555,  1558,  1559,  1562,  1563,  1566,  1567,  1569,  1571,  1574,
    1577,  1581,  1583,  1589,  1590,  1592,  1594,  1597,  1600,  1606,
    1609,  1611,  1613,  1614,  1618,  1620,  1621,  1624,  1626,  1628,
    1633,  1635,  1637,  1642,  1643,  1645,  1646,  1648,  1650,  1652,
    1656,  1657,  1662,  1665,  1667,  1668,  1673,  1674,  1677,  1679,
    1682,  1684,  1686,  1690,  1694,  1698,  1702,  1710,  1713,  1715,
    1716,  1718,  1720,  1722,  1724,  1731,  1732,  1734,  1736,  1739,
    1741,  1742,  1746,  1750,  1754,  1757,  1762,  1769,  1771,  1775,
    1778,  1780,  1782,  1784,  1786,  1788,  1790,  1794,  1797,  1798,
    1800,  1802,  1804,  1812,  1813,  1814,  1816,  1817,  1822,  1830,
    1831,  1834,  1837,  1839,  1843,  1845,  1849,  1852,  1854,  1858,
    1866,  1873,  1876,  1878,  1880,  1882,  1884,  1887,  1889,  1891,
    1893,  1895,  1897,  1898,  1902,  1903,  1905,  1906,  1909,  1912,
    1916,  1917,  1919,  1920,  1923,  1925,  1928,  1934,  1937,  1938,
    1943,  1944,  1949,  1950,  1952,  1954,  1955,  1958,  1961,  1964,
    1967,  1970,  1975,  1981,  1982,  1984,  1986,  1989,  1991,  1994,
    1995,  1998,  2002,  2005,  2009,  2013,  2019,  2021,  2022,  2024,
    2026,  2028,  2029,  2032,  2034,  2038,  2040,  2042,  2046,  2048,
    2050,  2052,  2054,  2058,  2060,  2061,  2063
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     193,     0,    -1,   194,    -1,   193,   194,    -1,   195,   454,
      -1,   226,    -1,   311,    -1,   317,    -1,   321,    -1,   455,
      95,    -1,   219,    -1,   211,    -1,   218,   227,    -1,   446,
     454,    95,    -1,    95,    -1,     1,    95,    -1,   196,    -1,
     217,    -1,   205,    -1,   207,    -1,   220,    -1,   208,    -1,
     216,    -1,   221,    -1,   206,   204,    -1,   141,   204,   203,
      -1,    -1,   152,   204,   197,   199,   203,    -1,    -1,   185,
     204,   198,   201,   203,    -1,   200,    -1,   199,   331,   200,
      -1,   334,    -1,   202,    -1,   201,   331,   202,    -1,   334,
     337,    -1,    -1,    -1,    18,   232,    -1,    93,    -1,    57,
      -1,     6,   209,   210,    -1,    -1,   320,    -1,   212,   213,
      95,    -1,   320,    -1,     9,   215,    -1,   214,    -1,   395,
     215,    -1,   214,   395,   215,    -1,   468,   474,    21,    -1,
     474,    -1,   474,   148,   474,    -1,    65,   320,    -1,    27,
      -1,   140,   320,    -1,   134,   320,    -1,   320,   320,    95,
      -1,    59,    -1,   161,   320,    -1,   224,    -1,   224,    -1,
     101,    -1,   381,   224,    -1,   228,   227,    -1,   145,    -1,
      95,    -1,   102,    45,   381,   224,    -1,   102,    45,    -1,
      52,    45,   224,   232,    -1,    53,    45,   381,   474,    -1,
       5,    45,   474,    25,   474,    -1,   147,    45,   474,   298,
      -1,    63,    45,   300,    -1,   124,    45,   301,   302,    -1,
      -1,   182,    45,   229,   303,    -1,   108,    45,   381,   474,
      -1,   186,    45,   224,   235,    -1,   127,    45,   236,   237,
     243,    -1,   126,    45,   244,   245,    -1,    15,    45,   252,
     253,    -1,   159,    45,   257,   258,    -1,   133,    45,   269,
      -1,   270,    45,   271,    -1,    64,    45,   284,    -1,   180,
      45,   285,    -1,   167,    45,   274,    -1,   153,    45,   287,
      -1,    55,    45,    54,    -1,    49,    45,    50,    -1,    23,
      45,    22,   233,    -1,   191,    45,   293,    -1,   184,    45,
     231,    -1,    85,    45,   234,    -1,   178,   319,    -1,    -1,
     168,    45,   230,   241,    -1,   160,    45,   242,    -1,   144,
      45,   294,   295,    -1,   143,    45,   296,   297,    -1,    42,
      45,   305,    -1,   132,    45,   131,    -1,   115,    45,   308,
      -1,   171,    45,   306,   309,   224,   310,    -1,    28,    45,
     293,    -1,   176,    45,   177,    -1,   158,    45,   320,    -1,
     104,    45,   506,    -1,   174,    45,   173,    -1,    66,    45,
     506,    -1,   121,    45,   320,    -1,    17,    45,   225,    25,
     225,    25,   225,    25,   225,    -1,   156,    45,   225,    25,
     225,    -1,   187,    -1,    71,    -1,    73,    -1,    -1,   109,
      -1,    -1,    71,    -1,    71,    -1,    73,    -1,    47,   224,
      -1,    -1,   118,    -1,    71,    -1,    -1,    -1,   238,    -1,
     241,    -1,   239,    -1,   238,    25,   241,    -1,   238,    25,
     239,    -1,    -1,    80,   240,   238,   136,    -1,   373,   378,
     374,   377,    -1,    72,    -1,    -1,   241,    -1,    -1,    74,
      75,    -1,    75,    74,    -1,    75,    -1,    74,    -1,    -1,
      -1,   246,    -1,   247,    -1,   246,    25,   247,    -1,   224,
     248,   249,    -1,    -1,    31,   224,    -1,    -1,    80,   251,
     250,   136,    -1,    -1,    25,   251,    -1,   320,    -1,    -1,
      -1,   256,    -1,   253,    25,   254,   256,    -1,   254,     9,
      -1,    -1,   255,    -1,   119,    -1,   224,   248,    -1,    -1,
     259,    -1,   258,   259,   261,   262,   263,   260,   266,   167,
     267,    -1,    -1,    -1,   480,    -1,    16,    -1,    -1,   255,
      -1,    80,   264,   265,   170,   264,   265,   136,    -1,    18,
      -1,    86,    -1,    -1,   468,   474,    -1,   256,    -1,   266,
      25,   256,    -1,     9,    -1,   268,    -1,   267,    25,   268,
      -1,   474,    -1,     9,    -1,   154,    -1,   105,    -1,   272,
      -1,   271,    25,   272,    -1,   271,    11,   272,    -1,   273,
      -1,    94,    -1,   103,    -1,   107,    -1,    89,    -1,    82,
      -1,    41,    -1,   130,    -1,   113,    -1,   275,   282,    -1,
     277,    -1,    -1,   275,   276,   277,    -1,   279,    -1,    -1,
     277,   120,   278,   279,    -1,    30,    -1,    26,    -1,   280,
     148,   224,    -1,   280,   120,    92,    -1,    92,    -1,   281,
      -1,   280,   120,   281,    -1,   224,    -1,    -1,   293,    -1,
      -1,    73,    -1,   224,   403,   307,    -1,   395,   396,   307,
      -1,   293,   286,    -1,    -1,    97,    -1,     9,    -1,    98,
      -1,   224,   283,    -1,   224,    36,    -1,   162,   288,    -1,
     162,    80,   289,   136,   288,    -1,    -1,    73,    -1,    71,
      -1,   290,    -1,   289,   290,    -1,   395,   291,   292,   398,
      -1,    -1,   403,    -1,    -1,   163,    -1,    71,    -1,    73,
      -1,   474,    -1,    -1,    25,   474,    -1,   381,   474,    -1,
      -1,    25,   381,   474,    -1,    -1,    25,   474,   299,    -1,
      -1,    25,   225,    25,   225,    -1,    12,    -1,   369,    -1,
     110,    -1,   395,   224,    -1,    -1,   106,    -1,    -1,   337,
     304,    -1,    -1,   183,    -1,    43,    -1,    18,    -1,   179,
      -1,    35,    -1,    -1,   190,    -1,    78,    -1,    10,   114,
      -1,   114,    -1,   190,    -1,    -1,   172,    -1,   169,   312,
     315,   316,   454,    95,    -1,   314,   313,    -1,    -1,    54,
      -1,    -1,    50,    -1,    -1,    80,   224,   136,    -1,   320,
      -1,   320,   320,    -1,   320,   320,   320,    -1,   318,   111,
     312,   315,   320,   454,    95,    -1,    -1,   112,    -1,   102,
      -1,   191,    -1,   144,    -1,   153,    -1,   168,    -1,   160,
      -1,   108,    -1,    15,    -1,    53,    -1,     5,    -1,    52,
      -1,    63,    -1,   147,    -1,   133,    -1,   176,    -1,    42,
      -1,   132,    -1,    85,    -1,   115,    -1,   186,    -1,   182,
      -1,   143,    -1,   126,    -1,   159,    -1,   105,    -1,   180,
      -1,    64,    -1,   167,    -1,   171,    -1,   127,    -1,   184,
      -1,   158,    -1,    28,    -1,   104,    -1,   174,    -1,    66,
      -1,    55,    -1,    49,    -1,    23,    -1,   157,    -1,   320,
     120,   157,    -1,   322,    95,    -1,   323,   324,   333,   339,
      -1,    91,   224,   454,    -1,   421,    -1,    -1,   330,    -1,
     325,    -1,   326,    -1,   325,   326,    -1,   327,   329,   328,
      -1,    68,    -1,   129,    -1,   330,    -1,   329,   145,   330,
      -1,   332,    -1,   330,   331,   332,    -1,    11,    -1,   334,
      -1,   334,   337,    -1,    24,    -1,   335,    -1,   334,    25,
     335,    -1,   222,   336,    -1,    -1,    31,   222,    -1,   223,
     338,    -1,   223,    31,   223,   338,    -1,    -1,    25,   337,
      -1,   340,    -1,   339,   340,    -1,   415,    -1,   341,   347,
     382,   357,   145,    -1,    -1,   342,    -1,   343,    -1,   342,
     343,    -1,    84,   344,   345,   139,    -1,   141,    -1,   152,
      -1,   185,    -1,   346,    -1,   345,   145,   346,    -1,    23,
      45,    22,    -1,   102,    45,   224,    -1,   191,    45,   293,
      -1,   348,   371,    -1,   351,    -1,    68,    31,   129,   351,
      -1,    68,   351,   352,   129,   349,   350,    -1,    -1,    34,
      34,    34,    -1,    -1,   350,    68,   352,   129,    -1,    -1,
      -1,   353,    -1,   354,    -1,   353,   145,   354,    -1,   188,
     360,   364,   361,    -1,   412,    -1,   368,    -1,   379,    -1,
     369,    -1,    53,   381,   224,    -1,    61,   355,    -1,    62,
     320,    -1,    69,   474,    -1,   149,   224,    -1,   120,    -1,
      31,    -1,   356,   474,    -1,    -1,   468,    -1,    -1,   358,
      -1,   359,    -1,   358,    25,   359,    -1,   370,    -1,   150,
     381,   474,    -1,    10,   224,    -1,   116,   426,    -1,    44,
      -1,   151,   362,   363,    -1,   164,   362,   363,    -1,    -1,
      -1,   119,    -1,    -1,   369,    -1,    -1,   170,   185,   224,
      -1,   365,    -1,   364,    25,   365,    -1,   366,    -1,   367,
      -1,   320,    -1,    34,    -1,    31,    -1,   138,    -1,    58,
      -1,    28,    -1,    56,    -1,    33,    -1,   189,    -1,   179,
      -1,    35,    -1,    19,   372,    -1,    46,    -1,    37,    -1,
      -1,   241,    -1,    -1,   188,   152,   119,    -1,    92,    -1,
     224,    -1,    -1,   374,   375,    -1,   468,   376,   373,   378,
      -1,    -1,    -1,    72,    -1,    -1,   378,    34,    -1,   380,
      -1,   108,   381,   474,    -1,    -1,    31,    -1,   388,    -1,
     383,    -1,   384,   387,    -1,   385,   386,    -1,    -1,   125,
      -1,   166,   362,   363,    -1,    45,   413,    -1,    58,   395,
     398,    -1,    58,   148,    -1,    62,   320,    -1,   407,    -1,
      -1,   387,   386,    -1,   391,   389,    -1,    -1,   390,   391,
     119,    -1,   188,    -1,    -1,   391,   392,   387,    -1,   393,
      -1,    74,    -1,    75,    -1,    76,    75,    -1,   137,    -1,
      16,    -1,    56,    -1,    43,    -1,   112,    -1,   126,    -1,
      22,    -1,   180,    -1,    80,   393,   136,    -1,   395,   394,
      -1,   395,    80,   399,   136,   398,    -1,   395,    80,   404,
     136,   394,    -1,   395,    80,   395,    -1,   395,   399,   292,
     398,   394,    -1,   395,   399,   292,    80,   404,   136,   394,
      -1,   395,   399,   292,    80,   395,    -1,   395,   163,   398,
     394,    -1,   395,   163,    80,   404,   136,   394,    -1,   395,
     404,   397,   394,    -1,   395,   404,    80,   399,   136,    -1,
     395,   404,    80,   395,    -1,    -1,   320,    -1,   118,    -1,
      -1,   403,    -1,    -1,   399,    -1,    -1,   404,    -1,   400,
     402,   401,    -1,    -1,    -1,   401,   402,    -1,   146,    -1,
      11,    -1,    73,    -1,    77,    -1,    32,    -1,    67,   320,
     128,    -1,   146,    -1,    11,    -1,    73,    -1,    77,    -1,
      32,    -1,   224,    -1,   405,    -1,   406,    -1,    31,    -1,
     405,    31,    -1,   120,    -1,   406,   120,    -1,   408,   409,
     138,   362,   363,    -1,    83,    -1,    -1,    99,    -1,   410,
      -1,   411,    -1,   410,   411,    -1,   395,   398,    -1,    45,
     413,    -1,    71,    -1,   118,    -1,    72,    -1,    74,    -1,
      75,    -1,    76,    -1,    73,    -1,    77,    -1,    81,    -1,
     414,    34,   224,    -1,    13,    -1,   417,   339,   418,   419,
     224,   416,   420,   145,    -1,    -1,    73,    -1,   100,    -1,
      71,    -1,    67,    -1,   128,    -1,    -1,   119,    -1,    -1,
      25,   241,    -1,    82,   422,   424,    24,   437,    -1,   423,
     427,   430,    -1,   425,    -1,    -1,   181,   222,    -1,   181,
     222,   223,    -1,    -1,   119,    -1,    -1,   119,    -1,   428,
      -1,     9,    -1,   427,    25,   428,    -1,   224,   429,    -1,
      -1,    31,   224,    -1,    11,   224,    -1,    -1,    -1,   430,
     145,   119,   431,   427,    -1,   433,    -1,   118,    -1,   434,
      -1,   433,    25,   434,    -1,   224,   435,    -1,    -1,    31,
     224,    -1,    -1,   438,   444,    -1,    -1,   439,    -1,   440,
      -1,   439,   440,    -1,   441,   145,    -1,   436,   371,   443,
      -1,   442,    -1,   417,   439,   418,   224,   420,    -1,    -1,
      75,    -1,   445,    -1,   444,   445,    -1,   320,   145,    -1,
      68,   432,   129,   320,   145,    -1,   456,   461,    -1,   478,
      -1,   482,    -1,    -1,   142,   447,   448,    -1,   517,    -1,
      -1,   448,   449,    -1,   450,    -1,   452,    -1,    53,   453,
     356,   451,    -1,   474,    -1,    14,    -1,   144,   453,   381,
     474,    -1,    -1,    45,    -1,    -1,   145,    -1,   489,    -1,
     511,    -1,   480,   457,   458,    -1,    -1,    80,   480,    16,
     136,    -1,   459,   460,    -1,    16,    -1,    -1,   460,    38,
     321,    39,    -1,    -1,   461,   462,    -1,   380,    -1,    45,
     413,    -1,   463,    -1,    60,    -1,    88,    45,   224,    -1,
      88,   468,   224,    -1,    70,    45,   320,    -1,   100,    45,
     224,    -1,   130,   464,   314,   313,   495,   465,   497,    -1,
      41,   320,    -1,    40,    -1,    -1,   320,    -1,    88,    -1,
     100,    -1,    70,    -1,    80,   467,   469,    25,   470,   136,
      -1,    -1,   120,    -1,    31,    -1,   471,   472,    -1,   472,
      -1,    -1,    80,   472,   136,    -1,   472,     7,   472,    -1,
     472,    90,   472,    -1,     7,   472,    -1,     3,    80,   472,
     136,    -1,     4,    80,   472,    25,   472,   136,    -1,   474,
      -1,   477,    34,   473,    -1,   167,   474,    -1,    71,    -1,
      77,    -1,   118,    -1,    73,    -1,    75,    -1,   224,    -1,
     224,    34,   475,    -1,    34,   476,    -1,    -1,   476,    -1,
     101,    -1,   413,    -1,   480,    78,   479,   466,   170,   466,
     481,    -1,    -1,    -1,    79,    -1,    -1,   188,   312,   315,
     320,    -1,   480,    29,   483,   488,   170,   488,   484,    -1,
      -1,   170,   485,    -1,    20,   486,    -1,   488,    -1,   485,
     170,   488,    -1,   487,    -1,   486,    25,   487,    -1,   381,
     474,    -1,   466,    -1,   490,    24,   501,    -1,   493,   495,
     496,   425,   427,   497,   500,    -1,   480,   117,   495,   425,
     427,   497,    -1,   491,   492,    -1,    87,    -1,   330,    -1,
       9,    -1,   494,    -1,   314,    54,    -1,    83,    -1,   138,
      -1,   113,    -1,    94,    -1,   103,    -1,    -1,    80,   224,
     136,    -1,    -1,    89,    -1,    -1,    53,   498,    -1,   474,
     499,    -1,    31,   474,   499,    -1,    -1,    48,    -1,    -1,
       8,   224,    -1,   502,    -1,   501,   502,    -1,   503,   505,
     506,   507,   145,    -1,   474,   504,    -1,    -1,    80,    31,
     224,   136,    -1,    -1,    68,   468,   474,   129,    -1,    -1,
     155,    -1,   320,    -1,    -1,   165,   508,    -1,   474,   509,
      -1,   504,   505,    -1,    72,   510,    -1,   504,   505,    -1,
     120,   474,   504,   505,    -1,   135,   512,   513,    24,   516,
      -1,    -1,   179,    -1,    35,    -1,   514,   515,    -1,   222,
      -1,   222,   223,    -1,    -1,   170,   222,    -1,   170,   222,
     223,    -1,   474,   145,    -1,   516,   474,   145,    -1,   528,
     529,   320,    -1,   518,   520,   521,   519,   320,    -1,   121,
      -1,    -1,    51,    -1,   529,    -1,   123,    -1,    -1,   188,
     522,    -1,   523,    -1,   522,    25,   523,    -1,   526,    -1,
     524,    -1,   525,    45,   526,    -1,   527,    -1,   414,    -1,
     527,    -1,   477,    -1,   477,    34,   473,    -1,   122,    -1,
      -1,    96,    -1,   466,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   578,   578,   581,   584,   587,   590,   593,   596,   599,
     602,   605,   608,   611,   614,   620,   631,   638,   642,   648,
     652,   656,   660,   664,   668,   683,   692,   692,   712,   712,
     730,   732,   736,   741,   743,   746,   752,   758,   764,  1012,
    1017,  1023,  1028,  1033,  1075,  1083,  1091,  1101,  1105,  1111,
    1117,  1123,  1129,  1139,  1148,  1161,  1174,  1197,  1216,  1224,
    1233,  1236,  1242,  1252,  1258,  1261,  1264,  1267,  1286,  1301,
    1307,  1323,  1329,  1335,  1341,  1350,  1350,  1354,  1361,  1367,
    1377,  1383,  1389,  1401,  1411,  1419,  1422,  1428,  1434,  1439,
    1445,  1451,  1482,  1488,  1491,  1497,  1527,  1527,  1542,  1554,
    1559,  1564,  1575,  1596,  1624,  1655,  1661,  1667,  1673,  1679,
    1691,  1697,  1716,  1737,  1757,  1769,  1785,  1796,  1801,  1807,
    1812,  1827,  1840,  1846,  1866,  1872,  1885,  1898,  1903,  1907,
    1911,  1917,  1920,  1926,  1930,  1930,  1935,  1993,  2011,  2016,
    2021,  2026,  2032,  2038,  2044,  2050,  2056,  2060,  2064,  2067,
    2070,  2079,  2085,  2097,  2103,  2110,  2116,  2122,  2126,  2132,
    2136,  2139,  2142,  2149,  2153,  2157,  2169,  2177,  2182,  2188,
    2194,  2199,  2204,  2221,  2231,  2239,  2242,  2251,  2270,  2276,
    2281,  2287,  2290,  2293,  2299,  2302,  2306,  2339,  2345,  2350,
    2370,  2378,  2386,  2393,  2405,  2411,  2417,  2423,  2442,  2448,
    2454,  2460,  2466,  2488,  2491,  2491,  2497,  2502,  2502,  2508,
    2514,  2520,  2543,  2555,  2563,  2566,  2569,  2588,  2593,  2599,
    2604,  2612,  2623,  2662,  2681,  2689,  2695,  2701,  2708,  2714,
    2720,  2730,  2737,  2742,  2748,  2758,  2764,  2770,  2779,  2784,
    2792,  2798,  2809,  2819,  2824,  2838,  2856,  2866,  2881,  2899,
    2911,  2915,  2921,  2925,  2937,  2943,  2949,  2952,  2978,  2983,
    2991,  2996,  3005,  3010,  3017,  3023,  3032,  3038,  3044,  3049,
    3065,  3071,  3077,  3082,  3086,  3091,  3096,  3100,  3120,  3125,
    3131,  3136,  3141,  3146,  3152,  3161,  3182,  3207,  3301,  3308,
    3315,  3318,  3321,  3324,  3327,  3330,  3333,  3336,  3339,  3342,
    3345,  3348,  3351,  3354,  3357,  3360,  3363,  3366,  3369,  3372,
    3375,  3378,  3381,  3384,  3387,  3390,  3393,  3396,  3399,  3402,
    3405,  3408,  3411,  3414,  3417,  3420,  3423,  3426,  3429,  3432,
    3443,  3456,  3468,  3487,  3522,  3528,  3532,  3538,  3544,  3547,
    3550,  3553,  3558,  3563,  3569,  3575,  3582,  3585,  3592,  3600,
    3609,  3616,  3619,  3625,  3634,  3640,  3650,  3663,  3684,  3688,
    3693,  3696,  3700,  3703,  3746,  3750,  3754,  3757,  3761,  3770,
    3776,  3782,  3789,  3792,  3796,  3806,  3823,  3839,  3843,  3859,
    3865,  3870,  3875,  3881,  3885,  3893,  3900,  3907,  3910,  3913,
    3916,  3931,  3934,  3937,  3940,  3957,  3974,  3985,  4012,  4023,
    4048,  4054,  4060,  4080,  4085,  4090,  4093,  4097,  4100,  4104,
    4107,  4120,  4148,  4160,  4171,  4186,  4200,  4211,  4216,  4222,
    4227,  4234,  4239,  4256,  4259,  4262,  4278,  4287,  4291,  4298,
    4305,  4312,  4318,  4330,  4342,  4352,  4363,  4369,  4375,  4403,
    4409,  4440,  4449,  4460,  4465,  4481,  4508,  4556,  4561,  4565,
    4580,  4601,  4606,  4619,  4624,  4630,  4650,  4656,  4662,  4668,
    4681,  4686,  4690,  4694,  4713,  4735,  4754,  4795,  4813,  4826,
    4845,  4848,  4851,  4855,  4862,  4867,  4907,  4914,  4922,  4928,
    4931,  4938,  4951,  4964,  4980,  5001,  5008,  5020,  5031,  5043,
    5055,  5063,  5068,  5080,  5090,  5100,  5116,  5122,  5132,  5148,
    5154,  5160,  5169,  5175,  5189,  5194,  5211,  5218,  5224,  5229,
    5234,  5238,  5244,  5249,  5254,  5259,  5263,  5268,  5274,  5280,
    5286,  5292,  5298,  5305,  5311,  5317,  5324,  5331,  5337,  5343,
    5355,  5365,  5371,  5377,  5383,  5390,  5397,  5404,  5413,  5420,
    5424,  5427,  5431,  5443,  5452,  5458,  5466,  5473,  5480,  5487,
    5494,  5501,  5508,  5515,  5522,  5529,  5536,  5542,  5549,  5556,
    5568,  5573,  5579,  5584,  5593,  5600,  5605,  5609,  5614,  5624,
    5630,  5637,  5644,  5651,  5657,  5662,  5670,  5673,  5683,  5686,
    5694,  5701,  5711,  5717,  5721,  5721,  5725,  5730,  5741,  5746,
    5751,  5759,  5765,  5771,  5780,  5792,  5798,  5804,  5807,  5810,
    5813,  5835,  5839,  5846,  5852,  5858,  5861,  5865,  5876,  5881,
    5990,  5993,  5997,  5996,  6095,  6098,  6102,  6106,  6109,  6112,
    6182,  6188,  6194,  6206,  6209,  6212,  6215,  6219,  6222,  6225,
    6278,  6284,  6306,  6314,  6337,  6341,  6347,  6350,  6354,  6362,
    6373,  6406,  6420,  6427,  6442,  6448,  6453,  6470,  6479,  6494,
    6504,  6512,  6521,  6530,  6538,  6546,  6555,  6561,  6568,  6576,
    6586,  6603,  6609,  6617,  6625,  6639,  6647,  6655,  6662,  6704,
    6726,  6743,  6749,  6759,  6765,  6771,  6776,  6782,  6789,  6795,
    6798,  6803,  6806,  6828,  6835,  6840,  6845,  6850,  6855,  6868,
    6881,  6884,  6887,  6890,  6894,  6897,  6901,  6917,  6954,  6962,
    6969,  6984,  6994,  7001,  7004,  7011,  7020,  7044,  7056,  7062,
    7068,  7074,  7081,  7087,  7093,  7098,  7104,  7110,  7123,  7129,
    7142,  7147,  7153,  7158,  7169,  7172,  7176,  7184,  7194,  7199,
    7205,  7210,  7216,  7221,  7233,  7239,  7244,  7249,  7267,  7275,
    7281,  7289,  7296,  7300,  7305,  7312,  7319,  7323,  7330,  7336,
    7339,  7346,  7353,  7359,  7364,  7378,  7388,  7393,  7399,  7405,
    7414,  7421,  7426,  7432,  7435,  7447,  7454,  7461,  7475,  7481,
    7490,  7496,  7503,  7508,  7512,  7519,  7526
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_1ARG_FUNC", "T_2ARG_FUNC",
  "T_2FNUMVAR", "T_ACCIDENTALS", "T_ADDSUB_OP", "T_ALIGN", "T_ALL",
  "T_ALT", "T_AMPERSAND", "T_ANY", "T_ARRAYVAR", "T_AUTO",
  "T_BARSTLISTVAR", "T_BARTYPE", "T_BBOX", "T_BLOCKHEAD", "T_BM",
  "T_BULGE", "T_CENTS", "T_CLEF", "T_CLEFVAR", "T_COLON", "T_COMMA",
  "T_COMMON", "T_CONTROL", "T_CUE", "T_CURVE", "T_CUT", "T_DASH",
  "T_DBLFLAT", "T_DIAM", "T_DOT", "T_DOWN", "T_DRUM", "T_EBM",
  "T_EM_BEGIN", "T_EM_END", "T_ENDENDING", "T_ENDING", "T_ENDSTYLE",
  "T_ENDTYPE", "T_EPH", "T_EQUAL", "T_ESBM", "T_EVERY", "T_EXCLAM",
  "T_FAMILY", "T_FFAMILY", "T_FILE", "T_FIRSTPAGE", "T_FNUMVAR", "T_FONT",
  "T_FONTVAR", "T_GRACE", "T_GRIDS", "T_HAT", "T_HEADSHAPES",
  "T_HIDECHANGES", "T_HO", "T_HS", "T_INPUTDIR", "T_KEY", "T_KEYMAP",
  "T_KEYMAPVAR", "T_LBRACE", "T_LBRACKET", "T_LEN", "T_LET", "T_LETTER",
  "T_LET_M", "T_LET_N", "T_LET_R", "T_LET_S", "T_LET_U", "T_LET_X",
  "T_LINE", "T_LINETYPE", "T_LPAREN", "T_LVAR", "T_LYRICS", "T_L_ANGLE",
  "T_L_DBLANGLE", "T_MEASNUM", "T_MIDDLE", "T_MIDI", "T_MNUM",
  "T_MODIFIER", "T_MULDIV_OP", "T_MULTIREST", "T_MULTIWHOLE", "T_MUSIC",
  "T_MUSSYM", "T_NEWLINE", "T_NL", "T_NONE", "T_NONNAT", "T_NOWHERE_SLIDE",
  "T_NUM", "T_NUMBER", "T_NUMVAR", "T_OCTAVE", "T_OPTSTRVAR", "T_ORDER",
  "T_ORIENTATION", "T_OTHERTEXT", "T_PAD", "T_PAGESIDE", "T_PAGESIZE",
  "T_PARAGRAPH", "T_PARATYPE", "T_PEDAL", "T_PEDSTAR", "T_PEDSTYLE",
  "T_PH", "T_PHRASE", "T_PITCH", "T_PLACE", "T_PLUS", "T_POSTSCRIPT",
  "T_PRINTTYPE", "T_PSHOOKLOC", "T_PSVAR", "T_QUESTION", "T_RANGELISTVAR",
  "T_RATNUMLISTVAR", "T_RBRACE", "T_RBRACKET", "T_REHEARSAL", "T_REHTYPE",
  "T_REH_STYLE", "T_REPEATDOTS", "T_RESTOREPARMS", "T_ROLL", "T_RPAREN",
  "T_RPT", "T_R_ANGLE", "T_R_DBLANGLE", "T_SAVEPARMS", "T_SCORE",
  "T_SCOREFEED", "T_SCOREPAD", "T_SCORESEP", "T_SEMICOLON", "T_SHARP",
  "T_SHORTEN", "T_SLASH", "T_SLASHMARK", "T_SLOPE", "T_SLUR", "T_STAFF",
  "T_STAFFLINES", "T_STANDARD", "T_STAR", "T_STEMOFFSET", "T_STRING",
  "T_STRVAR", "T_SUBBARSTYLE", "T_SWINGUNIT", "T_SYMBOL", "T_TAB",
  "T_TICKS", "T_TIE", "T_TIL", "T_TILDE", "T_TIME", "T_TIMEUNIT",
  "T_TITLE", "T_TO", "T_TRANSPOSE", "T_TRANSUSAGE", "T_TUNINGTYPE",
  "T_TUNINGVAR", "T_UNARY_OP", "T_UNITS", "T_UNITTYPE", "T_UNSET", "T_UP",
  "T_USEACCS", "T_USING", "T_VCOMBINE", "T_VCOMBVAL", "T_VISVAR",
  "T_VOICE", "T_VVAR", "T_WHEREUSED", "T_WITH", "T_XNOTE", "T_XPOS_INT",
  "T_YESNOVAR", "$accept", "song", "item", "context", "ssv_context", "$@1",
  "$@2", "ssv_stafflist", "ssv_staff_item", "ssv_sv_list", "ssv_sv_item",
  "alloc_ssv", "new_context", "blockhead_context", "music_context",
  "grid_context", "accidentals_context", "begin_acc_context",
  "acc_context_name", "acc_entry", "acc_name", "offsets_spec",
  "offsets_list", "acc_offset", "keymap_context", "control_context",
  "control_item", "stringpair", "headshape_context", "symbol_context",
  "staffnum", "voicenum", "num", "value", "assignment", "terminator",
  "assign", "$@3", "$@4", "visval", "opt_pageside", "opt_print_clef",
  "measnumval", "vschemetype", "allocbeamlist", "ratnumlist",
  "nonempty_ratnumlist", "subbeam", "$@5", "time_item", "swing_time",
  "opt_rs", "alloc_rangelist", "rangelist", "rangelistA", "rangeitem",
  "rangetail", "grplabel", "optlabel2", "glabel", "alloc_barstlist",
  "barstlist", "opt_between", "between", "barst_item", "subbar_check",
  "subbar_list", "alloc_subbar", "alloc_sb_barstlist", "sb_linetype",
  "sb_bartype", "sb_appearance", "line_ref", "line_offset", "sb_barstlist",
  "sb_timelist", "sb_count", "repeatdots_value", "mark_order", "orderlist",
  "orderitem", "marktype", "timesig", "tsiglist", "$@6", "meas_tsig",
  "$@7", "fraction", "numerator", "numerator_value", "opt_ts_visibility",
  "opt_n", "keyspec", "useaccs_value", "useaccs_qual", "stafflinedef",
  "prclef", "tab_string_list", "tab_item", "opt_str_acc", "opt_ticks",
  "flagval", "minscsep", "maxscsep", "minscpad", "maxscpad",
  "shorten_opts", "shorten_range", "inputdir", "pagesize", "orientation",
  "vcombine_value", "opt_vcombine_qualifier", "end_type", "updown",
  "majmin", "pedstyle", "transpose_interval", "trans_usage", "title",
  "tfont", "title_font", "font_family", "title_size", "titleA",
  "paragraph", "opt_paratype", "paramname", "string", "music_input",
  "noteinfo", "init_staff", "sv_spec", "sv_map_list", "sv_map_entry",
  "map_start", "map_finish", "sv_map_item_list", "voice_id", "sv_and",
  "sv_item", "notecolon", "grp_stafflist", "grp_staff_item",
  "grp_staff_range", "voice_spec", "voice_tail", "groupinfo", "groupdata",
  "mid_meas_param", "mid_meas_list", "mid_meas_item", "mm_context",
  "mm_params", "mm_param_item", "grp_attributes", "styleinfo", "gtc",
  "extra_styleinfo", "alloc_grpsyl", "marklist", "marklistA", "markitem",
  "hor_offset", "opt_plus_or_minus", "other_attr", "attr_list",
  "attr_item", "alloc_marklist", "mark_place", "opt_dir", "opt_to_voice",
  "marks", "mark", "mark_item", "shorthand_mark", "notetype", "dir",
  "beammark", "time_val", "crossbeam", "basic_time_val", "opt_more_time",
  "more_time_item", "alloc_timelist", "opt_m", "dots", "padding",
  "padspec", "opt_minus", "group", "special_group", "extra_attr",
  "spec_grp_alloc", "extra_item", "note_opts", "notelist",
  "opt_other_staff", "css_with", "some_notes", "notedata", "notedata1",
  "opt_bend", "pitch", "opt_accidental", "opt_acc_list", "opt_octave",
  "acc_list", "begin_acc_list", "acc_list_tail", "note_acc", "acc_symbol",
  "octave", "minuslist", "pluslist", "slur_item", "start_slur", "slurlist",
  "fullslurlist", "slurnote", "grp_locsave", "loc_variable", "arraytag",
  "ntuplet", "printtup", "start_tuplet", "rbrace", "opt_side", "opt_time",
  "lyricinfo", "lyric_id", "lyr_opt_place", "using", "opt_place",
  "ph_opt_place", "staff_list", "staff_item", "staff_range",
  "more_lyric_ids", "$@8", "verse_spec", "verselist", "verse_item",
  "verse_range", "alloc_lyr_grpsyl", "lyricdata", "lyr_tlist",
  "lyrics_timelist", "lyr_time_item", "lyr_tm", "lyrtuplet", "opt_space",
  "lyr_verse", "verse_string", "os_directive", "$@9", "scorefeed_options",
  "scorefeed_item", "temp_margin", "margin_override", "temp_scoresep",
  "opt_equals", "opt_semi", "directive", "barinfo", "precbartype",
  "barline", "bartype", "emptymeas_input", "bar_items", "bar_opt",
  "ending_info", "chk_dup_reh", "rehearsal_mark", "location", "alloc_loc",
  "plus_or_minus", "xcoord", "ycoord", "coord_setup", "expression",
  "direction", "floatnum", "opt_decimal_part", "numstr", "variable",
  "line", "line_alloc", "linetype", "opt_line_str", "curve", "curve_alloc",
  "curve_tail", "loc_list", "bulgelist", "bulge_value", "curve_loc",
  "stuff_info", "stuff_header", "midi", "midi_staff", "stuff_id",
  "stuff_type", "opt_size", "opt_modifier", "opt_dist", "stuff_dist",
  "opt_exclam", "opt_align", "stufflist", "stuff_item", "beat_offset",
  "gracebackup", "steps_offset", "opt_string", "til_clause", "til_val",
  "til_suffix", "til_offset", "roll_cmd", "opt_roll_dir", "roll_extent",
  "roll_start", "roll_end", "roll_offsetlist", "printcmd", "postscript",
  "opt_file", "ps_opt_loc", "export_list", "export_var_list",
  "export_item", "aliased_var", "alias", "export_var",
  "alias_or_export_var", "printtype", "opt_loc", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   192,   193,   193,   194,   194,   194,   194,   194,   194,
     194,   194,   194,   194,   194,   194,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   196,   197,   196,   198,   196,
     199,   199,   200,   201,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   213,   214,   214,
     215,   215,   215,   216,   217,   218,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   227,   228,   228,   228,
     228,   228,   228,   228,   228,   229,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   230,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   231,   231,   231,   232,   232,   233,
     233,   234,   234,   234,   235,   235,   235,   236,   237,   237,
     238,   238,   238,   238,   240,   239,   241,   241,   242,   242,
     243,   243,   243,   243,   243,   244,   245,   245,   246,   246,
     247,   248,   248,   249,   249,   250,   250,   251,   252,   253,
     253,   253,   253,   254,   254,   255,   256,   257,   258,   258,
     259,   260,   261,   262,   263,   263,   263,   264,   264,   265,
     265,   266,   266,   266,   267,   267,   268,   269,   269,   270,
     271,   271,   271,   272,   273,   273,   273,   273,   273,   273,
     273,   273,   274,   275,   276,   275,   277,   278,   277,   279,
     279,   279,   279,   279,   280,   280,   281,   282,   282,   283,
     283,   284,   284,   285,   286,   286,   286,   286,   287,   287,
     287,   287,   288,   288,   288,   289,   289,   290,   291,   291,
     292,   292,   293,   293,   294,   295,   295,   296,   297,   297,
     298,   298,   299,   299,   300,   300,   301,   301,   302,   302,
     303,   303,   304,   304,   305,   305,   306,   306,   307,   307,
     308,   308,   308,   309,   310,   310,   311,   312,   313,   313,
     314,   314,   315,   315,   316,   316,   316,   317,   318,   318,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   320,
     320,   321,   322,   322,   322,   323,   324,   324,   325,   325,
     326,   327,   328,   329,   329,   330,   330,   331,   332,   332,
     333,   334,   334,   335,   336,   336,   337,   337,   338,   338,
     339,   339,   340,   340,   341,   341,   342,   342,   343,   344,
     344,   344,   345,   345,   346,   346,   346,   347,   348,   348,
     348,   349,   349,   350,   350,   351,   352,   352,   353,   353,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   355,   355,   356,   356,   357,   357,   358,   358,   359,
     359,   359,   359,   359,   359,   359,   360,   361,   361,   362,
     362,   363,   363,   364,   364,   365,   366,   366,   367,   367,
     367,   367,   368,   368,   368,   368,   369,   369,   370,   370,
     370,   371,   371,   372,   372,   373,   373,   374,   374,   375,
     376,   377,   377,   378,   378,   379,   380,   381,   381,   382,
     382,   383,   384,   385,   386,   386,   386,   386,   386,   386,
     386,   387,   387,   388,   389,   389,   390,   391,   391,   392,
     392,   392,   392,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   393,   393,   393,   393,   393,   393,   393,   393,
     393,   393,   393,   393,   394,   394,   395,   396,   396,   397,
     397,   398,   398,   399,   400,   401,   401,   402,   402,   402,
     402,   402,   402,   403,   403,   403,   403,   403,   404,   404,
     404,   405,   405,   406,   406,   407,   408,   409,   409,   409,
     410,   410,   411,   412,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   414,   415,   416,   416,   416,   416,
     417,   418,   419,   419,   420,   420,   421,   422,   423,   424,
     424,   424,   425,   425,   426,   426,   427,   427,   427,   428,
     429,   429,   429,   430,   431,   430,   432,   432,   433,   433,
     434,   435,   435,   436,   437,   438,   438,   439,   439,   440,
     441,   441,   442,   443,   443,   444,   444,   445,   445,   446,
     446,   446,   447,   446,   446,   448,   448,   449,   449,   450,
     451,   451,   452,   453,   453,   454,   454,   455,   455,   456,
     457,   457,   458,   459,   460,   460,   461,   461,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   463,   463,   464,
     465,   465,   465,   465,   466,   467,   468,   468,   469,   470,
     471,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     473,   473,   473,   473,   473,   474,   474,   474,   475,   475,
     476,   477,   478,   479,   480,   480,   481,   481,   482,   483,
     484,   484,   485,   485,   486,   486,   487,   488,   489,   490,
     490,   490,   491,   492,   492,   493,   494,   494,   494,   494,
     494,   494,   495,   495,   496,   496,   497,   497,   498,   498,
     499,   499,   500,   500,   501,   501,   502,   503,   504,   504,
     505,   505,   506,   506,   506,   507,   507,   508,   509,   509,
     510,   510,   511,   512,   512,   512,   513,   514,   514,   515,
     515,   515,   516,   516,   517,   517,   518,   519,   519,   520,
     520,   521,   521,   522,   522,   523,   523,   524,   525,   526,
     526,   527,   527,   528,   529,   529,   529
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     2,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     0,     5,     0,     5,
       1,     3,     1,     1,     3,     2,     0,     0,     2,     1,
       1,     3,     0,     1,     3,     1,     2,     1,     2,     3,
       3,     1,     3,     2,     1,     2,     2,     3,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     4,     2,     4,
       4,     5,     4,     3,     4,     0,     4,     4,     4,     5,
       4,     4,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     3,     3,     3,     2,     0,     4,     3,     4,
       4,     3,     3,     3,     6,     3,     3,     3,     3,     3,
       3,     3,     9,     5,     1,     1,     1,     0,     1,     0,
       1,     1,     1,     2,     0,     1,     1,     0,     0,     1,
       1,     1,     3,     3,     0,     4,     4,     1,     0,     1,
       0,     2,     2,     1,     1,     0,     0,     1,     1,     3,
       3,     0,     2,     0,     4,     0,     2,     1,     0,     0,
       1,     4,     2,     0,     1,     1,     2,     0,     1,     9,
       0,     0,     1,     1,     0,     1,     7,     1,     1,     0,
       2,     1,     3,     1,     1,     3,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     0,     3,     1,     0,     4,     1,
       1,     3,     3,     1,     1,     3,     1,     0,     1,     0,
       1,     3,     3,     2,     0,     1,     1,     1,     2,     2,
       2,     5,     0,     1,     1,     1,     2,     4,     0,     1,
       0,     1,     1,     1,     1,     0,     2,     2,     0,     3,
       0,     3,     0,     4,     1,     1,     1,     2,     0,     1,
       0,     2,     0,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     1,     0,     1,     6,     2,     0,     1,
       0,     1,     0,     3,     1,     2,     3,     7,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     4,     3,     1,     0,     1,     1,     1,     2,
       3,     1,     1,     1,     3,     1,     3,     1,     1,     2,
       1,     1,     3,     2,     0,     2,     2,     4,     0,     2,
       1,     2,     1,     5,     0,     1,     1,     2,     4,     1,
       1,     1,     1,     3,     3,     3,     3,     2,     1,     4,
       6,     0,     3,     0,     4,     0,     0,     1,     1,     3,
       4,     1,     1,     1,     1,     3,     2,     2,     2,     2,
       1,     1,     2,     0,     1,     0,     1,     1,     3,     1,
       3,     2,     2,     1,     3,     3,     0,     0,     1,     0,
       1,     0,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     0,     1,     0,     3,     1,     1,     0,     2,     4,
       0,     0,     1,     0,     2,     1,     3,     0,     1,     1,
       1,     2,     2,     0,     1,     3,     2,     3,     2,     2,
       1,     0,     2,     2,     0,     3,     1,     0,     3,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     2,     5,     5,     3,     5,     7,     5,     4,
       6,     4,     5,     4,     0,     1,     1,     0,     1,     0,
       1,     0,     1,     3,     0,     0,     2,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     5,     1,     0,     1,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     8,     0,     1,     1,     1,
       1,     1,     0,     1,     0,     2,     5,     3,     1,     0,
       2,     3,     0,     1,     0,     1,     1,     1,     3,     2,
       0,     2,     2,     0,     0,     5,     1,     1,     1,     3,
       2,     0,     2,     0,     2,     0,     1,     1,     2,     2,
       3,     1,     5,     0,     1,     1,     2,     2,     5,     2,
       1,     1,     0,     3,     1,     0,     2,     1,     1,     4,
       1,     1,     4,     0,     1,     0,     1,     1,     1,     3,
       0,     4,     2,     1,     0,     4,     0,     2,     1,     2,
       1,     1,     3,     3,     3,     3,     7,     2,     1,     0,
       1,     1,     1,     1,     6,     0,     1,     1,     2,     1,
       0,     3,     3,     3,     2,     4,     6,     1,     3,     2,
       1,     1,     1,     1,     1,     1,     3,     2,     0,     1,
       1,     1,     7,     0,     0,     1,     0,     4,     7,     0,
       2,     2,     1,     3,     1,     3,     2,     1,     3,     7,
       6,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     0,     3,     0,     1,     0,     2,     2,     3,
       0,     1,     0,     2,     1,     2,     5,     2,     0,     4,
       0,     4,     0,     1,     1,     0,     2,     2,     2,     2,
       2,     4,     5,     0,     1,     1,     2,     1,     2,     0,
       2,     3,     2,     3,     3,     5,     1,     0,     1,     1,
       1,     0,     2,     1,     3,     1,     1,     3,     1,     1,
       1,     1,     3,     1,     0,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,    42,     0,     0,   117,     0,    54,     0,
       0,     0,   281,     0,     0,     0,    40,    58,     0,     0,
       0,     0,   685,   572,   707,     0,   702,     0,    39,   710,
      14,     0,   711,     0,   189,     0,   289,   709,     0,   756,
     773,     0,     0,     0,     0,     0,     0,   743,   708,     0,
      37,   612,     0,     0,     0,    37,     0,     0,   329,     0,
       0,     0,     0,     0,     0,   280,     0,     0,     0,     0,
       0,     0,     0,    37,     0,     0,     0,     2,   625,    16,
      18,    37,    19,    21,    11,     0,    22,    17,     0,    10,
      20,    23,     5,     0,     0,     6,     0,     7,     0,    45,
       8,     0,     0,   334,   625,     0,   636,   610,   630,   611,
     627,     0,     0,   712,   705,   628,   614,   774,   774,    15,
       0,     0,   158,   457,   118,    38,     0,     0,     0,     0,
       0,   457,     0,     0,     0,    53,   732,   573,   569,     0,
     568,     0,    62,   625,    68,   732,   457,     0,     0,     0,
     145,   127,     0,     0,    56,   745,   744,     0,    55,    36,
     615,   457,     0,     0,    26,     0,   457,     0,   167,   138,
      59,     0,    96,   282,   278,     0,     0,     0,   299,   297,
     328,   322,   305,   327,   300,   298,   326,   301,   316,   325,
     307,   290,   323,   314,   296,   308,   312,   319,   306,   303,
     311,   292,   302,   293,   321,   313,   295,   317,   294,   318,
     324,   304,   315,   310,   320,   309,   291,    95,     0,    75,
       0,    28,     0,     0,     1,     3,   626,     4,    24,     0,
     506,     0,    47,     0,    66,    65,    12,    64,     0,   706,
     280,     0,     0,   331,   341,   354,    60,     0,   337,   338,
       0,   336,   345,   348,   351,     0,     9,   609,   689,   683,
     684,   712,     0,     0,   704,   703,   701,     0,   714,   655,
     775,   760,   776,   761,   759,     0,     0,   675,     0,    41,
      43,   159,   458,     0,     0,   119,   242,   243,   105,   265,
     264,   101,    90,   117,     0,    89,   254,   437,   436,    73,
     255,     0,    85,   507,   733,   734,   110,     0,     0,   577,
     580,   583,   576,     0,   121,   122,    94,   333,     0,   108,
       0,     0,   270,   272,   103,   111,   256,   258,     0,   146,
     128,   102,   187,   188,    83,   747,     0,   749,    25,   613,
     248,     0,   245,   244,   250,     0,   232,   219,    88,     0,
     107,   170,   137,   445,   446,   139,    98,   453,   210,   209,
     213,   216,    87,   204,   203,   206,     0,   214,     0,     0,
       0,   279,   277,   267,   266,     0,   109,   106,    86,   224,
     260,   115,   116,   114,    93,     0,   124,    92,   657,   656,
      46,     0,    51,    44,     0,    48,   199,   198,   197,   194,
     195,   196,   201,   200,    84,   190,   193,   282,   330,    57,
       0,   353,   350,   364,   339,     0,   343,   347,     0,     0,
     358,    61,   349,    13,   648,     0,     0,   641,     0,     0,
       0,   457,   649,   638,   637,   640,     0,     0,     0,   572,
     633,   629,   634,   728,   698,   724,   730,     0,   715,   572,
     660,     0,   757,   754,   680,   677,   678,     0,   165,   151,
      81,     0,   164,   160,   457,    63,   120,    91,    69,    70,
     524,   527,   525,   526,   523,   268,   268,   508,   570,   593,
       0,     0,   579,     0,   567,   123,    67,    77,   271,   259,
      74,   257,   151,    80,   147,   148,   134,   140,   129,   131,
     130,   748,     0,     0,   746,   623,   623,   616,   617,   618,
     457,   100,   247,     0,    99,     0,    72,    36,    30,    32,
     234,   233,     0,   230,   229,   220,   228,   457,    82,   168,
     447,     0,   202,   218,   207,     0,     0,    97,     0,   625,
     284,   273,     0,   226,   225,   227,   223,    76,   262,    36,
      33,     0,   126,   125,    78,     0,     0,    49,     0,     0,
       0,   355,   560,     0,   364,   360,   385,   365,   366,   362,
     364,   342,     0,   340,   346,   352,     0,     0,   356,   647,
     554,   544,   546,   550,   547,   548,   549,   551,   552,   545,
     639,     0,     0,     0,     0,     0,     0,   280,   697,     0,
       0,     0,     0,   632,     0,   727,   725,     0,   732,   713,
       0,     0,     0,   681,   769,   771,   762,   763,   766,     0,
     765,   770,   758,     0,   676,   679,    71,     0,   166,   163,
     162,     0,   269,   221,   222,   571,   593,   441,   566,     0,
     593,   597,     0,   601,   582,   581,   578,     0,   153,     0,
       0,   144,   143,    79,     0,     0,   742,   750,   624,   403,
     457,     0,   246,   252,    27,     0,     0,   235,   238,   113,
     684,   454,   451,   205,     0,   212,   215,   211,   283,     0,
     285,   274,   263,   261,    29,     0,    35,    50,    52,   192,
     191,   625,   369,   370,   371,     0,   361,   385,   477,   441,
     378,   367,   364,   344,   359,   358,     0,   644,   642,   643,
     645,   456,   278,     0,     0,   631,   716,   335,     0,     0,
     735,   716,     0,     0,     0,     0,     0,     0,   658,   667,
       0,     0,     0,     0,   755,   152,     0,   457,   593,   442,
     603,     0,     0,   594,   605,   598,   599,   584,     0,   150,
     149,     0,   141,   142,   133,   132,   752,     0,   751,     0,
     404,     0,   249,   457,   251,    31,   232,   236,   240,   239,
       0,   172,   452,   448,   136,   450,   208,   276,   286,   275,
     104,    34,     0,     0,     0,     0,     0,   372,     0,   386,
     405,   460,   471,     0,   459,   474,   377,   561,   562,   357,
     553,   712,     0,   686,     0,   700,     0,     0,     0,     0,
       0,   722,     0,   659,     0,     0,   664,     0,   669,     0,
       0,     0,   670,   673,   674,   671,   672,   772,   764,   767,
     770,   161,     0,     0,   604,   600,   587,   591,     0,   586,
     588,   607,   606,     0,   155,   157,   135,   753,   621,   619,
     620,   622,     0,   231,   241,   511,   173,   174,     0,   287,
       0,     0,     0,   368,     0,   385,   432,   434,     0,   457,
     433,   403,     0,     0,     0,   416,   435,     0,   387,   388,
     392,   394,   393,   455,   391,     0,   443,   440,   413,   439,
     574,   457,   419,   419,     0,   406,   407,   409,   461,     0,
       0,     0,   536,   464,   419,   462,   470,   537,   484,   489,
     486,   485,   480,   481,     0,     0,   487,   488,   483,   490,
     476,   473,   477,   471,   479,   504,   563,     0,     0,   457,
       0,   688,   280,   682,     0,   720,   717,   635,   729,   731,
     728,   736,   726,     0,   699,   654,     0,     0,   661,   662,
     663,   668,   457,   564,     0,   590,     0,     0,   585,     0,
       0,   457,   531,   533,   528,   237,   512,   529,   530,     0,
     175,   171,   453,   374,   375,   376,   373,   379,   543,     0,
     401,   400,   396,     0,   397,   398,   399,     0,   381,     0,
     411,     0,   438,   575,   412,     0,   421,   420,   421,   363,
       0,   472,   466,   468,   511,   469,   421,   538,   511,     0,
     539,   540,   482,     0,     0,   478,   514,   511,   505,   492,
     240,     0,   509,   556,   653,   651,   652,   650,   716,     0,
     691,   694,   690,   692,   282,   720,   721,   718,   728,   730,
     737,   723,   665,     0,   112,     0,   602,   592,     0,   589,
     156,   154,   253,   532,   534,   177,   178,   179,     0,   449,
     395,   402,   429,   428,   431,   430,   427,   417,   423,   425,
     426,     0,   383,   389,     0,   410,     0,   414,   415,   408,
     467,   465,   542,   419,   541,   491,   475,   495,     0,     0,
       0,   504,   511,   518,   521,     0,   519,   520,   517,   515,
     514,   504,   510,   559,   557,   558,   564,   646,   696,   457,
       0,     0,   719,     0,   730,   739,   738,     0,   565,   608,
       0,     0,   183,   181,     0,     0,   418,   390,     0,   380,
     444,     0,   421,   511,   504,     0,   499,     0,   504,     0,
     513,   503,     0,   501,     0,   695,   693,   687,   728,   740,
     666,     0,   180,     0,     0,   424,   382,   386,   422,   535,
     493,   494,   504,   498,     0,   496,   522,   516,   502,   555,
     730,   179,   182,   169,   184,   186,     0,   500,   504,   741,
       0,     0,   384,   497,   176,   185
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    76,    77,    78,    79,   345,   385,   517,   518,   549,
     550,   338,   159,    80,    81,    82,    83,   121,   279,    84,
      85,   231,   232,   390,    86,    87,    88,    89,    90,    91,
     245,   420,   277,   283,    92,   236,    93,   380,   368,   384,
     125,   467,   316,   554,   330,   497,   498,   499,   650,   500,
     356,   653,   329,   493,   494,   495,   628,   749,   960,   844,
     281,   460,   461,   462,   463,   351,   528,   529,  1058,   770,
     857,   971,  1057,  1120,  1124,  1173,  1174,   334,    94,   404,
     405,   406,   362,   363,   531,   364,   674,   365,   366,   367,
     532,   526,   302,   378,   546,   348,   523,   666,   667,   768,
     855,   288,   342,   514,   340,   511,   516,   764,   299,   327,
     490,   547,   683,   291,   375,   633,   324,   542,   780,    95,
     173,   372,   174,   370,   539,    97,    98,   217,  1018,   100,
     101,   102,   247,   248,   249,   250,   573,   415,   251,   418,
     252,   413,   253,   254,   411,   422,   578,   564,   565,   566,
     567,   568,   695,   786,   787,   698,   699,  1072,  1129,   700,
     877,   878,   879,   982,   759,   894,   895,   896,   987,  1127,
     996,  1077,  1067,  1068,  1069,  1070,   880,   997,   897,   740,
     992,   357,   672,   773,   858,   774,   530,   882,   883,   284,
     790,   791,   792,   793,  1001,   898,   794,   921,   922,   795,
     923,   924,  1019,   925,   476,  1101,   965,  1020,  1021,  1140,
    1099,   475,   966,   967,   968,   906,   907,  1009,  1010,  1011,
     884,   613,   591,   569,  1106,   570,   798,   927,  1046,   103,
     138,   139,   308,   140,   994,   311,   312,   482,   484,   843,
     838,   839,   840,   955,   637,   638,   639,   640,   641,   642,
     643,   835,   743,   744,   104,   160,   339,   507,   508,   849,
     509,   659,   227,   105,   106,   262,   441,   442,   603,   257,
     434,   435,   597,  1028,   598,   450,   391,   611,   812,   612,
     728,   827,   729,   624,   455,   730,   107,   437,   108,   933,
     109,   436,   931,  1032,  1030,  1031,   599,   110,   111,   112,
     266,   113,   114,   268,   449,   805,   936,  1037,   944,   444,
     445,   446,   605,   608,   306,   810,   941,  1040,  1115,   115,
     157,   336,   337,   504,   656,   116,   117,   623,   273,   452,
     616,   617,   618,   619,   620,   621,   118,   274
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -964
static const yytype_int16 yypact[] =
{
    1294,    10,    82,  -964,   226,   239,   144,   274,  -964,   366,
     435,   461,  -964,   506,   546,   560,  -964,  -964,   564,   568,
     250,   570,  -964,   320,  -964,   571,  -964,   385,  -964,  -964,
    -964,   572,  -964,   583,  -964,   588,  -964,  -964,   589,   592,
    -964,   594,   595,   596,   597,   598,   250,    11,  -964,   250,
    -964,  -964,   599,   600,   601,  -964,   603,   604,  -964,   605,
     611,   614,   250,   617,   620,   463,   623,   624,   625,  1454,
     626,   628,   629,  -964,   630,   631,  1112,  -964,   381,  -964,
    -964,  -964,  -964,  -964,  -964,    97,  -964,  -964,     7,  -964,
    -964,  -964,  -964,     7,   632,  -964,   627,  -964,   544,   -34,
    -964,   585,   187,  -964,   381,   602,  -964,  -964,   253,  -964,
    -964,   654,    85,   607,  -964,  -964,  -964,   423,    36,  -964,
     332,   250,  -964,   651,  -964,  -964,   661,   335,    91,   639,
     385,   651,   640,    35,   399,   573,   451,  -964,   514,   115,
    -964,   489,  -964,   381,   334,   451,   651,   107,   250,   479,
    -964,  -964,   567,    40,   573,  -964,  -964,   385,   573,  -964,
    -964,   651,   332,   332,  -964,   321,   651,   250,  -964,   424,
     573,   237,  -964,   619,   646,    13,   528,   525,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,   335,  -964,
      18,  -964,   385,   335,  -964,  -964,  -964,  -964,  -964,   208,
    -964,   608,   586,   208,  -964,  -964,  -964,  -964,   441,  -964,
     463,   548,   169,  -964,  -964,   677,  -964,   686,   644,  -964,
     385,   702,  -964,    57,  -964,   621,  -964,   280,  -964,  -964,
     636,   607,   701,   332,  -964,   702,  -964,   385,   634,  -964,
    -964,  -964,  -964,   530,  -964,   250,   618,   687,   695,  -964,
     573,    58,  -964,   699,   385,   655,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,   144,   332,  -964,  -964,  -964,  -964,  -964,
    -964,    72,  -964,    72,  -964,   573,  -964,   385,   703,  -964,
     431,   700,  -964,   385,  -964,  -964,  -964,  -964,   385,  -964,
     332,   616,  -964,  -964,  -964,   573,  -964,   633,   385,   385,
     481,  -964,  -964,  -964,  -964,   385,   707,   562,  -964,    73,
     709,   332,   710,  -964,   712,   385,   507,    77,  -964,   713,
     573,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,   330,   622,  -964,   178,  -964,   424,   385,
     250,  -964,  -964,  -964,  -964,   550,  -964,  -964,  -964,   162,
     385,  -964,  -964,  -964,  -964,   385,   174,  -964,  -964,  -964,
    -964,   332,   593,  -964,   208,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,   503,  -964,  -964,   619,  -964,  -964,
     385,  -964,  -964,   497,  -964,   447,   702,  -964,   385,   385,
     421,  -964,  -964,  -964,  -964,   250,   466,  -964,   704,   217,
     706,   651,  -964,  -964,  -964,  -964,   666,   666,   732,   320,
    -964,  -964,  -964,   672,   332,  -964,   685,   635,  -964,   320,
    -964,   466,   705,   573,  -964,  -964,   618,   332,  -964,   723,
     733,   748,  -964,  -964,   651,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,   569,   569,  -964,   385,    94,
     385,   385,  -964,   385,   637,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,   723,  -964,   736,  -964,  -964,   521,   737,  -964,
    -964,  -964,   332,   385,  -964,   718,   718,  -964,  -964,  -964,
     651,  -964,  -964,   332,  -964,   332,  -964,   702,  -964,   739,
    -964,  -964,   586,  -964,  -964,  -964,  -964,   651,   355,  -964,
     734,   237,  -964,  -964,  -964,   478,   385,  -964,   638,   381,
     -34,  -964,   385,  -964,  -964,  -964,  -964,  -964,   584,   702,
    -964,    57,  -964,  -964,  -964,   745,   332,  -964,   441,   441,
     250,  -964,  -964,   370,   404,  -964,   708,   688,  -964,  -964,
     497,  -964,   385,  -964,  -964,  -964,   385,   385,  -964,   573,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,   735,   250,   385,   385,   385,   332,   463,  -964,   609,
     613,   641,   115,   740,   742,  -964,  -964,   141,   451,  -964,
     115,   755,   392,  -964,   735,   747,   759,  -964,  -964,   725,
    -964,   741,  -964,   250,  -964,  -964,  -964,   385,  -964,   668,
    -964,   760,  -964,  -964,  -964,  -964,   721,   424,  -964,    78,
      99,  -964,   648,  -964,  -964,  -964,  -964,   670,   711,   385,
     481,   719,   722,  -964,   481,   650,   332,   385,  -964,   141,
     651,   332,  -964,   772,  -964,   385,   -26,  -964,    72,  -964,
     636,  -964,   227,   622,   237,  -964,  -964,  -964,  -964,   714,
     -34,   642,  -964,  -964,  -964,   385,  -964,  -964,  -964,  -964,
    -964,   303,  -964,  -964,  -964,    20,  -964,   767,   207,   424,
    -964,  -964,   393,   702,  -964,   774,   385,   573,  -964,  -964,
    -964,  -964,   646,   666,   666,  -964,   282,   508,   385,   332,
     643,   282,   392,   720,   724,   392,   392,   332,    65,  -964,
     768,   456,   466,   466,   573,  -964,   385,   651,   369,  -964,
     730,   468,   304,    78,  -964,  -964,  -964,  -964,   250,  -964,
    -964,    53,  -964,  -964,  -964,  -964,  -964,   662,  -964,   260,
    -964,   332,  -964,   651,  -964,  -964,   541,  -964,   647,  -964,
     795,  -964,  -964,  -964,  -964,  -964,  -964,  -964,   573,  -964,
    -964,  -964,   717,   770,   773,   775,   362,  -964,   684,   175,
     341,  -964,  -964,   223,  -964,   301,  -964,  -964,   698,  -964,
    -964,   607,    21,   645,    67,  -964,   780,   689,   692,   332,
     678,   816,   690,    65,   392,   392,  -964,    46,  -964,   392,
     392,   456,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,   802,   385,  -964,  -964,  -964,   799,   715,   807,
    -964,  -964,  -964,   115,   810,   573,  -964,  -964,  -964,  -964,
    -964,  -964,   812,  -964,  -964,   235,  -964,   158,   493,  -964,
     817,   385,   335,  -964,    20,  -964,  -964,  -964,   466,   651,
    -964,   219,   250,   332,   385,  -964,  -964,   716,   693,  -964,
    -964,  -964,  -964,  -964,  -964,   385,   652,  -964,  -964,  -964,
     727,   651,    25,    25,   696,   818,  -964,  -964,   223,   466,
     152,   250,  -964,  -964,    25,  -964,  -964,   291,  -964,  -964,
    -964,  -964,  -964,  -964,   776,   586,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,   587,  -964,   385,   286,   651,
     666,  -964,   463,  -964,   332,   794,  -964,  -964,  -964,  -964,
     485,  -964,  -964,   385,  -964,  -964,    88,    90,  -964,   758,
    -964,  -964,   651,   824,   385,  -964,   250,   385,   700,   250,
     726,   651,  -964,  -964,  -964,  -964,  -964,   819,   743,   293,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,   385,
     360,   394,  -964,   332,   573,  -964,  -964,    62,   820,   175,
    -964,   728,  -964,  -964,  -964,   332,   682,  -964,   682,  -964,
     341,  -964,  -964,  -964,   235,   573,   682,  -964,   235,   729,
     586,  -964,  -964,   738,   610,   223,   296,   196,   573,  -964,
     647,    52,    41,   347,  -964,  -964,  -964,   573,   800,   332,
     830,  -964,   691,  -964,   619,   794,  -964,  -964,    19,   685,
    -964,  -964,  -964,   392,  -964,   424,  -964,  -964,   310,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,   141,   131,   734,
    -964,  -964,  -964,  -964,  -964,  -964,   573,    37,  -964,  -964,
    -964,   822,  -964,  -964,   746,  -964,   674,  -964,  -964,  -964,
    -964,  -964,  -964,    25,  -964,  -964,  -964,  -964,   750,   751,
     235,   250,   242,  -964,  -964,   250,  -964,  -964,  -964,  -964,
     586,   250,  -964,  -964,  -964,  -964,   824,  -964,  -964,   651,
     666,   250,  -964,   332,   685,  -964,  -964,    93,  -964,  -964,
     694,   332,  -964,  -964,    32,    62,  -964,  -964,   826,   798,
    -964,   385,   682,   235,   250,   752,  -964,   296,   250,   473,
      52,  -964,   753,  -964,   731,  -964,  -964,   573,   672,  -964,
    -964,   293,  -964,   385,   332,  -964,  -964,   175,  -964,  -964,
    -964,  -964,   250,  -964,   754,  -964,  -964,  -964,  -964,  -964,
     685,   141,  -964,   843,  -964,  -964,   744,  -964,   250,  -964,
     756,   332,  -964,  -964,  -964,  -964
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -964,  -964,   793,  -964,  -964,  -964,  -964,  -964,   205,  -964,
     186,  -239,   439,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -188,  -964,  -964,  -964,  -964,  -964,  -964,
    -131,  -305,   -27,  -160,  -964,   779,  -964,  -964,  -964,  -964,
     582,  -964,  -964,  -964,  -964,  -964,   229,   228,  -964,  -167,
    -964,  -964,  -964,  -964,  -964,   232,   391,  -964,  -964,   -82,
    -964,  -964,   262,    38,  -713,  -964,  -964,   365,  -964,  -964,
    -964,  -964,  -257,  -272,  -964,  -964,  -285,  -964,  -964,  -964,
      66,  -964,  -964,  -964,  -964,   371,  -964,   230,  -964,   368,
    -964,  -964,  -964,  -964,  -964,  -964,   135,  -964,   240,  -964,
    -115,  -210,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,   432,  -964,  -964,  -964,  -964,
    -236,   195,    14,  -398,  -964,  -964,  -964,  -964,    12,   192,
    -964,  -964,  -964,  -964,   663,  -964,  -964,  -964,   -87,  -117,
     492,  -964,  -316,   495,  -964,  -342,   210,   342,  -514,  -964,
    -964,   350,  -964,  -964,    54,  -964,  -964,  -964,  -964,  -653,
    -238,  -964,   -69,  -964,    50,  -964,  -964,   -77,  -964,  -964,
    -853,  -919,  -964,  -203,  -964,  -964,  -964,  -132,  -964,   225,
    -964,    68,  -964,  -964,  -964,  -964,   -47,  -964,   671,  -126,
    -964,  -964,  -964,  -964,   136,    16,  -964,  -964,  -964,    15,
    -964,    26,  -660,   -78,  -964,  -964,  -949,  -875,  -964,  -964,
    -207,  -275,  -888,  -964,  -964,  -964,  -964,  -964,  -964,   -76,
    -964,  -409,  -420,  -964,  -964,  -443,   197,  -964,  -170,  -964,
    -964,  -964,  -964,   -37,  -964,  -568,   459,  -964,  -964,  -964,
    -964,  -964,   -14,  -964,  -964,  -964,  -964,   308,  -574,  -964,
    -964,  -964,  -964,   202,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,   440,   -89,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -107,  -964,  -426,  -964,  -964,  -964,
    -645,   126,   -98,  -964,   494,  -418,  -964,  -964,  -241,  -964,
    -964,  -964,  -964,  -964,  -964,  -161,  -689,  -964,  -964,  -964,
    -964,  -964,  -964,  -245,  -964,  -694,  -964,   -86,  -964,  -964,
     509,  -964,  -901,  -963,  -124,  -964,  -964,  -964,  -964,  -964,
    -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,  -964,
    -964,   222,  -964,  -964,   218,   224,  -964,   837
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -769
static const yytype_int16 yytable[] =
{
     143,   300,   355,   594,   407,   294,   349,   233,   379,   560,
     272,   272,    99,   387,    96,   255,   439,   590,   318,   438,
     320,   319,   278,   831,   802,   265,   335,   811,   477,   519,
     501,   614,   135,   615,   716,   341,   636,  1022,   548,  1039,
     998,   929,   721,   783,   789,   395,   155,   296,   373,   332,
     696,  1006,  -514,   819,   317,  1080,   303,  1153,   154,  1082,
     297,   158,  1125,  1093,   343,   344,   745,  -163,  1091,   551,
     297,   328,   819,  -514,   170,   246,  1116,   813,   654,  1078,
     816,   817,   419,   470,  1094,   246,   241,  1081,    99,   381,
      96,   382,   230,  1062,   264,   819,  1063,   819,   934,   604,
     819,   276,   234,   293,   471,   119,   229,   301,  -514,   289,
     766,   242,   310,   524,  -514,  1043,   269,   321,  -514,  1095,
    1064,  1100,   784,    58,   309,  1096,   505,   120,  1089,  1097,
     246,   392,   270,   280,   290,   392,   820,  1114,   347,  1113,
    1122,  1088,   354,  1138,   361,   472,   741,  1102,   305,   473,
     525,  1149,   235,   533,   394,   820,  1126,   305,   142,   142,
     325,   562,  -595,   416,   745,   443,   562,  -596,   142,   946,
     947,   543,   388,   635,   949,   950,   478,   458,   820,   350,
     820,   719,   948,   820,  1160,   322,   142,  -514,   696,   846,
     156,   930,   374,   636,   333,   386,   469,   636,  1098,  1154,
    1065,   537,  1135,   866,   298,   383,   557,  1179,   867,   686,
     297,   785,   977,  1159,   298,   230,   142,   506,   474,    58,
     868,   323,   487,   246,  1042,  1142,   421,   962,   869,  1150,
    1132,   870,   142,   760,   704,    58,   871,   872,   969,   388,
     447,  1033,   276,   512,   873,   552,   775,  1170,   388,  1164,
     980,  -595,  -463,   124,   459,   244,  -596,   465,   388,   544,
     545,   389,   593,   358,   409,  -463,   962,   359,   899,  -463,
     230,   122,   705,   962,   848,   958,  1090,   458,   664,   561,
     246,   900,   258,   431,   123,   901,   485,   453,   142,   241,
    -463,   486,   553,   555,   276,   636,   392,   142,   535,   772,
    1003,   491,   492,   354,   631,   596,   902,   483,   421,   142,
     684,  1055,   614,   614,   615,   615,   963,   908,   246,   126,
     424,   425,  1137,   909,   874,   426,   536,   962,   389,   360,
     600,   259,  -463,   260,  1107,   804,   142,   389,   142,   981,
     427,   354,   538,   142,   910,  1123,   443,   389,   903,   519,
     428,   885,   758,   421,   298,   963,  1024,   911,   246,   626,
     886,   142,   963,   875,   876,   282,   276,   669,   429,   551,
     261,  -170,   657,  -463,  1025,   912,   913,   914,   887,  1056,
     430,   915,   540,   246,   661,   888,  1026,   889,   431,   904,
    1007,   246,   246,   769,  -657,   723,   724,   142,  1117,   725,
     665,   286,   602,   287,   655,   580,   286,    58,   287,   230,
     432,   127,   610,   916,   230,   662,   963,   663,  1103,   230,
    1104,  1146,   142,   241,   241,  -217,   276,   917,  -656,   771,
     241,  1136,   685,   142,  -170,  -457,   562,   579,   918,   137,
    1172,  1143,   480,    58,   668,   760,   576,  1105,   226,   841,
     679,   421,   577,   644,   645,  1119,   310,   890,   688,   978,
     562,  -657,   481,   581,   582,   583,   584,   585,   586,   587,
     739,   562,   726,   588,  1161,  -217,   246,   563,  1165,   580,
     128,   919,   396,   346,   720,   703,   142,   755,   563,   920,
    1002,   891,   892,   142,   164,  -656,   352,   797,   711,  -332,
     142,   863,  1177,   269,   361,   893,   129,   864,   361,   677,
     589,   692,   221,    12,   558,   681,   353,   230,  1183,   270,
     228,   797,   693,   397,   421,   142,   226,   822,   559,   823,
     398,   824,   739,   825,   761,   399,   313,   581,   582,   583,
     584,   585,   586,   587,   400,   246,   271,   588,   401,   421,
     421,   130,   680,   352,   402,   694,   928,  1038,   757,   727,
     314,   496,   315,   762,   562,   604,   708,   709,   710,   142,
     675,   403,   691,   353,   826,   310,   571,   832,   520,   142,
     521,   563,   142,   310,   589,   353,   836,   522,   668,   326,
      23,   131,   572,   241,   142,   651,   652,   230,  -514,    27,
     735,  1166,   782,   852,   707,   132,   304,   803,    58,   133,
     354,   712,   520,   134,   521,   136,   141,   144,   962,  -514,
     305,   808,   492,   354,   689,   690,   908,   354,   145,   818,
     421,  1121,   909,   146,   147,   734,  1111,   148,   246,   149,
     150,   151,   152,   153,   161,   162,   163,   361,   165,   166,
     167,   742,   975,   910,  -514,   240,   168,   881,   246,   169,
    -514,   850,   171,   851,  -514,   172,   911,  1016,   175,   176,
     177,   218,   354,   219,   220,   222,   223,   238,   263,   800,
     243,   239,   282,   285,   912,   913,   914,   267,   142,   292,
     915,   807,   778,   241,   295,   307,  1034,   256,   331,   369,
     371,   376,   377,   393,   230,   408,   935,   963,   410,   459,
     412,   940,   244,   417,   837,    22,   423,   440,   451,   454,
     457,   456,   916,   448,   464,   483,   466,   479,   230,  1086,
     488,   502,   503,  -514,   510,   513,   917,   515,   527,   489,
     541,   556,   534,   979,    58,  1121,   269,   918,   601,   592,
    1017,   595,   604,   607,   627,   742,   622,   630,   629,   632,
     845,   649,   654,   658,   419,   995,   687,   682,   671,   706,
     733,   609,   563,   718,   678,   985,   697,   715,   717,   713,
     722,   731,   647,   714,   732,   737,  -768,   458,   562,   747,
     919,   748,  1044,   746,   752,   756,   753,   763,   788,   576,
     814,  1052,   821,  1029,   815,   834,   953,   847,   809,   777,
     854,   856,   859,   865,   779,   860,   310,   926,   861,   937,
     862,   939,  1004,   942,   943,   938,   945,   952,   964,  1008,
     954,   354,   957,   932,   974,   959,  1035,   961,   989,   973,
     991,   999,  1036,  1000,   956,   988,   993,   986,   820,  1045,
    1053,  1012,  1076,   804,  1071,  1109,  1128,   881,   990,  1131,
    1156,  1110,  1051,  1054,  1151,  1130,  1157,  1083,  1181,   225,
     765,   781,   237,  1182,  1085,   468,  1169,  1050,  1118,   751,
    1074,   750,   754,   648,   984,  1061,  1133,  1134,  1162,  1168,
    1178,   736,  1184,   670,  1171,   970,  1185,  1075,   964,  1180,
    1023,   853,   673,   676,   776,  1092,   767,   801,   634,   806,
     574,   414,   702,  1005,   575,   799,  1041,   701,   976,  1176,
    1073,   983,  1155,  1079,   796,  1059,   972,  1047,   433,   905,
     837,  1108,  1008,  1167,  1084,   833,  1144,  1014,  1087,  1015,
    1027,  1013,   646,  1049,   738,   842,   660,   951,  1145,  1112,
     625,   829,  1060,   606,   828,   275,     0,   830,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1048,     0,
       0,   845,     0,     0,     0,     0,     0,   964,     0,     0,
       0,   964,     0,  1029,     0,     0,     0,     0,     0,   964,
     964,     0,     0,     0,     0,     0,     0,     0,     0,  1066,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1148,     0,     0,   354,     0,
       0,     0,  1141,  1152,     0,   881,     0,     0,     0,     0,
       0,   459,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1175,     0,     0,  1163,
       0,     0,     0,   964,     0,   964,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1158,     0,   964,  1139,     0,     0,
     964,     0,   224,     1,     0,     0,     0,     2,     3,     0,
       0,     0,     0,  1147,     0,     0,   459,     4,  -684,     5,
       6,     0,     0,     0,     0,     7,     0,  1066,     0,     8,
       9,  -684,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,    11,    12,     0,    13,    14,  -280,    15,     0,    16,
       0,    17,     0,     0,     0,    18,    19,    20,    21,     0,
    -335,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -684,    22,  -684,     0,    23,    24,     0,    25,     0,    26,
       0,     0,     0,    27,     0,    28,    29,    30,     0,     0,
       0,     0,     0,  -335,    31,    32,    33,    34,     0,     0,
      35,     0,     0,  -288,    36,    37,     0,    38,     0,  -684,
       0,     0,     0,    39,    40,     0,    41,     0,    42,    43,
       0,     0,     0,     0,    44,    45,    46,    47,     0,     0,
      48,     0,    49,    50,    51,    52,    53,     0,     0,    54,
       0,     0,     0,     0,    55,    56,     0,     0,    57,    58,
      59,    60,    61,    62,     0,     0,     0,     0,     0,    63,
      64,    65,     0,    66,     0,     0,    67,     0,    68,     0,
      69,     0,    70,     0,    71,     1,    72,    73,    74,     2,
       3,     0,     0,    75,     0,     0,     0,     0,     0,     4,
    -684,     5,     6,     0,     0,     0,     0,     7,     0,     0,
       0,     8,     9,  -684,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,     0,
       0,     0,     0,    11,    12,     0,    13,    14,  -280,    15,
       0,    16,     0,    17,     0,     0,     0,    18,    19,    20,
      21,     0,  -335,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -684,    22,  -684,     0,    23,    24,     0,    25,
       0,    26,     0,     0,     0,    27,     0,    28,    29,    30,
       0,     0,     0,     0,     0,  -335,    31,    32,    33,    34,
       0,     0,    35,     0,     0,  -288,    36,    37,     0,    38,
       0,  -684,     0,     0,     0,    39,    40,     0,    41,     0,
      42,    43,     0,     0,     0,     0,    44,    45,    46,    47,
       0,     0,    48,     0,    49,    50,    51,    52,    53,     0,
       0,    54,     0,     0,     0,     0,    55,    56,     0,     0,
      57,    58,    59,    60,    61,    62,     0,     0,     0,   178,
       0,    63,    64,    65,     0,    66,     0,     0,    67,   179,
      68,     0,    69,     0,    70,     0,    71,   180,    72,    73,
      74,     0,   181,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   182,     0,     0,     0,
       0,     0,     0,   183,     0,     0,   184,   185,     0,   186,
       0,     0,     0,     0,     0,     0,     0,   187,   188,     0,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,     0,   192,   193,
       0,     0,   194,     0,     0,     0,     0,     0,     0,   195,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     196,   197,     0,     0,     0,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,     0,
       0,   202,     0,     0,     0,     0,     0,   203,     0,     0,
       0,     0,   204,   205,   206,     0,     0,     0,     0,     0,
       0,   207,   208,     0,     0,   209,     0,     0,   210,     0,
     211,     0,     0,     0,   212,     0,   213,     0,   214,     0,
     215,     0,     0,     0,     0,   216
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-964)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      27,   133,   169,   429,   240,   131,   166,    85,   218,   407,
     117,   118,     0,   223,     0,   104,   261,   426,   144,   260,
     146,   145,   120,   736,   713,   112,   157,   721,   303,   345,
     335,   451,    20,   451,   602,   161,   479,   925,   380,   940,
     893,    20,   610,    23,   697,   233,    35,    12,    35,     9,
     564,   904,    11,     7,   143,  1004,   134,    25,    46,  1008,
      35,    49,    25,    11,   162,   163,   640,     9,  1017,   385,
      35,   149,     7,    32,    62,   102,  1039,   722,    25,   998,
     725,   726,    25,    11,    32,   112,   120,  1006,    76,    71,
      76,    73,   118,    31,     9,     7,    34,     7,    31,    80,
       7,    34,    95,   130,    32,    95,     9,   134,    67,    18,
     136,    99,   139,    36,    73,    25,    80,    10,    77,    67,
      58,    80,   102,   157,     9,    73,    53,    45,  1016,    77,
     157,   229,    96,   121,    43,   233,    90,  1038,   165,   120,
       9,  1016,   169,  1092,   171,    73,    68,  1022,   136,    77,
      73,  1114,   145,   363,   232,    90,   119,   145,   101,   101,
     148,    67,    68,   250,   738,   263,    67,    68,   101,   814,
     815,     9,    31,   478,   819,   820,   307,   119,    90,   167,
      90,   607,   136,    90,  1133,    78,   101,   146,   702,   136,
     179,   170,   179,   636,   154,   222,   294,   640,   146,   167,
     138,   368,  1090,    28,   179,   187,   394,  1170,    33,   551,
      35,   191,   865,  1132,   179,   118,   101,   144,   146,   157,
      45,   114,   320,   250,   136,  1100,   253,    31,    53,   136,
    1083,    56,   101,   659,   576,   157,    61,    62,    80,    31,
     267,   930,    34,   341,    69,    71,   672,  1148,    31,  1137,
      31,   157,    45,   109,   281,    68,   157,   284,    31,    97,
      98,   120,    45,    26,    95,    58,    31,    30,    45,    62,
     118,    45,   577,    31,    14,   843,    80,   119,   517,   410,
     307,    58,    29,   108,    45,    62,   313,   275,   101,   120,
      83,   318,   118,   391,    34,   738,   394,   101,   120,    72,
     148,   328,   329,   330,   464,   431,    83,    25,   335,   101,
     549,    18,   732,   733,   732,   733,   120,    16,   345,    45,
      40,    41,    80,    22,   149,    45,   148,    31,   120,    92,
     437,    78,   125,    80,  1028,    53,   101,   120,   101,   120,
      60,   368,   369,   101,    43,  1058,   444,   120,   125,   665,
      70,    10,   657,   380,   179,   120,    70,    56,   385,   457,
      19,   101,   120,   188,   189,    31,    34,   527,    88,   685,
     117,    16,   503,   166,    88,    74,    75,    76,    37,    86,
     100,    80,   370,   410,   510,    44,   100,    46,   108,   166,
      99,   418,   419,   668,    34,     3,     4,   101,  1043,     7,
     517,    71,   439,    73,   502,    13,    71,   157,    73,   118,
     130,    45,   449,   112,   118,   513,   120,   515,    71,   118,
      73,  1110,   101,   120,   120,    95,    34,   126,    34,   670,
     120,  1091,   549,   101,    79,   101,    67,   425,   137,   119,
    1153,  1101,    11,   157,   522,   871,    25,   100,   145,   145,
     539,   478,    31,   480,   481,   145,   483,   116,   556,   868,
      67,   101,    31,    71,    72,    73,    74,    75,    76,    77,
     637,    67,    80,    81,  1134,   145,   503,    84,  1138,    13,
      45,   180,    41,   162,   608,   572,   101,   654,    84,   188,
     899,   150,   151,   101,    55,   101,    72,   128,   596,    95,
     101,   139,  1162,    80,   531,   164,    45,   145,   535,   536,
     118,   141,    73,    50,    11,   542,    92,   118,  1178,    96,
      81,   128,   152,    82,   551,   101,   145,    71,    25,    73,
      89,    75,   699,    77,   660,    94,    47,    71,    72,    73,
      74,    75,    76,    77,   103,   572,   123,    81,   107,   576,
     577,    45,   540,    72,   113,   185,   801,    72,   656,   167,
      71,    80,    73,   661,    67,    80,   593,   594,   595,   101,
      92,   130,   560,    92,   118,   602,   129,   737,    71,   101,
      73,    84,   101,   610,   118,    92,   118,    80,   666,   110,
      82,    45,   145,   120,   101,    74,    75,   118,    11,    91,
     627,   128,   691,   763,   592,    45,   155,   714,   157,    45,
     637,   597,    71,    45,    73,    45,    45,    45,    31,    32,
     608,   719,   649,   650,   558,   559,    16,   654,    45,   727,
     657,  1057,    22,    45,    45,   623,  1034,    45,   665,    45,
      45,    45,    45,    45,    45,    45,    45,   674,    45,    45,
      45,   639,   862,    43,    67,   111,    45,   789,   685,    45,
      73,   759,    45,   761,    77,    45,    56,    80,    45,    45,
      45,    45,   699,    45,    45,    45,    45,    45,    24,   706,
      95,    54,    31,    22,    74,    75,    76,    80,   101,    50,
      80,   718,   680,   120,    54,   181,   932,    95,   131,    80,
      54,   173,   177,    95,   118,   157,   804,   120,    31,   736,
      24,   809,    68,    11,   741,    79,    95,    16,   188,   101,
      25,    34,   112,    89,    25,    25,    71,    24,   118,   119,
     114,    24,   170,   146,    25,    25,   126,    25,    25,   106,
     190,   148,   120,   869,   157,  1171,    80,   137,    16,    45,
     163,    45,    80,    68,    31,   743,    51,     9,    25,   190,
     748,    25,    25,    45,    25,   891,    21,   183,    34,    34,
      45,   136,    84,    31,   136,   873,    68,   136,    38,   170,
      25,    34,   145,   170,    25,    25,    45,   119,    67,   119,
     180,    80,   952,   145,    75,   145,    74,    25,    31,    25,
      80,   961,    34,   929,    80,    75,   833,   145,   165,    95,
     163,    16,    95,   129,   172,    45,   843,   119,    45,    39,
      45,   129,   900,   145,     8,   136,   136,    25,   855,   907,
      31,   858,    25,   188,   861,    25,   934,    25,   145,    22,
     188,   145,    48,    25,   129,   129,   119,   874,    90,    25,
      31,    75,   170,    53,    34,    25,    34,   989,   885,   185,
      34,   170,   136,   120,   170,   119,    68,   138,    25,    76,
     665,   685,    93,   129,   136,   293,   145,   959,  1045,   650,
     152,   649,   654,   492,   872,   983,   136,   136,   136,   136,
     136,   629,   136,   528,  1151,   857,  1181,   995,   925,  1171,
     927,   766,   531,   535,   674,  1020,   666,   712,   476,   717,
     418,   248,   570,   901,   419,   705,   943,   567,   864,  1157,
     989,   871,  1125,  1000,   699,   972,   858,   954,   257,   793,
     957,  1029,  1010,  1140,  1010,   738,  1106,   922,  1016,   923,
     928,   915,   483,   957,   636,   743,   506,   821,  1109,  1035,
     456,   733,   979,   444,   732,   118,    -1,   733,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   956,    -1,
      -1,   959,    -1,    -1,    -1,    -1,    -1,  1004,    -1,    -1,
      -1,  1008,    -1,  1109,    -1,    -1,    -1,    -1,    -1,  1016,
    1017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1113,    -1,    -1,  1045,    -1,
      -1,    -1,  1100,  1121,    -1,  1157,    -1,    -1,    -1,    -1,
      -1,  1058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1154,    -1,    -1,  1137,
      -1,    -1,    -1,  1090,    -1,  1092,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1181,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1131,    -1,  1133,  1095,    -1,    -1,
    1137,    -1,     0,     1,    -1,    -1,    -1,     5,     6,    -1,
      -1,    -1,    -1,  1111,    -1,    -1,  1153,    15,    16,    17,
      18,    -1,    -1,    -1,    -1,    23,    -1,  1125,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      -1,    59,    -1,    -1,    -1,    63,    64,    65,    66,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    80,    -1,    82,    83,    -1,    85,    -1,    87,
      -1,    -1,    -1,    91,    -1,    93,    94,    95,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,   104,   105,    -1,    -1,
     108,    -1,    -1,   111,   112,   113,    -1,   115,    -1,   117,
      -1,    -1,    -1,   121,   122,    -1,   124,    -1,   126,   127,
      -1,    -1,    -1,    -1,   132,   133,   134,   135,    -1,    -1,
     138,    -1,   140,   141,   142,   143,   144,    -1,    -1,   147,
      -1,    -1,    -1,    -1,   152,   153,    -1,    -1,   156,   157,
     158,   159,   160,   161,    -1,    -1,    -1,    -1,    -1,   167,
     168,   169,    -1,   171,    -1,    -1,   174,    -1,   176,    -1,
     178,    -1,   180,    -1,   182,     1,   184,   185,   186,     5,
       6,    -1,    -1,   191,    -1,    -1,    -1,    -1,    -1,    15,
      16,    17,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    -1,    59,    -1,    -1,    -1,    63,    64,    65,
      66,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    80,    -1,    82,    83,    -1,    85,
      -1,    87,    -1,    -1,    -1,    91,    -1,    93,    94,    95,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,   104,   105,
      -1,    -1,   108,    -1,    -1,   111,   112,   113,    -1,   115,
      -1,   117,    -1,    -1,    -1,   121,   122,    -1,   124,    -1,
     126,   127,    -1,    -1,    -1,    -1,   132,   133,   134,   135,
      -1,    -1,   138,    -1,   140,   141,   142,   143,   144,    -1,
      -1,   147,    -1,    -1,    -1,    -1,   152,   153,    -1,    -1,
     156,   157,   158,   159,   160,   161,    -1,    -1,    -1,     5,
      -1,   167,   168,   169,    -1,   171,    -1,    -1,   174,    15,
     176,    -1,   178,    -1,   180,    -1,   182,    23,   184,   185,
     186,    -1,    28,    -1,    -1,   191,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    53,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,    -1,   104,   105,
      -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     126,   127,    -1,    -1,    -1,    -1,   132,   133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,   144,    -1,
      -1,   147,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,
      -1,    -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,   167,   168,    -1,    -1,   171,    -1,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,    -1,   182,    -1,   184,    -1,
     186,    -1,    -1,    -1,    -1,   191
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     5,     6,    15,    17,    18,    23,    27,    28,
      42,    49,    50,    52,    53,    55,    57,    59,    63,    64,
      65,    66,    79,    82,    83,    85,    87,    91,    93,    94,
      95,   102,   103,   104,   105,   108,   112,   113,   115,   121,
     122,   124,   126,   127,   132,   133,   134,   135,   138,   140,
     141,   142,   143,   144,   147,   152,   153,   156,   157,   158,
     159,   160,   161,   167,   168,   169,   171,   174,   176,   178,
     180,   182,   184,   185,   186,   191,   193,   194,   195,   196,
     205,   206,   207,   208,   211,   212,   216,   217,   218,   219,
     220,   221,   226,   228,   270,   311,   314,   317,   318,   320,
     321,   322,   323,   421,   446,   455,   456,   478,   480,   482,
     489,   490,   491,   493,   494,   511,   517,   518,   528,    95,
      45,   209,    45,    45,   109,   232,    45,    45,    45,    45,
      45,    45,    45,    45,    45,   320,    45,   119,   422,   423,
     425,    45,   101,   224,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,   320,    35,   179,   512,   320,   204,
     447,    45,    45,    45,   204,    45,    45,    45,    45,    45,
     320,    45,    45,   312,   314,    45,    45,    45,     5,    15,
      23,    28,    42,    49,    52,    53,    55,    63,    64,    66,
      85,   102,   104,   105,   108,   115,   126,   127,   132,   133,
     143,   144,   147,   153,   158,   159,   160,   167,   168,   171,
     174,   176,   180,   182,   184,   186,   191,   319,    45,    45,
      45,   204,    45,    45,     0,   194,   145,   454,   204,     9,
     118,   213,   214,   395,    95,   145,   227,   227,    45,    54,
     111,   120,   320,    95,    68,   222,   224,   324,   325,   326,
     327,   330,   332,   334,   335,   454,    95,   461,    29,    78,
      80,   117,   457,    24,     9,   330,   492,    80,   495,    80,
      96,   123,   466,   520,   529,   529,    34,   224,   474,   210,
     320,   252,    31,   225,   381,    22,    71,    73,   293,    18,
      43,   305,    50,   224,   381,    54,    12,    35,   179,   300,
     369,   224,   284,   395,   155,   320,   506,   181,   424,     9,
     224,   427,   428,    47,    71,    73,   234,   454,   381,   506,
     381,    10,    78,   114,   308,   320,   110,   301,   395,   244,
     236,   131,     9,   154,   269,   222,   513,   514,   203,   448,
     296,   381,   294,   474,   474,   197,   162,   224,   287,   225,
     320,   257,    72,    92,   224,   241,   242,   373,    26,    30,
      92,   224,   274,   275,   277,   279,   280,   281,   230,    80,
     315,    54,   313,    35,   179,   306,   173,   177,   285,   293,
     229,    71,    73,   187,   231,   198,   224,   293,    31,   120,
     215,   468,   474,    95,   395,   215,    41,    82,    89,    94,
     103,   107,   113,   130,   271,   272,   273,   312,   157,    95,
      31,   336,    24,   333,   326,   329,   330,    11,   331,    25,
     223,   224,   337,    95,    40,    41,    45,    60,    70,    88,
     100,   108,   130,   380,   462,   463,   483,   479,   480,   495,
      16,   458,   459,   474,   501,   502,   503,   224,    89,   496,
     467,   188,   521,   320,   101,   476,    34,    25,   119,   224,
     253,   254,   255,   256,    25,   224,    71,   233,   232,   474,
      11,    32,    73,    77,   146,   403,   396,   403,   222,    24,
      11,    31,   429,    25,   430,   224,   224,   474,   114,   106,
     302,   224,   224,   245,   246,   247,    80,   237,   238,   239,
     241,   223,    24,   170,   515,    53,   144,   449,   450,   452,
      25,   297,   474,    25,   295,    25,   298,   199,   200,   334,
      71,    73,    80,   288,    36,    73,   283,    25,   258,   259,
     378,   276,   282,   293,   120,   120,   148,   241,   224,   316,
     320,   190,   309,     9,    97,    98,   286,   303,   337,   201,
     202,   334,    71,   118,   235,   474,   148,   215,    11,    25,
     315,   222,    67,    84,   339,   340,   341,   342,   343,   415,
     417,   129,   145,   328,   332,   335,    25,    31,   338,   320,
      13,    71,    72,    73,    74,    75,    76,    77,    81,   118,
     413,   414,    45,    45,   468,    45,   381,   464,   466,   488,
     466,    16,   425,   460,    80,   504,   502,    68,   505,   136,
     425,   469,   471,   413,   414,   477,   522,   523,   524,   525,
     526,   527,    51,   519,   475,   476,   474,    31,   248,    25,
       9,   225,   190,   307,   307,   223,   417,   436,   437,   438,
     439,   440,   441,   442,   224,   224,   428,   145,   248,    25,
     240,    74,    75,   243,    25,   474,   516,   222,    45,   453,
     453,   381,   474,   474,   203,   331,   289,   290,   395,   225,
     259,    34,   374,   277,   278,    92,   281,   224,   136,   454,
     320,   224,   183,   304,   203,   331,   337,    21,   474,   272,
     272,   320,   141,   152,   185,   344,   340,    68,   347,   348,
     351,   343,   339,   330,   337,   223,    34,   320,   224,   224,
     224,   474,   314,   170,   170,   136,   427,    38,    31,   468,
     506,   427,    25,     3,     4,     7,    80,   167,   472,   474,
     477,    34,    25,    45,   320,   224,   254,    25,   439,   241,
     371,    68,   320,   444,   445,   440,   145,   119,    80,   249,
     247,   238,    75,    74,   239,   241,   145,   474,   223,   356,
     468,   381,   474,    25,   299,   200,   136,   290,   291,   403,
     261,   480,    72,   375,   377,   468,   279,    95,   320,   172,
     310,   202,   454,    23,   102,   191,   345,   346,    31,   351,
     382,   383,   384,   385,   388,   391,   371,   128,   418,   338,
     224,   313,   488,   466,    53,   497,   321,   224,   474,   165,
     507,   497,   470,   472,    80,    80,   472,   472,   474,     7,
      90,    34,    71,    73,    75,    77,   118,   473,   523,   526,
     527,   256,   225,   418,    75,   443,   118,   224,   432,   433,
     434,   145,   445,   431,   251,   320,   136,   145,    14,   451,
     474,   474,   225,   288,   163,   292,    16,   262,   376,    95,
      45,    45,    45,   139,   145,   129,    28,    33,    45,    53,
      56,    61,    62,    69,   149,   188,   189,   352,   353,   354,
     368,   369,   379,   380,   412,    10,    19,    37,    44,    46,
     116,   150,   151,   164,   357,   358,   359,   370,   387,    45,
      58,    62,    83,   125,   166,   386,   407,   408,    16,    22,
      43,    56,    74,    75,    76,    80,   112,   126,   137,   180,
     188,   389,   390,   392,   393,   395,   119,   419,   495,    20,
     170,   484,   188,   481,    31,   474,   498,    39,   136,   129,
     474,   508,   145,     8,   500,   136,   472,   472,   136,   472,
     472,   473,    25,   224,    31,   435,   129,    25,   427,    25,
     250,    25,    31,   120,   224,   398,   404,   405,   406,    80,
     255,   263,   373,    22,   224,   293,   346,   351,   413,   381,
      31,   120,   355,   356,   320,   474,   224,   360,   129,   145,
     224,   188,   372,   119,   426,   381,   362,   369,   362,   145,
      25,   386,   413,   148,   395,   320,   362,    99,   395,   409,
     410,   411,    75,   393,   391,   387,    80,   163,   320,   394,
     399,   400,   404,   224,    70,    88,   100,   320,   465,   381,
     486,   487,   485,   488,   312,   474,    48,   499,    72,   504,
     509,   224,   136,    25,   225,    25,   420,   224,   320,   434,
     251,   136,   225,    31,   120,    18,    86,   264,   260,   378,
     224,   474,    31,    34,    58,   138,   320,   364,   365,   366,
     367,    34,   349,   354,   152,   474,   170,   363,   363,   359,
     398,   363,   398,   138,   411,   136,   119,   395,   399,   404,
      80,   398,   292,    11,    32,    67,    73,    77,   146,   402,
      80,   397,   399,    71,    73,   100,   416,   497,   474,    25,
     170,   315,   499,   120,   504,   510,   505,   472,   241,   145,
     265,   468,     9,   256,   266,    25,   119,   361,    34,   350,
     119,   185,   362,   136,   136,   404,   394,    80,   398,   320,
     401,   395,   399,   394,   420,   487,   488,   320,   474,   505,
     136,   170,   474,    25,   167,   365,    34,    68,   224,   363,
     398,   394,   136,   395,   404,   394,   128,   402,   136,   145,
     504,   264,   256,   267,   268,   474,   352,   394,   136,   505,
     265,    25,   129,   394,   136,   268
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:
/* Line 1792 of yacc.c  */
#line 615 "src/mup/gram.y"
    {
		/* for blank lines -- nothing to do */
	}
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 621 "src/mup/gram.y"
    {
		/* to keep going after stumbling on an input error */
		Getting_tup_dur = NO;
		Good_till_canceled = NO;
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Last_grpsyl_p = (struct GRPSYL *) 0;
		Prev_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 632 "src/mup/gram.y"
    {
		/* fill in context field of the SSV struct */
		Currstruct_p->u.ssv_p->context = (short) Context;
	}
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 639 "src/mup/gram.y"
    {}
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 643 "src/mup/gram.y"
    {
		Curr_family = Score.fontfamily;
	}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 649 "src/mup/gram.y"
    {}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 653 "src/mup/gram.y"
    {}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 657 "src/mup/gram.y"
    {}
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 661 "src/mup/gram.y"
    {}
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 665 "src/mup/gram.y"
    {}
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 669 "src/mup/gram.y"
    {
		/* have lots of separate structs in music context, so
		 * mark that we have no current struct */
		Currstruct_p = (struct MAINLL *) 0;

		/* make sure at least 1 staff is visible. Not good to
		 * check when user sets visible, because it would be
		 * nice to first set everything invisible and later
		 * turn one on. So if we wait till now to check,
		 * user doesn't have to switch back and forth from
		 * score to staff to get 1 voice visible. */
		check_at_least1visible();
	}
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 684 "src/mup/gram.y"
    {
		Context = C_SCORE;
		Curr_font = svpath(0, FONT)->font;
		Curr_family = svpath(0, FONTFAMILY)->fontfamily;
		Curr_size = svpath(0, SIZE)->size;
	}
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 692 "src/mup/gram.y"
    { begin_range(PL_UNKNOWN); }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 693 "src/mup/gram.y"
    {
		/* Make sure all the staffs are in range */
		chk_ssv_ranges(C_STAFF);

		/* Set current SSV's staff to the first one on the list.
		 * If there is more than one, we will clone the SSV later.
		 * Note that it is possible that the staff number the user
		 * specified is actually illegal, but we will use it anyway,
		 * because it keeps the code simpler to pretend all is well,
		 * and ssv.c code will ignore such illegal SSVs anyway.
		 */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		Context = C_STAFF;
	}
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 712 "src/mup/gram.y"
    { begin_range(PL_UNKNOWN); }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 713 "src/mup/gram.y"
    {
		/* Make sure all the staffs and voices are in range */
		chk_ssv_ranges(C_VOICE);

		/* Set current SSV's staff/voice to the first one on the list.
		 * If there are more than, we will clone the SSV later */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		if (Svrangelist_p != 0 && Svrangelist_p->vnolist_p != 0) {
			Currstruct_p->u.ssv_p->voiceno
					= Svrangelist_p->vnolist_p->begin;
		}
		Context = C_VOICE;
	}
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 737 "src/mup/gram.y"
    {
		add_to_sv_list();
	}
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 747 "src/mup/gram.y"
    {
		add_to_sv_list();
	}
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 752 "src/mup/gram.y"
    {
		/* allocate an SSV struct */
		Currstruct_p = newMAINLLstruct(S_SSV, yylineno);
	}
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 758 "src/mup/gram.y"
    {
		/* entering new context, if we have a current struct,
		 * we were in a different context, so add its info to the list */
		end_prev_context();
	}
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 765 "src/mup/gram.y"
    {
		struct FEED *feed_p;		/* where to attach blocks */
		int calloced;			/* YES if dynamically alloced */

		end_prev_context();
		Context = (yyvsp[(1) - (2)].intval);
		calloced = NO;

		switch ((yyvsp[(1) - (2)].intval)) {
		case C_HEADER:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER, "header", &Header);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER,
					"header leftpage", &Leftheader);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER,
					"header rightpage", &Rightheader);
				break;
			}
			break;

		case C_HEAD2:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER2,
					"header2", &Header2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER2,
					"header2 leftpage", &Leftheader2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER2,
					"header2 rightpage", &Rightheader2);
				break;
			}
			break;
		case C_FOOTER:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER,
					"footer", &Footer); 
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER,
					"footer leftpage", &Leftfooter);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER,
					"footer rightpage", &Rightfooter);
				break;
			}
			break;
		case C_FOOT2:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER2,
					"footer2", &Footer2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER2,
					"footer2 leftpage", &Leftfooter2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER2,
					"footer2 rightpage", &Rightfooter2);
				break;
			}
			break;
		case C_TOP:
		case C_TOP2:
		case C_BOT:
		case C_BOT2:
		case C_BLOCK:
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			calloced = YES;
			break;
		default:
			pfatal("Unknown block-type context");
			/*NOTREACHED*/
			break;
		}
		set_win_coord(Currblock_p->c);
		/* Remember where to start attaching "print" commands */
		Next_print_link_p_p = &(Currblock_p->printdata_p);

		/* The dynamically allocated blocks
		 * (not the static head/foot blocks)
		 * need extra processing to populate
		 * the main list properly with FEEDs.
		 */
		if (calloced == YES) {
			if (Mainlltc_p == 0 || Mainlltc_p->str != S_FEED) {
				/* User had not specified a feed
				 * right before this block, so we need
				 * to add one for them implicitly.
				 * Create a new FEED and add it
				 * to the end of the main list.
				 */
				insertMAINLL(newMAINLLstruct(S_FEED, yylineno),
							Mainlltc_p);
			}
			feed_p = Mainlltc_p->u.feed_p;

			/* Normally, top/top2/bot/bot2 result in a pagefeed.
			 * But we have a special case for backward
			 * compatibility and for flexibility.
			 * User can get a separate
			 * "title" page if they really want to,
			 * by using an explicit newpage at the beginning.
			 * But in the normal case, they'd want to declare
			 * top/bot that will go on the first page without
			 * that causing a newpage. So if there hasn't been
			 * any music or block yet, we won't set newpage=YES
			 * for top/top2/bot/bot2, but otherwise we will.
			 */
			if (Context & (C_TOP|C_TOP2|C_BOT|C_BOT2)) {
				struct MAINLL *m_p;
				for (m_p = Mainlltc_p->prev; m_p != 0;
							m_p = m_p->prev) {
					if (m_p->str == S_BAR ||
							m_p->str == S_BLOCKHEAD) {
						/* There was music or block,
						 * so this is not
						 * at very beginning,
						 * so no special case:
						 * there will be new page.
						 */
						feed_p->pagefeed = YES;
						break;
					}
				}
			}

			/* Now check for redefined blocks and
			 * attach the BLOCKHEAD onto the FEED or the
			 * main list, as appropriate.
			 */
			switch (Context) {
			case C_TOP:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top_p),
							"top" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop_p),
							"top leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop_p),
							"top rightpage" );
					break;
				}
				break;
			case C_TOP2:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top2_p),
							"top2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop2_p),
							"top2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop2_p),
							"top2 rightpage" );
					break;
				}
				break;
			case C_BOT:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot_p),
							"bot" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot_p),
							"bot leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot_p),
							"bot rightpage" );
					break;
				}
				break;
			case C_BOT2:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot2_p),
							"bot2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot2_p),
							"bot2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot2_p),
							"bot2 rightpage" );
					break;
				}
				break;
			case C_BLOCK:
				insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
				Mainlltc_p->u.blockhead_p = Currblock_p;
				if ((yyvsp[(2) - (2)].intval) != PGSIDE_NOT_SET) {
					l_warning(Curr_filename, yylineno,
						"leftpage/rightpage cannot be used on blocks; ignoring");
				}
				/* These blocks count like "music" for purposes
				 * of things that can only be set
				 * before any "music"
				 */
				Got_some_data = YES;
				break;
			case C_HEADER:
			case C_HEAD2:
			case C_FOOTER:
			case C_FOOT2:
				/* These are static, not in main list,
				 * so nothing needs to be done with them.
				 */
				break;
			default:
				pfatal("unexpected context (0x%x) for block", Context);
				/*NOTREACHED*/
				break;
			}

			/* We need a feed after a block.
			 * Use -1 as lineno to mark it as internally generated.
			 * That way if user puts their own explicit feed
			 * next in the input, we can know we can
			 * discard this internally generated one.
			 */
			if (Context & C_BLOCK) {
				insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
			}
		}
	}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 1013 "src/mup/gram.y"
    {
		Context = C_MUSIC;
	}
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 1018 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_GRIDS;
	}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 1024 "src/mup/gram.y"
    {
	}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 1028 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_ACCIDENTALS;
	}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 1034 "src/mup/gram.y"
    {
		struct ACCIDENTALS *acc_name_map_p;

		/* Make sure not already in list */
		for (acc_name_map_p = Acc_contexts_list_p; acc_name_map_p != 0;
					acc_name_map_p = acc_name_map_p->next) {
			if (strcmp(acc_name_map_p->name, (yyvsp[(1) - (1)].stringval)) == 0) {
				l_warning(Curr_filename, yylineno,
				"accidental context name %s re-defined; using last", (yyvsp[(1) - (1)].stringval));
				/* We'll free the table, since that is
				 * potentially big, and is easy to do.
				 * We'll leave the ACCIDENTALS struct itself,
				 * because it doesn't seem worth the trouble
				 * to keep track of the "prev" to free up a
				 * little memory in a rare error case.
				 * And we'll leave the name, so future loops
				 * though the list can strcmp it, even though
				 * it will never really be used. We will put
				 * the replacement at the head of the list,
				 * so we'll always see that copy first and
				 * never bother to come down to this one.
				 */
				if (acc_name_map_p->info != 0) {
					FREE(acc_name_map_p->info);
					acc_name_map_p->info = 0;
					acc_name_map_p->size = 0;
				}
				/* If redefined multiple times, don't
				 * bother giving multiple errors. */
				break;
			}
		}

		MALLOC(ACCIDENTALS, acc_name_map_p, 1);
		acc_name_map_p->name = strdup((yyvsp[(1) - (1)].stringval) + 2);
		MALLOC(ACCINFO, acc_name_map_p->info, ITEMS);
		acc_name_map_p->size = 0;
		acc_name_map_p->next = Acc_contexts_list_p;
		Acc_contexts_list_p = acc_name_map_p;
	}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 1076 "src/mup/gram.y"
    {
		if (Context != C_ACCIDENTALS) {
			yyerror("something like looks like an accidentals entry when not in accidentals context");
		}
	}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 1084 "src/mup/gram.y"
    {
		if (Context == C_ACCIDENTALS) {
			new_acc_entry((yyvsp[(1) - (1)].stringval) + 2);
		}
	}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 1092 "src/mup/gram.y"
    {
		/* A single value to use for all notes a-g */
		int i;
		for (i = 0; i < 7; i++) {
			add_acc_offset('a' + i, (yyvsp[(2) - (2)].floatval));
		}
	}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 1106 "src/mup/gram.y"
    {
		add_acc_offset((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].floatval));
	}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 1112 "src/mup/gram.y"
    {
		add_acc_offset((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].floatval));
	}
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 1118 "src/mup/gram.y"
    {
		(yyval.floatval) = (float) cents2value( (double) ((yyvsp[(1) - (3)].intval) * (yyvsp[(2) - (3)].floatval)));
	}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 1124 "src/mup/gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 1130 "src/mup/gram.y"
    {
		if ((yyvsp[(3) - (3)].floatval) == 0.0) {
			yyerror("denominator cannot be zero");
		}
		else {
			(yyval.floatval) = (yyvsp[(1) - (3)].floatval) / (yyvsp[(3) - (3)].floatval);
		}
	}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1140 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_KEYMAP;
		new_keymap((yyvsp[(2) - (2)].stringval) + 2);
	}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1149 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_CONTROL;
		Saw_restoreparms = NO;
		Prev_control_parms = SR_SAVE;	/* really means "not restore"
						 * but didn't seem worth
						 * having separate state
						 * for that. */

	}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1162 "src/mup/gram.y"
    {
		if (contextcheck(C_CONTROL, "saveparms") == YES) {
			/* Associate the user's name with the current place
			 * in the main list */
			add_saveparms((yyvsp[(2) - (2)].stringval) + 2);
			if (Prev_control_parms != SR_WARN) {
				Prev_control_parms = SR_SAVE;
			}
		}
	}
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1175 "src/mup/gram.y"
    {
		if (contextcheck(C_CONTROL, "restoreparms") == YES) {
			if (do_restoreparms((yyvsp[(2) - (2)].stringval) + 2) == YES) {
				if (Saw_restoreparms == YES) {
					if (Prev_control_parms == SR_RESTORE) {
						l_warning(Curr_filename, yylineno,
						"consecutive instances of 'restoreparms' in the same control context; only the last is effective");
					}
					else if (Prev_control_parms != SR_WARN) {
						l_warning(Curr_filename, yylineno,
						"multiple instances of 'restorparms is of dubious usefulness");
					}
					Prev_control_parms = SR_WARN;
				}
				if (Prev_control_parms != SR_WARN) {
					Prev_control_parms = SR_RESTORE;
				}
			}
		}
	}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1198 "src/mup/gram.y"
    {
		if (Context == C_GRIDS) {
			add_grid((yyvsp[(1) - (3)].stringval), (yyvsp[(2) - (3)].stringval));
		}
		else if (Context == C_HEADSHAPES) {
			/* skip past the font/size bytes */
			add_shape((yyvsp[(1) - (3)].stringval) + 2, (yyvsp[(2) - (3)].stringval) + 2);
		}
		else if (Context == C_KEYMAP) {
			add_to_keymap((yyvsp[(1) - (3)].stringval), (yyvsp[(2) - (3)].stringval));
		}
		else {
			l_warning(Curr_filename, yylineno - 1,
				"unexpected pair of text strings (possibly intended to be in grids, headshapes, or keymap context, or missing + for concatenation?)");
		}
	}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1217 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_HEADSHAPES;
	}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1225 "src/mup/gram.y"
    {
		end_prev_context();
		Context = C_SYMBOL;
		/* The +2 to skip font/size */
		Curr_usym_p = alloc_usym((yyvsp[(2) - (2)].stringval) + 2);
	}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1237 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
		/* later on we check for being within current range */
	}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1243 "src/mup/gram.y"
    {
		errno = 0;
		(yyval.intval) = strtol(yytext, 0, 10);
		if (errno == ERANGE) {
			l_yyerror(Curr_filename, yylineno,
				"Number %s is beyond the range of numbers that can be handled", yytext);
		}
	}
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1253 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].intval);
	}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1268 "src/mup/gram.y"
    {
		/* Only a few things are allowed to have a negative number.
		 * Other code assumes that that restriction is enforced here,
		 * so we only honor the minus if it is legal. */
		if ((yyvsp[(3) - (4)].intval) == -1) {
			if ((yyvsp[(1) - (4)].intval) != SYLPOSITION) {
				yyerror("negative value not allowed");
			}
			else {
				assign_int((yyvsp[(1) - (4)].intval), -((yyvsp[(4) - (4)].intval)), Currstruct_p);
			}
		}
		else {
			assign_int((yyvsp[(1) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
		}
	}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1287 "src/mup/gram.y"
    {
		/* only restcombine and gridfret can be set to empty */
		if ((yyvsp[(1) - (2)].intval) == RESTCOMBINE) {
			assign_int((yyvsp[(1) - (2)].intval), NORESTCOMBINE, Currstruct_p);
		}
		else if ((yyvsp[(1) - (2)].intval) == GRIDFRET) {
			assign_int((yyvsp[(1) - (2)].intval), NOGRIDFRET, Currstruct_p);
		}
		else {
			yyerror("parameter value required");
		}
	}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1302 "src/mup/gram.y"
    {
		assign_firstpage((yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1308 "src/mup/gram.y"
    {
		if ((yyvsp[(3) - (4)].intval) == -1) {
			if ((yyvsp[(1) - (4)].intval) != STAFFPAD) {
				yyerror("negative value not allowed");
			}
			else {
				assign_float((yyvsp[(1) - (4)].intval), -((yyvsp[(4) - (4)].floatval)), Currstruct_p);
			}
		}
		else {
			assign_float((yyvsp[(1) - (4)].intval), (yyvsp[(4) - (4)].floatval), Currstruct_p);
		}
	}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1324 "src/mup/gram.y"
    {
		assign_2floats((yyvsp[(1) - (5)].intval), (yyvsp[(3) - (5)].floatval), (yyvsp[(5) - (5)].floatval), Currstruct_p);
	}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1330 "src/mup/gram.y"
    {
		assign_float((yyvsp[(1) - (4)].intval), (yyvsp[(3) - (4)].floatval), Currstruct_p);
	}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1336 "src/mup/gram.y"
    {
		assign_direction((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1342 "src/mup/gram.y"
    {
		double multiplier;
		multiplier = (Score.units == INCHES ? 1.0 : CMPERINCH);
		assign_float(PAGEWIDTH, pagesztbl[(yyvsp[(3) - (4)].intval)][(yyvsp[(4) - (4)].intval)] * multiplier, Currstruct_p);
		assign_float(PAGEHEIGHT, pagesztbl[(yyvsp[(3) - (4)].intval)][(yyvsp[(4) - (4)].intval) ^ 1] * multiplier, Currstruct_p);
	}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1350 "src/mup/gram.y"
    { begin_range(PL_UNKNOWN);  }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1351 "src/mup/gram.y"
    { }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 1355 "src/mup/gram.y"
    {
		/* specified in stepsizes, stored in inches */
		assign_float(PAD, (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval) * STEPSIZE, Currstruct_p);
	}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 1362 "src/mup/gram.y"
    {
		assign_vscheme ((yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1368 "src/mup/gram.y"
    {
		set_beamlist(Currstruct_p);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->beamrests = ((yyvsp[(5) - (5)].intval) & 0x1);
			Currstruct_p->u.ssv_p->beamspaces = (((yyvsp[(5) - (5)].intval) >> 1) & 0x1);
		}
	}
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1378 "src/mup/gram.y"
    {
		set_staffset((yyvsp[(1) - (4)].intval), Currstruct_p);
	}
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1384 "src/mup/gram.y"
    {
		set_barstlist(Currstruct_p, 0);
	}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1390 "src/mup/gram.y"
    {
		/* Put them in time order */
		if (Currstruct_p != 0) {
			qsort((char *)(Currstruct_p->u.ssv_p->subbarlist),
				Currstruct_p->u.ssv_p->nsubbar,
				sizeof(struct SUBBAR_INSTANCE),
				comp_subbar);
		}
	}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1402 "src/mup/gram.y"
    {
		if (contextcheck(C_SCORE|C_STAFF, "repeatdots") == YES
					&& Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->repeatdots = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[REPEATDOTS] = YES;
		}
	}
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1412 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			chk_order(Currstruct_p->u.ssv_p, Order_place);
		}
	}
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1423 "src/mup/gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1429 "src/mup/gram.y"
    {
		/* all the work for this is done in timesig */
	}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1435 "src/mup/gram.y"
    {
	}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1440 "src/mup/gram.y"
    {
		set_font((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1446 "src/mup/gram.y"
    {
		set_font((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1452 "src/mup/gram.y"
    {
		if (contextcheck(C_SCORE|C_STAFF,"clef parameter") == YES) {
			used_check(Currstruct_p, CLEF, "clef");
			if (Context == C_STAFF && has_tab_staff()) {
				/* We used to be able to make this just a
				 * warning, but now that is hard, because
				 * we'd want to let it assign for any
				 * non-tab, but it is hard to know at this
				 * point which SSVs will be tab and which					 * non-tab, because we may not have created
				 * them all yet. We cannot let the tab ones
				 * get assigned, because later code would
				 * get confused by clef not being TABCLEF.
				 * While we could figure this all out with
				 * enough code, it really is a user error,
				 * so not worth bending over backwards
				 * to try to keep it just a warning.
				 */
				l_yyerror(Curr_filename, yylineno,
					"can't set clef on tab staff");
			}
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->clef = (yyvsp[(3) - (4)].intval);
				Currstruct_p->u.ssv_p->forceprintclef = (yyvsp[(4) - (4)].intval);
				Currstruct_p->u.ssv_p->used[CLEF] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1483 "src/mup/gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1492 "src/mup/gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1498 "src/mup/gram.y"
    {
		if (contextcheck(C_STAFF|C_VOICE, "unset") == YES
					&& Currstruct_p != 0) {
			if ((yyvsp[(2) - (2)].intval) < 0 || (yyvsp[(2) - (2)].intval) >= NUMFLDS) {
				pfatal("invalid parameter index %d on line %d", (yyvsp[(2) - (2)].intval), yylineno);
			}
			if (Currstruct_p->u.ssv_p->used[(yyvsp[(2) - (2)].intval)] == YES) {
				warning("unsetting parameter overrides previous setting");
			}
			/* Note that if user tries to unset something that
			 * can't be set in the current context, we silently
			 * ignore that. We figure that since it's already unset,
			 * it doesn't hurt anything to unset it again,
			 * and it's easier to not bother to check.
			 */

			Currstruct_p->u.ssv_p->used[(yyvsp[(2) - (2)].intval)] = UNSET;

			/* special case: scoresep controls two fields */
			if ((yyvsp[(2) - (2)].intval) == MINSCSEP) {
				Currstruct_p->u.ssv_p->used[MAXSCSEP] = UNSET;
			}

			/* Assign, just in case there are new interactions */
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1527 "src/mup/gram.y"
    { Doing_timeunit = YES; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1528 "src/mup/gram.y"
    {
		if ( contextcheck(C_SSV, "timeunit parameter") == YES ) {
			used_check(Currstruct_p, TIMEUNIT, "timeunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->timeunit = (yyvsp[(4) - (4)].ratval);
				Currstruct_p->u.ssv_p->timelist_p = Extra_time_p;
				Currstruct_p->u.ssv_p->used[TIMEUNIT] = YES;
			}
			Extra_time_p = 0;
			Doing_timeunit = NO;
		}
	}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1543 "src/mup/gram.y"
    {
		if ( contextcheck(C_SSV, "swingunit parameter") == YES ) {
			used_check(Currstruct_p, SWINGUNIT, "swingunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->swingunit = (yyvsp[(3) - (3)].ratval);
				Currstruct_p->u.ssv_p->used[SWINGUNIT] = YES;
			}
		}
	}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1555 "src/mup/gram.y"
    {
	}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1560 "src/mup/gram.y"
    {
	}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1565 "src/mup/gram.y"
    {
		if ( contextcheck(C_SCORE, "endingstyle parameter") == YES
					&& Currstruct_p != 0 ) {
			used_check(Currstruct_p, ENDINGSTYLE, "endingstyle");
			Currstruct_p->u.ssv_p->endingstyle = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[ENDINGSTYLE] = YES;
		}
	}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1576 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			if ((yyvsp[(1) - (3)].intval) == REHSTYLE) {
				if (contextcheck(C_SCORE | C_STAFF, "rehstyle parameter") == YES ) {
					used_check(Currstruct_p, REHSTYLE, "rehstyle");
					Currstruct_p->u.ssv_p->rehstyle = (yyvsp[(3) - (3)].intval);
					Currstruct_p->u.ssv_p->used[REHSTYLE] = YES;
				}
			}
			else if ((yyvsp[(1) - (3)].intval) == MEASNUMSTYLE) {
				if (contextcheck(C_SCORE, "measnumstyle parameter") == YES) {
					used_check(Currstruct_p, MEASNUMSTYLE, "measnumstyle");
					Currstruct_p->u.ssv_p->measnumstyle = (yyvsp[(3) - (3)].intval);
					Currstruct_p->u.ssv_p->used[MEASNUMSTYLE] = YES;
				}
			}
		}
	}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1597 "src/mup/gram.y"
    {
		if (contextcheck(C_SCORE | C_STAFF, "pedstyle parameter") == YES
					&& Currstruct_p != 0) {
			used_check(Currstruct_p, PEDSTYLE, "pedstyle");
			Currstruct_p->u.ssv_p->pedstyle = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[PEDSTYLE] = YES;
			/* Since Ped_stop is a predefined string that
			 * doesn't go through fix_string(), we wouldn't
			 * realize that font ZD1 was used until printing
			 * phase after we ought to have emitted the
			 * encoding vector code, which is too late,
			 * so mark it here. If the user sets the
			 * parameter to pedstar but then never actually uses
			 * a star, this will just cause a few extraenous
			 * but otherwise harmless lines of output. It is
			 * less important the ZI gets marked as used,
			 * since we don't change its encodiong vector,
			 * so don't need to emit special code, but might as
			 * well mark that here as well. */
			if ((yyvsp[(3) - (3)].intval) != P_LINE) {
				Fontinfo[font_index(FONT_ZD1)].was_used = YES;
				Fontinfo[font_index(FONT_ZI)].was_used = YES;
			}
		}
	}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1625 "src/mup/gram.y"
    {
		char *trans_name;
		trans_name = ((yyvsp[(1) - (6)].intval) == TRANSPOSITION ?
			"transpose" : "addtranspose");
		if (contextcheck(C_SCORE|C_STAFF, trans_name) == YES) {
			if (Context == C_STAFF && has_tab_staff() == YES) {
				l_warning(Curr_filename, yylineno,
					"%s not allowed on tablature staff; ignoring",
					trans_name);
			}
			chk_interval((yyvsp[(4) - (6)].intval), (yyvsp[(5) - (6)].intval));
			if (Currstruct_p != 0) {
				used_check(Currstruct_p, (yyvsp[(1) - (6)].intval), trans_name);
				if ((yyvsp[(1) - (6)].intval) == TRANSPOSITION) {
					Currstruct_p->u.ssv_p->inttype = (yyvsp[(4) - (6)].intval);
					Currstruct_p->u.ssv_p->intnum = (yyvsp[(3) - (6)].intval) * (yyvsp[(5) - (6)].intval);
					Currstruct_p->u.ssv_p->trans_usage = (yyvsp[(6) - (6)].intval);
				}
				else {
					Currstruct_p->u.ssv_p->addinttype = (yyvsp[(4) - (6)].intval);
					Currstruct_p->u.ssv_p->addintnum = (yyvsp[(3) - (6)].intval) * (yyvsp[(5) - (6)].intval);
					Currstruct_p->u.ssv_p->addtrans_usage = (yyvsp[(6) - (6)].intval);
				}
				Currstruct_p->u.ssv_p->used[(yyvsp[(1) - (6)].intval)] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1656 "src/mup/gram.y"
    {
		assign_int(CUE, (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1662 "src/mup/gram.y"
    {
		assign_unit((yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1668 "src/mup/gram.y"
    {
		assign_string((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1674 "src/mup/gram.y"
    {
		assign_string((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1680 "src/mup/gram.y"
    {
		if (contextcheck(C_SCORE, "tuning") == YES
				&& Currstruct_p != 0) {
			used_check(Currstruct_p, TUNING, "tuning");
			Currstruct_p->u.ssv_p->used[TUNING] = YES;
			Currstruct_p->u.ssv_p->tuning = (yyvsp[(3) - (3)].intval);
			Tuning_used = YES;
		}
	}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1692 "src/mup/gram.y"
    {
		set_keymap((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1698 "src/mup/gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"postscript= only valid in symbol context; maybe you meant without '=' ?");
		}
		else {
			if (Curr_usym_p->flags & US_POSTSCRIPT) {
				l_warning(Curr_filename, yylineno,
					"Multiple postscript definitions given for symbol '%s'; using last",
					Curr_usym_p->name);
				FREE(Curr_usym_p->postscript);
			}
			Curr_usym_p->postscript = (yyvsp[(3) - (3)].stringval);
			Curr_usym_p->flags |= US_POSTSCRIPT;
		}
	}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1717 "src/mup/gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"bbox= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_BBOX) {
				l_warning(Curr_filename, yylineno,
					"Multiple bbox definitions given for symbol %s; using last",
					Curr_usym_p->name);
			}
			Curr_usym_p->llx = (yyvsp[(3) - (9)].intval);
			Curr_usym_p->lly = (yyvsp[(5) - (9)].intval);
			Curr_usym_p->urx = (yyvsp[(7) - (9)].intval);
			Curr_usym_p->ury = (yyvsp[(9) - (9)].intval);
			Curr_usym_p->flags |= US_BBOX;
		}
	}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1738 "src/mup/gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"stemoffset= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_STEMOFFSET) {
				l_warning(Curr_filename, yylineno,
					"Multiple stemoffset definitions given for %s; last used",
					Curr_usym_p->name);
			}
			Curr_usym_p->upstem_y = (yyvsp[(3) - (5)].intval);
			Curr_usym_p->downstem_y = (yyvsp[(5) - (5)].intval);
			Curr_usym_p->flags |= US_STEMOFFSET;
		}
	}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1758 "src/mup/gram.y"
    {
		/* whereused is not allowed on voice, just score and staff */
		if (contextcheck(C_SCORE|C_STAFF, "visible=whereused") == YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = YES;
			}
		}
	}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1770 "src/mup/gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("visible value must be y, n, or whereused");
		}
		else if (contextcheck(C_SSV, "visible parameter")
								== YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1786 "src/mup/gram.y"
    {
		if (contextcheck(C_SSV, "visible parameter") == YES) {
			assign_int(VISIBLE, NO, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1796 "src/mup/gram.y"
    {
		(yyval.intval) = PGSIDE_NOT_SET;
	}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1802 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1807 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1813 "src/mup/gram.y"
    {
		/* only valid letter is y */
		if (*yytext == 'y') {
			(yyval.intval) = YES;
		}
		else {
			/* Our yyerror will end up making this into a
			 * nice error message that gives the offending token */
			yyerror("syntax error");
			(yyval.intval) = NO;
		}
	}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1828 "src/mup/gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("measnum value must be y, n, or every N");
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = MN_SCORE;
		}
	}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1841 "src/mup/gram.y"
    {
		(yyval.intval) = MN_NONE;
	}
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1847 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) < MINEVERYMEASNUM || (yyvsp[(2) - (2)].intval) > MAXEVERYMEASNUM) {
			/* We have to do range check here rather than let
			 * assign_int() do it, because internally we use
			 * additional values, and it would be confusing to
			 * the user to include those internal values in the
			 * valid range. */
			l_yyerror(Curr_filename, yylineno,
				"for measnum=every N, N must be between %d and %d",
				MINEVERYMEASNUM, MAXEVERYMEASNUM);
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1866 "src/mup/gram.y"
    {
		/* none specified */
		(yyval.intval) = V_1;
	}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1873 "src/mup/gram.y"
    {
		/* only valid value here is 'f'  */
		if (*yytext == 'f') {
			(yyval.intval) = V_2FREESTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = V_1;
		}
	}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1886 "src/mup/gram.y"
    {
		/* only valid value here is 'o' */
		if (*yytext == 'o') {
			(yyval.intval) = V_2OPSTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = (int) V_1;
		}
	}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1898 "src/mup/gram.y"
    {
		/* NULL token for allocating a new beamlist */
		new_beamlist();
	}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1912 "src/mup/gram.y"
    {
		add_beamlist((yyvsp[(1) - (1)].ratval));
	}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1921 "src/mup/gram.y"
    {
		add_beamlist((yyvsp[(3) - (3)].ratval));
	}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1930 "src/mup/gram.y"
    { begin_subbeam(); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1931 "src/mup/gram.y"
    {
		end_subbeam();
	}
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1936 "src/mup/gram.y"
    {
		(yyval.ratval) = calcfulltime((yyvsp[(1) - (4)].ratval), (yyvsp[(2) - (4)].intval));

		/* If filling in a GRPSYL struct,
		 * need to fill in dots and basictime.
		 * Could also be here due to beamstyle
		 * or timeunit or location time offset,
		 * in which case the Curr_grpsyl_p will be NULL,
		 * or while getting tuplet duration. */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
						&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->dots = (yyvsp[(2) - (4)].intval);
			Curr_grpsyl_p->basictime = reconstruct_basictime((yyval.ratval));
		}
		else {
			struct TIMELIST *timelist_p;	/* walk thru list */
			struct TIMELIST *next_p;/* save next to delete curr */
			RATIONAL totaltime;	/* sum of extra times */

			/* Start with first time value (which was calculated
			 * above and is now in $$), then add on the added
			 * times, if any. */
			totaltime = (yyval.ratval);
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = next_p) {
				next_p = timelist_p->next;
				totaltime = radd(totaltime, timelist_p->fulltime);
				if (Doing_timeunit == NO) {
					/* For things like swingunit
					 * or tuplet time, we just need the
					 * resulting time, not the individual
					 * time units and arithmetic. */
					FREE(timelist_p);
				}
			}
			if (Extra_time_p != 0 && LE(totaltime, Zero)) {
				yyerror("Time values must add up to more than zero");
			}
			/* Current timelist is finished; can't append any
			 * more items to it. */
			Curr_timelist_p = 0;
			if (Doing_timeunit == YES) {
				/* For timeunit, we return the initial
				 * timeunit, but also preserve
				 * Extra_time_p for putting in SSV.
				 */
				(yyval.ratval) = calcfulltime((yyvsp[(1) - (4)].ratval), (yyvsp[(2) - (4)].intval));
			}
			else {
				/* the list has been freed above */
				Extra_time_p = 0;
				(yyval.ratval) = totaltime;
			}
		}
	}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1994 "src/mup/gram.y"
    {
		(yyval.ratval).n = (svpath(1, TIME))->time.n;
		(yyval.ratval).d = (svpath(1, TIME))->time.d;
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* use whole note symbol as default */
			Curr_grpsyl_p->basictime = 1;
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = NO;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 2011 "src/mup/gram.y"
    {
		(yyval.ratval) = Zero;
	}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 2021 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 2027 "src/mup/gram.y"
    {
		(yyval.intval) = (YES | (YES << 1));
	}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 2033 "src/mup/gram.y"
    {
		(yyval.intval) = ((YES << 1) | YES);
	}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 2039 "src/mup/gram.y"
    {
		(yyval.intval) = (YES << 1);
	}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 2045 "src/mup/gram.y"
    {
		(yyval.intval) = YES;
	}
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 2050 "src/mup/gram.y"
    {
		/* null token for the purpose of allocating a new rangelist
		 * to be filled in with user data */
		new_staffset();
	}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 2071 "src/mup/gram.y"
    {
		/* save information about this range in the list */
		/* if only a single number, not a range, rangetail will be
		 * 0, so use num as both beginning and end of range */
		add_staffset( (yyvsp[(1) - (3)].intval), ((yyvsp[(2) - (3)].intval) > 0 ? (yyvsp[(2) - (3)].intval) : (yyvsp[(1) - (3)].intval)), String1, String2);
	}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 2079 "src/mup/gram.y"
    {
		/* no end of range, so return 0 as flag that there was only 1 number */
		(yyval.intval) = 0;
	}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 2086 "src/mup/gram.y"
    {
		/* make sure isn't 0, because that it illegal and would be used
		 * later as though there were no range. Other error checking
		 * on this number will be done later. */
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("second number of range may not be zero");
		}
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 2097 "src/mup/gram.y"
    {
		/* no labels */
		String1 = String2 = (char *) 0;
	}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 2104 "src/mup/gram.y"
    {
		/* save label */
		String1 = (yyvsp[(2) - (4)].stringval);
	}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 2110 "src/mup/gram.y"
    {
		/* no second label */
		String2 = (char *) 0;
	}
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 2117 "src/mup/gram.y"
    {
		/* save label2 for later use */
		String2 = (yyvsp[(2) - (2)].stringval);
	}
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 2126 "src/mup/gram.y"
    {
		/* NULL token for allocating space for a bar style list */
		new_barstlist();
		Bar_between = NO;
	}
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 2143 "src/mup/gram.y"
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 2149 "src/mup/gram.y"
    {
	}
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 2158 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != PL_BETWEEN) {
			yyerror("barstyle range place can only be between");
		}
		else {
			Bar_between = YES;
		}
	}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 2170 "src/mup/gram.y"
    {
		/* if only 1 number, not range, rangetail will be 0, so use
		 * same number for beginning and end */
		add_barst((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)), Bar_between, NO);
	}
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 2177 "src/mup/gram.y"
    {
		used_check(Currstruct_p, SUBBARSTYLE, "subbarstyle");
		Bar_between = NO;
	}
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 2183 "src/mup/gram.y"
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 2189 "src/mup/gram.y"
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 2194 "src/mup/gram.y"
    {
		MALLOC(SUBBAR_APPEARANCE, Subbar_app_p, 1);
	}
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 2199 "src/mup/gram.y"
    {
		new_barstlist();
	}
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 2205 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case L_NORMAL:
		case L_DASHED:
		case L_DOTTED:
			break;
		default:
			l_yyerror(Curr_filename, yylineno,
				"subbar linetype, if specified, can only be dashed or dotted");
			break;
		}

		Subbar_app_p->linetype = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 2222 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != SINGLEBAR && (yyvsp[(1) - (1)].intval) != DOUBLEBAR) {
			l_yyerror(Curr_filename, yylineno,
				"subbar type can only be bar or dblbar");
		}
		Subbar_app_p->bartype = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 2231 "src/mup/gram.y"
    {
		Subbar_app_p->upper_ref_line = LR_TOP;
		Subbar_app_p->upper_offset = 0.0;
		Subbar_app_p->lower_ref_line = LR_BOTTOM;
		Subbar_app_p->lower_offset = 0.0;
	}
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 2243 "src/mup/gram.y"
    {
		Subbar_app_p->upper_ref_line = (yyvsp[(2) - (7)].intval);
		Subbar_app_p->upper_offset = (yyvsp[(3) - (7)].floatval);
		Subbar_app_p->lower_ref_line = (yyvsp[(5) - (7)].intval);
		Subbar_app_p->lower_offset = (yyvsp[(6) - (7)].floatval);
	}
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 2252 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case C_TOP:
			(yyval.intval) = LR_TOP;
			break;
		case C_BOT:
			(yyval.intval) = LR_BOTTOM;
			break;
		default:
			/* our yyerror will turn this into more helpful msg */
			yyerror("syntax error");
			/* return some valid value */
			(yyval.intval) = LR_MIDDLE;
			break;
		}
	}
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 2271 "src/mup/gram.y"
    {
		(yyval.intval) = LR_MIDDLE;
	}
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 2276 "src/mup/gram.y"
    {
		(yyval.floatval) = 0.0;
	}
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 2282 "src/mup/gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval);
	}
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 2294 "src/mup/gram.y"
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 2307 "src/mup/gram.y"
    {
		struct SSV *ssv_p;
		int n;		/* to loop for checking for duplicates */

		if (Currstruct_p != 0) {
			ssv_p = Currstruct_p->u.ssv_p;
			if (ssv_p->nsubbar == 0) {
				MALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist, 1);
			}
			else {
				REALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist,
							ssv_p->nsubbar+1);
			}

			if ((yyvsp[(1) - (1)].floatval) <= 1.0 || (yyvsp[(1) - (1)].floatval) >= (double) Score.timenum + 1.0) {
				l_yyerror(Curr_filename, yylineno,
					"subbar time must be greater than 1.0 and less than %.3f",
							Score.timenum + 1.0);
			}
			for (n = 0; n < ssv_p->nsubbar; n++) {
				if (ssv_p->subbarlist[n].count == (yyvsp[(1) - (1)].floatval)) {
					l_warning(Curr_filename, yylineno,
						"time %f specified more than once for same subbar instance", (yyvsp[(1) - (1)].floatval));
				}
			}
			ssv_p->subbarlist[ssv_p->nsubbar].count = (yyvsp[(1) - (1)].floatval);
			ssv_p->subbarlist[ssv_p->nsubbar].appearance_p = Subbar_app_p;
			(ssv_p->nsubbar)++;
		}
	}
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 2340 "src/mup/gram.y"
    {
		(yyval.intval) = RD_ALL;
	}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 2346 "src/mup/gram.y"
    {
		(yyval.intval) = RD_STANDARD;
	}
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 2351 "src/mup/gram.y"
    {
		Order_place = (yyvsp[(1) - (1)].intval);
		Order_prio = 1;
		if (Currstruct_p != 0) {
			switch ((yyvsp[(1) - (1)].intval)) {
			case PL_ABOVE:
				Currstruct_p->u.ssv_p->used[ABOVEORDER] = YES;
				break;
			case PL_BELOW:
				Currstruct_p->u.ssv_p->used[BELOWORDER] = YES;
				break;
			case PL_BETWEEN:
				Currstruct_p->u.ssv_p->used[BETWEENORDER] = YES;
				break;
			}
		}
	}
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 2371 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(1) - (1)].intval)] = Order_prio;
		}
	}
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 2379 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(3) - (3)].intval)] = ++Order_prio;
		}
	}
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 2387 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(3) - (3)].intval)] = Order_prio;
		}
	}
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 2394 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(1) - (1)].intval)] != 0) {
				l_yyerror(Curr_filename, yylineno,
					"order item %s specified more than once", (yyvsp[(1) - (1)].intval));
			}
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 2406 "src/mup/gram.y"
    {
		(yyval.intval) = MK_MUSSYM;
	}
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 2412 "src/mup/gram.y"
    {
		(yyval.intval) = MK_OCTAVE;
	}
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 2418 "src/mup/gram.y"
    {
		(yyval.intval) = MK_OTHERTEXT;
	}
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 2424 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case TM_CHORD:
			(yyval.intval) = MK_CHORD;
			break;
		case TM_DYN:
			(yyval.intval) = MK_DYN;
			break;
		default:
			yyerror("invalid text modifier in order list");
			/* set to something valid, since $$ will be used
			 * as an array subscript. */
			(yyval.intval) = MK_CHORD;
			break;
		}
	}
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 2443 "src/mup/gram.y"
    {
		(yyval.intval) = MK_LYRICS;
	}
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 2449 "src/mup/gram.y"
    {
		(yyval.intval) = MK_ENDING;
	}
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 2455 "src/mup/gram.y"
    {
		(yyval.intval) = MK_REHEARSAL;
	}
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 2461 "src/mup/gram.y"
    {
		(yyval.intval) = MK_PEDAL;
	}
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 2467 "src/mup/gram.y"
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->timerep, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->timerep, Timerep);
			assign_timesig(Currstruct_p, (yyvsp[(2) - (2)].intval), &Next_alt_timesig);
			Tsig_visibility = (yyvsp[(2) - (2)].intval);
			/* If there are alternating time signatures,
			 * need to save pointer to this list */
			if (Next_alt_timesig != 0) {
				Alt_timesig_list = Currstruct_p->u.ssv_p->timerep;
			}
			else {
				Alt_timesig_list = 0;
			}
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 2491 "src/mup/gram.y"
    { tsig_item(TSR_ALTERNATING); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 2492 "src/mup/gram.y"
    {
		/* this is for alternating time signature */
	}
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 2498 "src/mup/gram.y"
    {
	}
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 2502 "src/mup/gram.y"
    { tsig_item(TSR_ADD); }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 2503 "src/mup/gram.y"
    {
		/* This would be for things like 2/4 + 3/8 */
	}
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 2509 "src/mup/gram.y"
    {
		tsig_item(TSR_CUT);
	}
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 2515 "src/mup/gram.y"
    {
		tsig_item(TSR_COMMON);
	}
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 2521 "src/mup/gram.y"
    {
		tsig_item(TSR_SLASH);
		if ((yyvsp[(3) - (3)].intval) < MINDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be less than %d",
				MINDENOMINATOR);
			(yyvsp[(3) - (3)].intval) = MINDENOMINATOR;
		}
		else if ((yyvsp[(3) - (3)].intval) > MAXDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be greater than %d",
				MAXDENOMINATOR);
			(yyvsp[(3) - (3)].intval) = MAXDENOMINATOR;
		}
		else if (power_of2check((yyvsp[(3) - (3)].intval), "time signature denominator") == NO) {
			(yyvsp[(3) - (3)].intval) = 1 << drmo((yyvsp[(3) - (3)].intval));
		}

		tsig_item((yyvsp[(3) - (3)].intval));
	}
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 2544 "src/mup/gram.y"
    {
		/* this is something like 3+1/4 where the 1/4 get interpreted
		 * by lexer as quadwhole, but it's really 1 for numerator
		 * and 4 for denominator. 
		 */
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[(3) - (3)].intval));
	}
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 2556 "src/mup/gram.y"
    {
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[(1) - (1)].intval));
	}
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 2570 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) < MINNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be less than %d",
				MINNUMERATOR);
			(yyvsp[(1) - (1)].intval) = MINNUMERATOR;
		}
		else if ((yyvsp[(1) - (1)].intval) > MAXNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be greater than %d",
				MAXNUMERATOR);
			(yyvsp[(1) - (1)].intval) = MAXNUMERATOR;
		}
		tsig_item((yyvsp[(1) - (1)].intval));
	}
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 2588 "src/mup/gram.y"
    {
		(yyval.intval) = PTS_ONCE;
	}
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 2594 "src/mup/gram.y"
    {
		(yyval.intval) = ((yyvsp[(1) - (1)].intval) == YES ? PTS_ALWAYS : PTS_NEVER);
	}
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 2599 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 2605 "src/mup/gram.y"
    {
		/* 'n' is used in various places to mean do NOT
		 * print something that would normally be printed,
		 * so YES means we do want to inhibit the normal printing. */
		(yyval.intval) = YES;
	}
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 2613 "src/mup/gram.y"
    {
		if ( ((yyvsp[(2) - (3)].intval) != '#') && ((yyvsp[(2) - (3)].intval) != '&') ) {
			yyerror("key signature must include # or &");
		}
		else {
			assign_key((yyvsp[(1) - (3)].intval), (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
		}
	}
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 2624 "src/mup/gram.y"
    {
		int sharps;

		/* Get number of sharps for the pitch letter */
		sharps = strchr(Circle, (yyvsp[(1) - (3)].intval)) - Circle - 1;

		/* adjust for sharp/flat */
		if ((yyvsp[(2) - (3)].intval) == '#') {
			sharps += 7;
		}
		else if ((yyvsp[(2) - (3)].intval) == '&') {
			sharps -= 7;
		}
		else if ((yyvsp[(2) - (3)].intval) != 0) {
			yyerror("key letter can only be followed by # or &");
			/* set to some ridiculous value, so will fail below */
			sharps = 999;
		}

		/* Adjust if needed for minor */
		if ((yyvsp[(3) - (3)].intval) == YES) {
			sharps -= 3;
		}

		/* disallow illegal keys, like f& */
		if (abs(sharps) > 7) {
			/* print error unless already printed one above */
			if (sharps < 100) {
				yyerror("invalid key--too many sharps or flats");
			}
		}
		else {
			assign_key(abs(sharps), (sharps >= 0 ? '#' : '&'),
							(yyvsp[(3) - (3)].intval), Currstruct_p);
		}
	}
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 2663 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) == NO) {
			if ((yyvsp[(2) - (2)].intval) != -1) {
				l_warning(Curr_filename, yylineno,
					"can't use useaccs qualifier with n; ignoring the qualifier");
			}
			(yyval.intval) = UA_N;
		}
		else {
			if ((yyvsp[(2) - (2)].intval) == -1) {
				(yyvsp[(2) - (2)].intval) = UA_Y_NONE;
			}
			(yyval.intval) = (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 2681 "src/mup/gram.y"
    {
		/* Empty means UA_Y_NONE when used with 'y', but we need
		 * to distinguish temporarily, in case user erroneously
		 * tries to use std with 'n' */
		(yyval.intval) = -1;
	}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 2690 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 2696 "src/mup/gram.y"
    {
		(yyval.intval) = UA_Y_ALL;
	}
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 2702 "src/mup/gram.y"
    {
		(yyval.intval) = UA_Y_NONNAT;
	}
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 2709 "src/mup/gram.y"
    {
		asgn_stafflines((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval) == YES ? SS_NOTHING : SS_NORMAL, Currstruct_p);
	}
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 2715 "src/mup/gram.y"
    {
		asgn_stafflines((yyvsp[(1) - (2)].intval), SS_DRUM, Currstruct_p);
	}
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 2721 "src/mup/gram.y"
    {
		/* use default tablature */
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->strinfo = Guitar;
			asgn_stafflines(DEFTABLINES, (yyvsp[(2) - (2)].intval), Currstruct_p);
		}
	}
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 2731 "src/mup/gram.y"
    {
		/* user-specified tablature */
		asgn_stafflines((yyvsp[(3) - (5)].intval), (yyvsp[(5) - (5)].intval), Currstruct_p);
	}
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 2737 "src/mup/gram.y"
    {
		(yyval.intval) = PTC_FIRST;
	}
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 2743 "src/mup/gram.y"
    {
		(yyval.intval) = PTC_NEVER;
	}
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 2749 "src/mup/gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = PTC_ALWAYS;
	}
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 2759 "src/mup/gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 2765 "src/mup/gram.y"
    {
		/* count up the number of strings */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 2771 "src/mup/gram.y"
    {
		/* save info about this tablature string */
		if (Currstruct_p != 0) {
			add_tab_string_info((yyvsp[(1) - (4)].intval), (yyvsp[(2) - (4)].intval), (yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 2779 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 2785 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != '&' && (yyvsp[(1) - (1)].intval) != '#') {
			yyerror("accidental on string can only be & or #");
		}
	}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 2792 "src/mup/gram.y"
    {
		/* no ticks */
		(yyval.intval) = 0;
	}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 2799 "src/mup/gram.y"
    {
		/* limit number of ticks. Has to match the number of bits
		 * used by TMP_NTICKS in grpsyl.c */
		if ((yyvsp[(1) - (1)].intval) > MAXTICKS) {
			l_yyerror(Curr_filename, yylineno,
				"too many ' marks (%d max)", MAXTICKS);
			(yyvsp[(1) - (1)].intval) = MAXTICKS;
		}
	}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 2810 "src/mup/gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = YES;
	}
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 2820 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 2825 "src/mup/gram.y"
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scoresep; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCSEP, (yyvsp[(1) - (1)].floatval), Currstruct_p);
		}
	}
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 2838 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			/* if user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscsep
					> Currstruct_p->u.ssv_p->maxscsep) {
				Currstruct_p->u.ssv_p->maxscsep
					= Currstruct_p->u.ssv_p->minscsep;
			}
			else {
				/* fill in default */
				assign_float(MAXSCSEP, DEFMAXSCSEP, Currstruct_p);
			}
		}
	}
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 2857 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscsep > (yyvsp[(2) - (2)].floatval)) {
				yyerror("scoresep maximum smaller than minimum");
			}
			assign_float(MAXSCSEP, (yyvsp[(2) - (2)].floatval), Currstruct_p);
		}
	}
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 2867 "src/mup/gram.y"
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scorepad; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCPAD, (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval), Currstruct_p);
		}
	}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 2881 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			/* If user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscpad
					> Currstruct_p->u.ssv_p->maxscpad) {
				Currstruct_p->u.ssv_p->maxscpad
					= Currstruct_p->u.ssv_p->minscpad;
			}
			else {
				/* fill in default */
				assign_float(MAXSCPAD, DEFMAXSCPAD, Currstruct_p);
			}
		}
	}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 2900 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscpad > (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].floatval)) {
				yyerror("scorepad maximum smaller than minimum");
			}
			assign_float(MAXSCPAD, (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].floatval), Currstruct_p);
		}
	}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 2911 "src/mup/gram.y"
    {
	}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 2916 "src/mup/gram.y"
    {
		assign_float(MAXPROSHORT, (yyvsp[(2) - (3)].floatval), Currstruct_p);
	}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 2921 "src/mup/gram.y"
    {
	}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 2926 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (4)].intval) > (yyvsp[(4) - (4)].intval)) {
			l_warning(Curr_filename, yylineno,
				"distance to begin shortening protruding stems cannot be greater than ending distance; making them equal");
			(yyvsp[(4) - (4)].intval) = (yyvsp[(2) - (4)].intval);
		}
		assign_int(BEGPROSHORT, (yyvsp[(2) - (4)].intval), Currstruct_p);
		assign_int(ENDPROSHORT, (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 2938 "src/mup/gram.y"
    {
		(yyval.intval) = UNKNOWN;
	}
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 2944 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 2953 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) == (int) 'a' && (yyvsp[(2) - (2)].intval) >= 4 && (yyvsp[(2) - (2)].intval) <= 6) {
			switch ((yyvsp[(2) - (2)].intval)) {
			case 4:
				(yyval.intval) = PS_A4;
				break;
			case 5:
				(yyval.intval) = PS_A5;
				break;
			case 6:
				(yyval.intval) = PS_A6;
				break;
			default:
				pfatal("impossible pagesize");
				break;
			}
		}
		else {
			yyerror("unsupported pagesize");
		}
	}
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 2978 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 2984 "src/mup/gram.y"
    {
		(yyval.intval) = ((yyvsp[(1) - (1)].intval) == O_PORTRAIT ? 0 : 1);
	}
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 2991 "src/mup/gram.y"
    {
		assign_vcombine(VC_NOOVERLAP, Currstruct_p);
	}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 2997 "src/mup/gram.y"
    {
		assign_vcombine((yyvsp[(2) - (2)].intval), Currstruct_p);
		Defining_multiple = NO;
	}
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 3005 "src/mup/gram.y"
    {
		(yyval.intval) = VC_NOOVERLAP;
	}
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 3011 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 3018 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 3024 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != C_TOP) {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
		(yyval.intval) = ENDING_TOP;
	}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 3033 "src/mup/gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 3039 "src/mup/gram.y"
    {
		(yyval.intval) = -1;
	}
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 3044 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 3050 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case MINOR:
			(yyval.intval) = YES;
			break;
		case MAJOR:
			(yyval.intval) = NO;
			break;
		default:
			(yyval.intval) = NO;
			yyerror("must be major or minor");
			break;
		}
	}
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 3066 "src/mup/gram.y"
    {
		(yyval.intval) = P_LINE;
	}
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 3072 "src/mup/gram.y"
    {
		(yyval.intval) = P_ALTPEDSTAR;
	}
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 3078 "src/mup/gram.y"
    {
		(yyval.intval) = P_PEDSTAR;
	}
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 3086 "src/mup/gram.y"
    {
		(yyval.intval) = TR_BOTH;
	}
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 3092 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 3097 "src/mup/gram.y"
    {
	}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 3101 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) == FONT_UNKNOWN) {
			(yyvsp[(2) - (2)].intval) = Curr_font;
		}
		if ((yyvsp[(1) - (2)].intval) == FAMILY_DFLT) {
			/* user didn't specify a family. Use the current
			 * family, unless we don't have one yet, in which
			 * case look it up */
			if (Curr_family == FAMILY_DFLT) {
				Curr_family = Score.fontfamily;
			}
			Titlefont =  Curr_family + (yyvsp[(2) - (2)].intval);
		}
		else {
			Titlefont = (yyvsp[(1) - (2)].intval) + (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 3120 "src/mup/gram.y"
    {
		(yyval.intval) = FONT_UNKNOWN;
	}
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 3126 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 3131 "src/mup/gram.y"
    {
		(yyval.intval) = FAMILY_DFLT;
	}
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 3136 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 3141 "src/mup/gram.y"
    {
		Titlesize = Curr_size;
	}
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 3147 "src/mup/gram.y"
    {
		Titlesize = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 3153 "src/mup/gram.y"
    {
		String1 = (yyvsp[(1) - (1)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String1,
			Titlefont, Titlesize, YES, NO, PU_NORMAL, NO, 0, Extra);
	}
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 3162 "src/mup/gram.y"
    {
		double tmp_extra;

		/* If one is taller than the default for the font/size,
		 * figure out how much more to add on. */
		String1 = (yyvsp[(1) - (2)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[(2) - (2)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
	}
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 3183 "src/mup/gram.y"
    {
		double tmp_extra;
		char *string3;

		String1 = (yyvsp[(1) - (3)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[(2) - (3)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);
		string3 = (yyvsp[(3) - (3)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &string3);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, string3,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
	}
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 3208 "src/mup/gram.y"
    {
		char *p;		/* pointer through the string */
		int backslash_count;	/* how many backslashes in a row */
		int font, size;		/* at end of \n-delimited segment */
		char *string_start;	/* where current segment begins */

		/* Convert unescaped input newlines to spaces.
		 * The +2 in the 'for' initialization is to skip font/size.
		 */
		backslash_count = 0;
		string_start = (yyvsp[(5) - (7)].stringval);
		/* If we are running on a file using \r or \r\n for
		 * line separator, normalize to \n instead */
		for (p = string_start + 2; *p != 0; p++) {
			if (*p == '\r') {
				if ( *(p+1) != '\n') {
					/* \r by itself. Use \n instead */
					*p = '\n';
				}
				else {
					/* delete the \r */
					char *src, *dest;
					for (src = p + 1, dest = p;  ; src++, dest++) { 
						*dest = *src;
						if (*src == '\0') {
							break;
						}
					}
				}
			}
		}

		font = Titlefont;
		size = Titlesize;
		for (p = string_start + 2; *p != 0; p++) {
			/* Real newlines not preceded by an odd number
			 * of backslashes are converted to spaces. */
			if (*p == '\n' && (backslash_count & 0x1) == 0) {
				*p = ' ';
			}

			/* Count up number of consecutive backslashes.
			 * Also, if user explicitly uses \n, split into
			 * a new paragraph
			 */
			if (*p == '\\') {
				backslash_count++;
				if (((backslash_count & 0x1) == 1)
						&& ( *(p+1) == 'n') ) {
					/* Need to split.
					 * Terminate the current string
					 * where we are in it, and process it,
					 * then arrange to continue processing
					 * on the rest of the string.
					 */
					*p = '\0';
					(void) fix_string(string_start,
						font, size,
						Curr_filename, yylineno);
					String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
					proc_printcmd((yyvsp[(1) - (7)].intval), (struct INPCOORD*) 0,
						String1, font, size,
						YES, NO, PU_NORMAL, NO, 0, 0.0);

					/* The user could change font/size
					 * in mid-string with \f() and/or \s().
					 * so we have to determine what they
					 * are at the end of the current segment
					 * and use that for making the copy
					 * of the remainder of the string.
					 * The original copy of the remainder
					 * of the string gets "memory leaked,"
					 * but this is a rare case, so not
					 * worth worrying about.
					 */
					end_fontsize(String1, &font, &size);
					string_start = copy_string(p+2, font, size);
					p = string_start + 2;
				}
			}
			else {
				backslash_count = 0;
			}
		}
		(void) fix_string(string_start, font, size,
					Curr_filename, yylineno);
		String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
		proc_printcmd((yyvsp[(1) - (7)].intval), (struct INPCOORD*) 0, String1,
				font, size, YES, NO, PU_NORMAL, NO, 0, 0.0);
	}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 3301 "src/mup/gram.y"
    {
		/* Use same paragraph time as last time (or default if
		 * this is the first paragraph ever in this song.) */
		(yyval.intval) = Curr_paratype;
	}
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 3309 "src/mup/gram.y"
    {
		Curr_paratype = (yyvsp[(1) - (1)].intval);
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 3433 "src/mup/gram.y"
    {
		/* strip the quotes from the string and make a copy for later use */
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		(yyval.stringval) = copy_string(stripquotes(yytext), Curr_family + Curr_font,
								Curr_size);
	}
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 3444 "src/mup/gram.y"
    {
		char *old_string;

		/* append new string part to existing part */
		old_string = (yyvsp[(1) - (3)].stringval);
		/* new string part has quotes, so subtract 2 from needed length,
		 * but need space for null, so overall need 1 less. */
		MALLOCA(char, (yyval.stringval), strlen(old_string) + strlen(yytext) - 1);
		sprintf((yyval.stringval), "%s%s", old_string, stripquotes(yytext));
		FREE(old_string);
	}
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 3457 "src/mup/gram.y"
    {
		(void) contextcheck(C_MUSIC, "music information");
		tssv_line();
		/* reset flags for next voice */
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Good_till_canceled = NO;
		free_extra_time();
		Prev_grpsyl_p = 0;
	}
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 3469 "src/mup/gram.y"
    {
		/* Here's the deal: the staff/voice specification
		 * could be lists of staff ranges and/or voices.
		 * We need a separate copy of the groupinfo
		 * for each staff/voice. So as we parse the sv_spec,
		 * we remember which staffs and voices are specified,
		 * and keep a pointer to the first STAFF in the measure.
		 * Then after collecting the groupinfo,
		 * we make copies of the group info for each staff/voice given.
		 * It has to be copies rather than just a pointer to the
		 * same stuff, because the coordinates will be different
		 * for each staff/voice. */

		/* attach the groupinfo to each of the STAFF structs */
		link_groups();
	}
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 3488 "src/mup/gram.y"
    {
		add_multirest((yyvsp[(2) - (3)].intval));
		/* If there are alternating time signatures, figure out
		 * which one should be in effect at the end of the multirest */
		if (Alt_timesig_list != 0) {
			int m;

			/* The Next_alt_timesig is already pointing to
			 * the value for after the first measure in the
			 * multirest, so have to subtract 1 here */
			for (m = 0; m < (yyvsp[(2) - (3)].intval) - 1; m++) {
				if (Next_alt_timesig == 0) {
					/* Shouldn't really ever get here,
					 * since other code should do the
					 * wrap-around, but just in case... */
					Next_alt_timesig = Alt_timesig_list;
					continue;
				}
				do {
					Next_alt_timesig++;
					if (*Next_alt_timesig == TSR_END) {
						Next_alt_timesig = Alt_timesig_list;
						break;
					}
				} while (*Next_alt_timesig != TSR_ALTERNATING);
			}
			if (*Next_alt_timesig == TSR_ALTERNATING) {
				Next_alt_timesig++;
			}
		}
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 3523 "src/mup/gram.y"
    {
		free_staffrange();
	}
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 3528 "src/mup/gram.y"
    {
		begin_range(PL_UNKNOWN);
	}
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 3533 "src/mup/gram.y"
    {
		Chord_at_a_time = NO;
	}
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 3539 "src/mup/gram.y"
    {
		Chord_at_a_time = YES;
	}
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 3554 "src/mup/gram.y"
    {
		begin_map();
	}
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 3559 "src/mup/gram.y"
    {
		end_map();
	}
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 3564 "src/mup/gram.y"
    {
		map_item();
	}
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 3570 "src/mup/gram.y"
    {
		map_item();
		Defining_multiple = YES;
	}
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 3576 "src/mup/gram.y"
    {
		/* initialize grpsyl info */
		Curr_grpsyl_p = Last_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 3586 "src/mup/gram.y"
    {
		/* prepare for a new set of ranges */
		begin_range(Place);
		Defining_multiple = YES;
	}
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 3593 "src/mup/gram.y"
    {
		/* data is for staff with only one voice */
		save_vno_range(1, 1);
		add_to_sv_list();
	}
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 3601 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) == YES) {
			add_to_sv_list();
		}
	}
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 3610 "src/mup/gram.y"
    {
		/* set flag as to whether we are processing tab staff
		 * information or normal staff info */
		Doing_tab_staff = is_tab_range();
	}
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 3620 "src/mup/gram.y"
    {
		/* several staffs have the same note data */
		Defining_multiple = YES;
	}
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 3626 "src/mup/gram.y"
    {
		/* remember which staffs we are currently getting data for */
		/* if only a single number, not a range, staff_range will be
		 * 0, so use staffnum as high and low of range */
		save_staff_range((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)));
	}
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 3634 "src/mup/gram.y"
    {
		/* empty - no range, just a single number */
		(yyval.intval) = 0;
	}
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 3641 "src/mup/gram.y"
    {
		Defining_multiple = YES;
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 3651 "src/mup/gram.y"
    {
		/* note data applies to a single voice */
		if (rangecheck((yyvsp[(1) - (2)].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			save_vno_range((yyvsp[(1) - (2)].intval), (yyvsp[(1) - (2)].intval));
			(yyval.intval) = YES;
		}
		else {
			(yyval.intval) = NO;
		}
	}
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 3664 "src/mup/gram.y"
    {
		/* note data applies to range of voices */
		if (rangecheck((yyvsp[(1) - (4)].intval), MINVOICES, MAXVOICES, "voice") == YES &&
				rangecheck((yyvsp[(3) - (4)].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if ((yyvsp[(3) - (4)].intval) < (yyvsp[(1) - (4)].intval)) {
				l_yyerror(Curr_filename, yylineno,
					"end of voice range is smaller than beginning");
				(yyval.intval) = NO;
			}
			else {
				save_vno_range((yyvsp[(1) - (4)].intval), (yyvsp[(3) - (4)].intval));
				Defining_multiple = YES;
				(yyval.intval) = YES;
			}
		}
		else {
			(yyval.intval) = NO;
		}
	}
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 3689 "src/mup/gram.y"
    {
		Defining_multiple = YES;
	}
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 3704 "src/mup/gram.y"
    {
		/* Associate any TIMEDSSVs with this group */
		if (Curr_tssv_p != 0) {
			tssv_setgrpsyl(Curr_grpsyl_p);
			Curr_tssv_p = 0;
		}

		/* if no custom beaming indicated, fill in based on previous. */
		if ( Curr_grpsyl_p->beamloc == NOITEM) {
			setbeamloc(Curr_grpsyl_p, Last_grpsyl_p);
		}

		/* later we check that if there is an 'm', it is
		 * the only thing in the measure */

		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		Curr_marklist = 0;
		/* Save pointer to this group, in case there are additive
		 * times, and the next group gets its time value from this
		 * group. In that case, we need this group, not the last one
		 * of the added groups. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* Add groups if there were additive time values. */
		if (Extra_time_p != 0) {
			Curr_grpsyl_p = expandgrp(Curr_grpsyl_p, Extra_time_p);
			/* If there was a custom beam ebm on something with
			 * additive time, we need make sure ENDITEM is on only
			 * the last of the expanded groups. */
			if (Curr_grpsyl_p != Prev_grpsyl_p
					&& Prev_grpsyl_p->beamloc == ENDITEM) {
				struct GRPSYL *g_p;
				for (g_p = Prev_grpsyl_p; g_p != Curr_grpsyl_p;
							g_p = g_p->next) {
					g_p->beamloc = INITEM;
				}
				Curr_grpsyl_p->beamloc = ENDITEM;
			}
			Last_grpsyl_p = Curr_grpsyl_p->prev;
		}
		Curr_timelist_p = 0;
	}
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 3762 "src/mup/gram.y"
    {
		if (Chord_at_a_time == YES) {
			yyerror("mid-measure changes not allowed on chord-at-a-time input");
		}
	}
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 3771 "src/mup/gram.y"
    {
		Curr_tssv_p = tssv_create(C_SCORE);
	}
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 3777 "src/mup/gram.y"
    {
		Curr_tssv_p = tssv_create(C_STAFF);
	}
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 3783 "src/mup/gram.y"
    {
		Curr_tssv_p = tssv_create(C_VOICE);
	}
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 3797 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->grpsyl == GS_GROUP
				&& Curr_grpsyl_p->grpvalue == GV_ZERO) {
			yyerror("mid-measure clef change not allowed after grace note\n");
		}
		tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
	}
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 3807 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (3)].intval)) {

		case DEFOCT:
		case RELEASE:
			tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 3824 "src/mup/gram.y"
    {
		switch ((yyvsp[(1) - (3)].intval)) {

		case ALIGNRESTS:
			tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 3844 "src/mup/gram.y"
    {
		if (Good_till_canceled == NO) {
			/* use default attributes */
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_NORMAL;
			Curr_grpsyl_p->headshape = HS_UNKNOWN;
		}
		else {
			/* re-use previous style */
			copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
			Curr_grpsyl_p->with_was_gtc = YES;
		}
	}
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 3860 "src/mup/gram.y"
    {
		Good_till_canceled = NO;
	}
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 3866 "src/mup/gram.y"
    {
	}
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 3870 "src/mup/gram.y"
    {
		Good_till_canceled = NO;
	}
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 3876 "src/mup/gram.y"
    {
		Good_till_canceled = YES;
	}
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 3881 "src/mup/gram.y"
    {
	}
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 3886 "src/mup/gram.y"
    {
		if (Good_till_canceled == YES) {
			yyerror("can't use ... and more than one [] on same chord");
		}
	}
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 3893 "src/mup/gram.y"
    {
		/* NULL token to cause allocation of a GRPSYL struct */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_GROUP);
	}
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 3900 "src/mup/gram.y"
    {
		/* an empty marklist means we should use
		 * the same attributes as the last time */
		copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
	}
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 3917 "src/mup/gram.y"
    {
		Curr_grpsyl_p->nwith = (short) Item_count;
		Curr_grpsyl_p->withlist = Curr_marklist;
		if ((yyvsp[(4) - (4)].intval) != PL_UNKNOWN) {
			int m;

			/* User specified a side, so remember that */
			for (m = Mark_start; m < Item_count; m++) {
				Curr_marklist[m].place = (yyvsp[(4) - (4)].intval);
			}
		}
	}
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 3941 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->stemdir != UNKNOWN &&
					Curr_grpsyl_p->stemdir != (yyvsp[(1) - (1)].intval)) {
			l_warning(Curr_filename, yylineno,
				"both stem directions specified; using last instance");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"stem direction specification is pointless on tab staff; ignoring");
		}
		else {
			Curr_grpsyl_p->stemdir = (yyvsp[(1) - (1)].intval);
		}
	}
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 3958 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (3)].intval) != DIST) {
			l_warning(Curr_filename, yylineno,
				"unexpected parameter name; ignoring");
		}
		else {
			if (Curr_grpsyl_p->restdist != NORESTDIST &&
					Curr_grpsyl_p->restdist != (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval)) {
				l_warning(Curr_filename, yylineno,
						"more than one dist value specified; using last instance");
			}
			Curr_grpsyl_p->restdist = (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval);
		}
	}
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 3975 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->ho_usage != HO_NONE &&
				Curr_grpsyl_p->ho_usage != (yyvsp[(2) - (2)].intval)) {
			l_warning(Curr_filename, yylineno,
				"More than one ho type specified; last instance used");
		}
		Curr_grpsyl_p->ho_usage = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 3986 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p != 0) {
			if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
				l_warning(Curr_filename, yylineno,
					"multiple head shapes specified, using last");
			}
			/* +2 to skip past extraneous font/size */
			if (Doing_tab_staff == YES && strcmp((yyvsp[(2) - (2)].stringval) + 2, "allx") != 0) {
				yyerror("allx is the only headshape allowed on tab staffs");
			}
			if ((Curr_grpsyl_p->headshape = get_shape_num((yyvsp[(2) - (2)].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[(2) - (2)].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			pfatal("Curr_grpsyl_p was null for setting hs");
		}
		/* We don't need the name anymore; we have its corresponding
		 * number that we use internally. */
		FREE((yyvsp[(2) - (2)].stringval));
	}
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 4013 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->stemlen != STEMLEN_UNKNOWN &&
				fabs(Curr_grpsyl_p->stemlen - (yyvsp[(2) - (2)].floatval) * STEPSIZE) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"more than one len specified; using last instance");
		}
		Curr_grpsyl_p->stemlen = (yyvsp[(2) - (2)].floatval) * STEPSIZE;
	}
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 4024 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) <= 0) {
			yyerror("slash number must be > 0");
		}
		else if ((yyvsp[(2) - (2)].intval) > 8) {
			/* we decided 8 slashes would be at least 256th note
			 * or shorter, and 256th is the shortest note we
			 * support, 8 slashes is plenty */
			l_warning(Curr_filename, yylineno,
				"number of slashes only allowed to be <= 8; limiting to 8");
			(yyvsp[(2) - (2)].intval) = 8;
		}
		if (Curr_grpsyl_p->slash_alt > 0 &&
					Curr_grpsyl_p->slash_alt != (yyvsp[(2) - (2)].intval)) {
			l_warning(Curr_filename, yylineno,
				"more than one slash value specified; using last instance");
		}
		if (Curr_grpsyl_p->slash_alt < 0) {
			yyerror("only one slash/alt allowed per group");
		}
		Curr_grpsyl_p->slash_alt = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 4049 "src/mup/gram.y"
    {
		(yyval.intval) = HO_RIGHT;
	}
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 4055 "src/mup/gram.y"
    {
		(yyval.intval) = HO_LEFT;
	}
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 4061 "src/mup/gram.y"
    {
		/* We want to silently accept identical values specified
		 * more than once, so use fuzzy compare to deal with roundoff */
		if (Curr_grpsyl_p->ho_usage == HO_VALUE &&
				fabs(Curr_grpsyl_p->ho_value - (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval)) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"More than one ho value specified; last instance used");
		}
		if ((yyvsp[(1) - (2)].intval) == 0) {
			Curr_grpsyl_p->ho_value = (yyvsp[(2) - (2)].floatval);
		}
		else {
			Curr_grpsyl_p->ho_value = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval);
		}
		(yyval.intval) = HO_VALUE;
	}
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 4080 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 4086 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 4108 "src/mup/gram.y"
    {
		(yyvsp[(3) - (3)].floatval) *= (yyvsp[(2) - (3)].intval);
		if (fabs(Curr_grpsyl_p->beamslope - NOBEAMANGLE) > 0.01) {
			l_warning(Curr_filename, yylineno,
				"multiple slope values specified; using last one");
		}
		if (frangecheck((yyvsp[(3) - (3)].floatval), MINBEAMANGLE, MAXBEAMANGLE, "slope") == YES) {
			Curr_grpsyl_p->beamslope = (yyvsp[(3) - (3)].floatval);
		}
	}
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 4121 "src/mup/gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) <= 0) {
			yyerror("alt number must be > 0");
		}
		if (Curr_grpsyl_p->slash_alt != 0) {
			yyerror("only one slash/alt allowed per group");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"alt not allowed on tablature staff; ignoring");
		}
		else {
			/* Should at least keep small enough
			 * that 1 shifted left by this still fits
			 * in a 16-bit int. For a while we limited to 15,
			 * but for slashes, we limit to 8, and
			 * that seems like more than enough for here too. */
			if ((yyvsp[(2) - (2)].intval) > 8) {
				l_warning(Curr_filename, yylineno,
					"alt value too large; limiting to 8");
				(yyvsp[(2) - (2)].intval) = 8;
			}
			Curr_grpsyl_p->slash_alt = -(yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 4149 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->phcount < PH_COUNT) {
			Curr_grpsyl_p->phplace[Curr_grpsyl_p->phcount++] = (yyvsp[(2) - (2)].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many ph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 4161 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->ephcount < PH_COUNT) {
			Curr_grpsyl_p->ephcount++;
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many eph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 4172 "src/mup/gram.y"
    {
		int n;

		/* add a slur to each note in the chord. Don't know
		 * which pitch to slur to yet, just that it will be to
		 * the "matching" note in the next chord, so use
		 * special magic pitch of 'M' to convey this */
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			add_slurto(Curr_grpsyl_p, 'M', USE_DFLT_OCTAVE, n, (yyvsp[(1) - (3)].intval));
			set_slurdir(Curr_grpsyl_p, -1, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval));
		}
	}
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 4187 "src/mup/gram.y"
    {
		int n;

		Curr_grpsyl_p->tie = YES;
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			Curr_grpsyl_p->notelist[n].tie = YES;
			Curr_grpsyl_p->notelist[n].tiestyle = (yyvsp[(1) - (3)].intval);
			Curr_grpsyl_p->notelist[n].tiedir = (yyvsp[(2) - (3)].intval);
			Curr_grpsyl_p->notelist[n].tied_to_voice = (yyvsp[(3) - (3)].intval);
		}
	}
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 4200 "src/mup/gram.y"
    {
		if (Curr_marklist == 0) {
			/* allocate space for a list of marks */
			MALLOC(WITH_ITEM, Curr_marklist, ITEMS);
			Item_count = 0;
			Max_items = ITEMS;
		}
		Mark_start = Item_count;
	}
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 4211 "src/mup/gram.y"
    {
		(yyval.intval) = PL_UNKNOWN;
	}
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 4217 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 4222 "src/mup/gram.y"
    {
		(yyval.intval) = UNKNOWN;
	}
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 4228 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 4234 "src/mup/gram.y"
    {
		(yyval.intval) = NO_TO_VOICE;
	}
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 4240 "src/mup/gram.y"
    {
		if ((yyvsp[(3) - (3)].intval) >= MINVOICES && (yyvsp[(3) - (3)].intval) <= MAXVOICES) {
			/* Note that if the current staff doesn't have this
			 * to voice, that error will be caught later,
			 * by find_to_group() in tie.c */
			(yyval.intval) = (yyvsp[(3) - (3)].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"to voice must be between %d and %d",
					MINVOICES, MAXVOICES);
			(yyval.intval) = NO_TO_VOICE;
		}
	}
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 4263 "src/mup/gram.y"
    {
		/* if too many items, get some more space */
		if (Item_count >= Max_items) {
			Max_items += ITEMS;
			if ((Curr_marklist = (struct WITH_ITEM *) realloc(Curr_marklist,
						Max_items * sizeof(struct WITH_ITEM)))
						==  0) {
				l_no_mem(__FILE__, __LINE__);
			}
		}
		Curr_marklist[Item_count].string = (yyvsp[(1) - (1)].stringval);
		Curr_marklist[Item_count].place = PL_UNKNOWN;
		Item_count++;
	}
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 4279 "src/mup/gram.y"
    {
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[(1) - (1)].stringval)) + 3);
		(yyval.stringval)[0] = FONT_TR;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "%s", (yyvsp[(1) - (1)].stringval));
	}
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 4292 "src/mup/gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(dot)" : "\\(smdot)");
	}
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 4299 "src/mup/gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(leg)" : "\\(smleg)");
	}
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 4306 "src/mup/gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_gt)" : "\\(smacc_gt)");
	}
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 4313 "src/mup/gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_hat)" : "\\(smacc_hat)");
	}
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 4319 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 4331 "src/mup/gram.y"
    {
		Curr_grpsyl_p->grpvalue = GV_ZERO;
		if (Curr_grpsyl_p->grpsize == GS_SMALL) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 4343 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"diam is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num("diam");
	}
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 4353 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"xnote is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num(
					Doing_tab_staff == YES ? "allx" : "x");
	}
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 4364 "src/mup/gram.y"
    {
		(yyval.intval) = UP;
	}
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 4370 "src/mup/gram.y"
    {
		(yyval.intval) = DOWN;
	}
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 4376 "src/mup/gram.y"
    {
		/* custom beaming cannot be nested */
		struct GRPSYL *prev_like_gs_p;
		/* Find previous group with same grace-ness. Can't use
		 * prevsimilar() here, since it looks at grpcont too. */
		for (prev_like_gs_p = Last_grpsyl_p; prev_like_gs_p != 0 &&
			prev_like_gs_p->grpvalue != Curr_grpsyl_p->grpvalue;
			prev_like_gs_p = prev_like_gs_p->prev) {
			;
		}
		if (prev_like_gs_p != 0 &&
				((prev_like_gs_p->beamloc == STARTITEM)
				|| (prev_like_gs_p->beamloc == INITEM)) ) {
			yyerror("custom beaming may not be nested");
		}
		/* Non-custom beaming, if any, is done later, in do_bar() */
		else {
			/* begin custom beaming */
			Curr_grpsyl_p->beamloc = STARTITEM;
			if (Curr_grpsyl_p->basictime < 8 && (yyvsp[(2) - (2)].intval) == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
		Curr_grpsyl_p->beamto = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 4404 "src/mup/gram.y"
    {
		Curr_grpsyl_p->breakbeam = YES;
	}
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 4410 "src/mup/gram.y"
    {
		struct GRPSYL *last_nongrace_p;

		/* find the previous group, skipping grace groups */
		for (last_nongrace_p = Last_grpsyl_p;
				last_nongrace_p != (struct GRPSYL *) 0
				&& last_nongrace_p->grpvalue == GV_ZERO;
				last_nongrace_p = last_nongrace_p->prev) {
			;
		}

		/* check that a custom beam is in progress */
		if ((last_nongrace_p == (struct GRPSYL *) 0)
				|| ((last_nongrace_p != (struct GRPSYL *) 0)
				&& (last_nongrace_p->beamloc != STARTITEM)
				&& (last_nongrace_p->beamloc != INITEM) )) {
			l_warning(Curr_filename, yylineno,
				"'ebm' unexpected: no custom beaming in progress; ignoring");
		}
		else {
			Curr_grpsyl_p->beamloc = ENDITEM;
			Curr_grpsyl_p->beamto = last_nongrace_p->beamto;
			if (Curr_grpsyl_p->basictime < 8
					&& Last_grpsyl_p->beamto == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
	}
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 4440 "src/mup/gram.y"
    {
		/* Use the same as last time or default timeunit.
		 * If that involves additive time values,
		 * save pointer to that info in Extra_time_p for later use. */
		Extra_time_p = copy_timeunit(Curr_grpsyl_p, Prev_grpsyl_p,
						Extra_time_p);
	}
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 4450 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			Curr_grpsyl_p->fulltime = Score.time;
		}
		else {
			Curr_grpsyl_p->fulltime = (yyvsp[(1) - (1)].ratval);
		}
	}
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 4460 "src/mup/gram.y"
    {
		(yyval.intval) = CS_SAME;
	}
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 4466 "src/mup/gram.y"
    {
		CSBused = YES;
		switch ((yyvsp[(3) - (3)].intval)) {
		case PL_ABOVE:
			(yyval.intval) = CS_ABOVE;
			break;
		case PL_BELOW:
			(yyval.intval) = CS_BELOW;
			break;
		default:
			yyerror("bm with staff must be 'above' or 'below'");
			(yyval.intval) = CS_SAME;
		}
	}
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 4482 "src/mup/gram.y"
    {
		(yyval.ratval).n = (yyvsp[(1) - (1)].intval);
		(yyval.ratval).d = 1;

		/* if filling in a GRPSYL struct, need to fill in basic time,
		 * could also be here due to beamstyle, in which case the
		 * Curr_grpsyl_p will be NULL, or when getting tuplet duration,
		 * in which case flag will be set */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* If we are gathering basictime as part of a list
			 * of additive times, we will save the value a few
			 * lines down from here. But in the normal case,
			 * we set basictime in the current GRPSYL. */
			if (Extra_time_p == 0) {
				/* 1/2 is 0 internally. 1/4 is -1 internally */
				 Curr_grpsyl_p->basictime = ((yyvsp[(1) - (1)].intval) == 2 ? 0 : -1);
			}
		}
		/* If doing additive times, need to save value. */
		if (Extra_time_p != 0) {
			Extra_basictime = ((yyvsp[(1) - (1)].intval) == 2 ? 0 : -1);
		}
	}
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 4509 "src/mup/gram.y"
    {
		/* check that a power of two from 1 to MAXBASICTIME */
		if (power_of2check((yyvsp[(1) - (1)].intval), "note basic time value") == NO) {
			/* force to a power to two, so that other code
			 * (like in expandgrp) that expect a sane value
			 * will not blow up. This may lead to a somewhat
			 * misleading "time does not add up to time
			 * signature" message, but we don't know what
			 * time they really meant, and this is better
			 * than pfataling. */
			(yyvsp[(1) - (1)].intval) = 2;
		}
		/* can't use rangecheck here because the error message would
		 * say 0 and -1 are valid times, which is only true internally--
		 * the user has to use 1/2, 1/4 or m. */
		if ((yyvsp[(1) - (1)].intval) < MINBASICTIME || (yyvsp[(1) - (1)].intval) > MAXBASICTIME) {
			l_yyerror(Curr_filename, yylineno,
				"time value must be between 1 and %d, or 1/2 or 1/4 or m",
				MAXBASICTIME);
			/* If user entered outrageous value, clamp to
			 * something semi-reasonable, else we could get
			 * rational overflow, and pfatal, even though it
			 * it is really a user error. */
			if ((yyvsp[(1) - (1)].intval) > MAXBASICTIME * 4) {
				(yyvsp[(1) - (1)].intval) = MAXBASICTIME * 4;
			}
		}
		(yyval.ratval).n = 1;
		/* avoid division by zero */
		if ((yyvsp[(1) - (1)].intval) == 0) {
			(yyvsp[(1) - (1)].intval) = 1;
		}
		(yyval.ratval).d = (yyvsp[(1) - (1)].intval);
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			if (Curr_timelist_p == 0) {
				Curr_grpsyl_p->basictime = (yyvsp[(1) - (1)].intval);
			}
		}
		/* If doing additive times, need to save value */
		if (Extra_time_p != 0) {
			Extra_basictime = (yyvsp[(1) - (1)].intval);
		}
	}
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 4556 "src/mup/gram.y"
    {
		free_extra_time();
	}
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 4566 "src/mup/gram.y"
    {
		/* Set basictime to what we saved in basic_time_val rule,
		 * then calculate fulltime from that and number of dots. */
		Curr_timelist_p->basictime = Extra_basictime;
		Curr_timelist_p->fulltime = calcfulltime((yyvsp[(3) - (4)].ratval), (yyvsp[(4) - (4)].intval));
		/* handle subtracted times by negating the fulltime */
		if ((yyvsp[(1) - (4)].intval) == -1) {
			Curr_timelist_p->fulltime = rneg(Curr_timelist_p->fulltime);
		}
	}
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 4580 "src/mup/gram.y"
    {
		struct TIMELIST *timelist_p;

		MALLOC(TIMELIST, timelist_p, 1);
		/* Add to end of linked list */
		timelist_p->next = 0;
		/* Init fulltime to something to avoid garbage if there
		 * in a user input error */
		timelist_p->fulltime = Zero;
		if (Extra_time_p == 0) {
			Last_alloced_timelist_p = Extra_time_p = timelist_p;
		}
		else {
			Curr_timelist_p->next = timelist_p;
		}
		/* Keep track of where to append next item to list, if any */
		Curr_timelist_p = timelist_p;
	}
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 4601 "src/mup/gram.y"
    {
		User_meas_time = NO;
	}
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 4607 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = YES;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 4619 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 4625 "src/mup/gram.y"
    {
		/* count up the number of dots */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 4631 "src/mup/gram.y"
    {
		/* We can't distinguish between the default 0.0 and
		 * if user explicitly sets to 0.0, so if they set to 0.0
		 * then to something else, we won't catch that as setting
		 * twice, but that shouldn't be common. Besides, if they
		 * expect them to be additive, adding to zero will work
		 * as they expect... Because of roundoff, we can't do
		 * exact compare for specifying the same value more than once,
		 * so treat as identical if pretty close. */
		if (Curr_grpsyl_p->padding != 0.0 && 
				fabs(Curr_grpsyl_p->padding - ((yyvsp[(1) - (1)].floatval) * STEPSIZE))
				> 0.0001) {
			l_warning(Curr_filename, yylineno,
				"padding specified more than once; using last instance");
		}
		Curr_grpsyl_p->padding = (yyvsp[(1) - (1)].floatval) * STEPSIZE;
	}
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 4651 "src/mup/gram.y"
    {
		(yyval.floatval) = (float) (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].floatval);
	}
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 4656 "src/mup/gram.y"
    {
		/* no sign--must be a positive number */
		(yyval.intval) = 1;
	}
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 4663 "src/mup/gram.y"
    {
		/* user wants a negative number */
		(yyval.intval) = -1;
	}
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 4669 "src/mup/gram.y"
    {
		Curr_grpsyl_p->grpcont = GC_NOTES;
		if ((yyvsp[(1) - (1)].intval) == 0) {
			/* no notes listed, use same as previous group */
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else {
			resize_notelist(Curr_grpsyl_p);
		}
	}
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 4694 "src/mup/gram.y"
    {
		/* allocate GRPSYL for the case where everything is defaulted
		 * from the previous group, with just an extra attribute
		 * like ? or ~ specified. */
		if (Curr_grpsyl_p == (struct GRPSYL *) 0) {
			/* shouldn't ever happen, but just in case... */
			Curr_grpsyl_p = newGRPSYL(GS_GROUP);
		}
		if (Last_grpsyl_p != (struct GRPSYL *) 0 &&
					Last_grpsyl_p->nnotes >= 1) {
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else if (Last_grpsyl_p != (struct GRPSYL *) 0 && 
				Last_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpcont = GC_REST;
		}
	}
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 4714 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_TINY;
			}
			else {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_SMALL;
			}
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpsize  = GS_SMALL;
		}
		else {
			yyerror("no note specified for '?'");
		}
	}
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 4736 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->grpcont != GC_NOTES) {
			yyerror("can't tie a rest or space");
		}
		else if (Curr_grpsyl_p->nnotes > 0) {
			struct NOTE *n_p;
			n_p = &(Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]);
			n_p->tie = YES;
			n_p->tiestyle = (yyvsp[(1) - (3)].intval);
			n_p->tiedir = (yyvsp[(2) - (3)].intval);
			n_p->tied_to_voice = (yyvsp[(3) - (3)].intval);
		}
		else {
			yyerror("no note specified for '~'");
		}
	}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 4755 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->nnotes > 0) {
			switch (Curr_grpsyl_p->notelist
                                        [Curr_grpsyl_p->nnotes - 1].letter) {
			case PP_REST:
				/* If we haven't already allocated space for
				 * the restc array, so that now. It could
				 * already be allocated if user specified
				 * more than one tag. */
				if (Curr_grpsyl_p->restc == 0) {
					MALLOCA(float, Curr_grpsyl_p->restc, NUMCTYPE);
				}
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->restc, CT_NOTE);
				break;
			case PP_SPACE:
			case PP_RPT:
			case PP_NO_PITCH:  /* this one not really possible */
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
				break;
			default:
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->notelist
					[Curr_grpsyl_p->nnotes - 1].c, CT_NOTE);
				break;
			}
			var_valid();
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			/* This should really never be hit anymore since
			 * chord-at-a-time code was added, but shouldn't
			 * hurt to leave it, just in case. */
			addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"no note specified for location tag '%s'", (yyvsp[(2) - (2)].stringval));
		}
	}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 4796 "src/mup/gram.y"
    {
		/* this is for bend on a non-tablature staff */
		if (Doing_tab_staff == YES) {
			yyerror("^ bend not allowed on tablature staff; use quoted bend string");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval),
					Curr_grpsyl_p->nnotes - 1, L_NORMAL);
			if (Curr_grpsyl_p->nnotes > 0) {
				Curr_grpsyl_p->notelist
						[Curr_grpsyl_p->nnotes - 1]
						.is_bend = YES;
			}
		}
	}
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 4814 "src/mup/gram.y"
    {
		/* this is for a small bend (1/4 step) on a non-tab staff */
		if (Doing_tab_staff == YES) {
			yyerror("^/ not allowed on tablature staff; use quoted bend string");
		}
		else if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->nnotes > 0) {
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.smallbend = YES;
		}
	}
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 4827 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if ((Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.headshape = get_shape_num((yyvsp[(2) - (2)].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[(2) - (2)].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			yyerror("no note specified for headshape");
		}
		FREE((yyvsp[(2) - (2)].stringval));
	}
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 4856 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + (yyvsp[(2) - (2)].intval);	/* total number of notes */
	}
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 4862 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 4868 "src/mup/gram.y"
    {
		switch ((yyvsp[(3) - (3)].intval)) {
		case PL_ABOVE:
			Curr_grpsyl_p->stemto = CS_ABOVE;
			break;
		case PL_BELOW:
			Curr_grpsyl_p->stemto = CS_BELOW;
			break;
		default:
			yyerror("cross staff stem must be with 'above' or 'below'");
			Curr_grpsyl_p->stemto = CS_SAME;
		}
		if ((yyvsp[(2) - (3)].intval) == 0) {
			/* Maybe this wouldn't really hurt to allow,
			 * but it's rather silly--why would user bother to go
			 * to the trouble of saying there are cross staff stem
			 * notes, but then not list any?
			 */
			yyerror("cross-staff stem note list is empty");
		}

		/* It doesn't make sense to do "with r below" or "with s below"
		 * since we don't allow mixing rests and notes, and the only
		 * reason for CSS is for something that has a stem. */
		else if ((yyvsp[(2) - (3)].intval) > 0) {
			int idx;
			int pitch;

			for (idx = FCNI(Curr_grpsyl_p);
					idx <= LCNI(Curr_grpsyl_p); idx++) {
				pitch = Curr_grpsyl_p->notelist[idx].letter;
				if (pitch == PP_REST || pitch == PP_SPACE) {
					yyerror("can't use with above/below on rest or space");
				}
			}
		}
		(yyval.intval) = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 4908 "src/mup/gram.y"
    {
		CSSused = YES;
		Curr_grpsyl_p->stemto_idx = Curr_grpsyl_p->nnotes;
	}
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 4914 "src/mup/gram.y"
    {
		/* No notes.  If this is for the list of "normal" staff notes,
		 * and there are no "other" staff notes (for cross-staff stems),
		 * this means use the same notes as the last group. */
		(yyval.intval) = 0;
	}
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 4923 "src/mup/gram.y"
    {
		/* return number of notes in notelist */
		(yyval.intval) = (yyvsp[(1) - (3)].intval) + 1;
	}
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 4932 "src/mup/gram.y"
    {
		add_note(Curr_grpsyl_p, (int) PP_REST, No_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
	}
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 4939 "src/mup/gram.y"
    {
		/* temporarily stash uncompressibility (NO in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, NO,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure space is pointless; ignoring");
		}
	}
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 4952 "src/mup/gram.y"
    {
		/* temporarily stash uncompressibility (YES in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, YES,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure uncollapseable space is pointless; ignoring");
		}
	}
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 4965 "src/mup/gram.y"
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			if (User_meas_time == YES) {
				l_warning(Curr_filename, yylineno,
					"specifying time value on measure repeat is pointless; ignoring");
			}
		}
		else {
			yyerror("rpt can only be used with m");
		}
		add_note(Curr_grpsyl_p, (int) PP_RPT, No_accs, USE_DFLT_OCTAVE,
							0, NO, (char *) 0);
	}
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 4981 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == SINGLEBAR) {
			/* lexer thinks this is 'bar'
			 * but is really 'b' 'a' 'r' */
			keyword_notes(yytext);
		}
		else if ((yyvsp[(1) - (1)].intval) == ENDBAR) {
			/* lexer thinks this is 'endbar'
			 * but is really 'en' 'd' 'b' 'a' 'r' */
			add_acc("nat");
			add_note(Curr_grpsyl_p, (int) 'e', Curr_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
			keyword_notes(yytext + 2);
		}
		else {
			yyerror("bar type not valid here");
		}
	}
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 5002 "src/mup/gram.y"
    {
		/* lexer thinks this is 'grace' but really 'g' 'r' 'a' 'c' 'e' */
		keyword_notes(yytext);
	}
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 5009 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == ENDING_BARRED) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 5020 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == J_RAGPARA) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 5032 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == BRACELIST) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 5044 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == BASS) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 5056 "src/mup/gram.y"
    {
		/* in chord-at-time mode, lex could mistake useaccs
		 * for a 6-note chord: us e a c c s  */
		keyword_notes(yytext);
	}
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 5064 "src/mup/gram.y"
    {
		Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].note_has_paren = YES;
	}
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 5069 "src/mup/gram.y"
    {
		if (Doing_tab_staff == YES) {
			add_note(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), No_accs, NOFRET, 0, NO, (yyvsp[(2) - (2)].stringval));
		}
		else {
			add_note(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), No_accs, USE_DFLT_OCTAVE,
								0, NO, (yyvsp[(2) - (2)].stringval));
		}
	}
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 5081 "src/mup/gram.y"
    {
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"parentheses around accidentals are extraneous on tab staffs; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(5) - (5)].intval), 0, YES, (char *) 0);
	}
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 5091 "src/mup/gram.y"
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"parentheses around octave are extraneous; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), No_accs, (yyvsp[(3) - (5)].intval), 0, YES, (yyvsp[(5) - (5)].stringval));
	}
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 5101 "src/mup/gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (3)].intval), No_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			0, NO, (char *) 0);
	}
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 5117 "src/mup/gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(4) - (5)].intval), (yyvsp[(3) - (5)].intval), NO, (yyvsp[(5) - (5)].stringval));
	}
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 5123 "src/mup/gram.y"
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"extraneous parentheses around octave; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (7)].intval), Curr_accs, (yyvsp[(5) - (7)].intval), (yyvsp[(3) - (7)].intval), YES, (yyvsp[(7) - (7)].stringval));
	}
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 5133 "src/mup/gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			(yyvsp[(3) - (5)].intval), NO, (char *) 0);
	}
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 5149 "src/mup/gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), No_accs, (yyvsp[(3) - (4)].intval), (yyvsp[(2) - (4)].intval), NO, (yyvsp[(4) - (4)].stringval));
	}
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 5155 "src/mup/gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (6)].intval), No_accs, (yyvsp[(4) - (6)].intval), (yyvsp[(2) - (6)].intval), YES, (yyvsp[(6) - (6)].stringval));
	}
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 5161 "src/mup/gram.y"
    {
		if (Doing_tab_staff == YES && Curr_accs[0] != '\0') {
			yyerror("accidental must be before fret number");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), Curr_accs, (yyvsp[(2) - (4)].intval), 0, NO, (yyvsp[(4) - (4)].stringval));
	}
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 5170 "src/mup/gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(2) - (5)].intval), 0, YES, (char *) 0);
	}
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 5176 "src/mup/gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), No_accs, (yyvsp[(2) - (4)].intval), 0, NO, (char *) 0);
	}
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 5189 "src/mup/gram.y"
    {
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 5195 "src/mup/gram.y"
    {
		if (Doing_tab_staff == NO) {
			/* try to give helpful error message */
			if (get_shape_num((yyvsp[(1) - (1)].stringval) + 2) != HS_UNKNOWN) {
				yyerror("missing 'hs' before headshape string");
			}
			else if (strcmp((yyvsp[(1) - (1)].stringval) + 2, "full") == 0 || isdigit((yyvsp[(1) - (1)].stringval)[2])) {
				yyerror("bend string not allowed on non-tablature staff; use ^");
			}
			else {
				yyerror("unexpected string");
			}
			(yyval.stringval) = (char *) 0;
		}
	}
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 5212 "src/mup/gram.y"
    {
		/* return 'a' to 'g' value */
		(yyval.intval) = (int) *yytext;
	}
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 5218 "src/mup/gram.y"
    {
		/* no accidental */
		(yyval.intval) = 0;
	}
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 5225 "src/mup/gram.y"
    {
	}
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 5229 "src/mup/gram.y"
    {
		clear_curr_accs();
	}
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 5235 "src/mup/gram.y"
    {
	}
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 5238 "src/mup/gram.y"
    {
		/* no octave or fret designation */
		(yyval.intval) = (Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE);
	}
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 5245 "src/mup/gram.y"
    {
	}
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 5250 "src/mup/gram.y"
    {
	}
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 5254 "src/mup/gram.y"
    {
		clear_curr_accs();
	}
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 5259 "src/mup/gram.y"
    {
	}
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 5264 "src/mup/gram.y"
    {
	}
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 5269 "src/mup/gram.y"
    {
		add_acc("sharp");
	}
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 5275 "src/mup/gram.y"
    {
		add_acc("flat");
	}
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 5281 "src/mup/gram.y"
    {
		add_acc("nat");
	}
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 5287 "src/mup/gram.y"
    {
		add_acc("dblsharp");
	}
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 5293 "src/mup/gram.y"
    {
		add_acc("dblflat");
	}
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 5299 "src/mup/gram.y"
    {
		add_acc((yyvsp[(2) - (3)].stringval) + 2);
		Tuning_used = YES;
	}
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 5306 "src/mup/gram.y"
    {
		(yyval.intval) = '#';
	}
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 5312 "src/mup/gram.y"
    {
		(yyval.intval) = '&';
	}
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 5318 "src/mup/gram.y"
    {
		/* natural */
		(yyval.intval) = 'n';
	}
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 5325 "src/mup/gram.y"
    {
		/* double sharp */
		(yyval.intval) = 'x';
	}
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 5332 "src/mup/gram.y"
    {
		(yyval.intval) = 'B';
	}
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 5338 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 5344 "src/mup/gram.y"
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		/* this will be a negative number */
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 5356 "src/mup/gram.y"
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		(yyval.intval) = USE_DFLT_OCTAVE + (yyvsp[(1) - (1)].intval);
	}
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 5366 "src/mup/gram.y"
    {
		(yyval.intval) = -1;
	}
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 5372 "src/mup/gram.y"
    {
		/* count up the number of minus signs */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) - 1;
	}
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 5378 "src/mup/gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 5384 "src/mup/gram.y"
    {
		/* count up the number of plus signs */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 5391 "src/mup/gram.y"
    {
		set_slurdir(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1, (yyvsp[(4) - (5)].intval), (yyvsp[(5) - (5)].intval));
	}
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 5398 "src/mup/gram.y"
    {
		Linetype = (yyvsp[(1) - (1)].intval);
		begin_slur(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1);
	}
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 5404 "src/mup/gram.y"
    {
		/* empty list. Only allowed if only one note in following
		 * group. However, we don't know that yet, so marked pitch
		 * as 'U' for unknown */
		add_slurto(Curr_grpsyl_p, 'U', USE_DFLT_OCTAVE,
				Curr_grpsyl_p->nnotes - 1, Linetype);
	}
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 5414 "src/mup/gram.y"
    {
		add_slurto(Curr_grpsyl_p, 0, (yyvsp[(1) - (1)].intval), Curr_grpsyl_p->nnotes - 1,
						Linetype);
	}
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 5432 "src/mup/gram.y"
    {
		if (Doing_tab_staff == YES) {
			yyerror("cannot specify string inside <> on tab staffs");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval),
					Curr_grpsyl_p->nnotes - 1, Linetype);
		}
	}
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 5444 "src/mup/gram.y"
    {
		/* save address associated with entire group */
		if ( (yyvsp[(2) - (2)].stringval) != (char *) 0) {
			addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
	}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 5453 "src/mup/gram.y"
    {
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 5459 "src/mup/gram.y"
    {
		/* a-g are usually pitches, but in this context, they
		 * are 1-character variable names. */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 5467 "src/mup/gram.y"
    {
		/* usually m means measure, but here it is the variable m */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 5474 "src/mup/gram.y"
    {
		/* usually rest, here variable r */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 5481 "src/mup/gram.y"
    {
		/* usually space, here variable s */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 5488 "src/mup/gram.y"
    {
		/* usually uncompressible, here variable u */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 5495 "src/mup/gram.y"
    {
		/* usually natural, here variable n */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 5502 "src/mup/gram.y"
    {
		/* usually double sharp, here variable x */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 5509 "src/mup/gram.y"
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 5516 "src/mup/gram.y"
    {
		(void) sprintf(Stringbuff + strlen((yyvsp[(1) - (3)].stringval)), ".%d", (yyvsp[(3) - (3)].intval));
		(yyval.stringval) = Stringbuff;
	}
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 5523 "src/mup/gram.y"
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 5530 "src/mup/gram.y"
    {
		end_tuplet((yyvsp[(5) - (8)].intval), (yyvsp[(7) - (8)].ratval), (yyvsp[(6) - (8)].intval), (yyvsp[(4) - (8)].intval));
		Getting_tup_dur = NO;
	}
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 5536 "src/mup/gram.y"
    {
		/* nothing -- use default of when to print tuplet number/bracket */
		(yyval.intval) = PT_DEFAULT;
	}
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 5543 "src/mup/gram.y"
    {
		/* don't print tuplet or bracket */
		(yyval.intval) = PT_NEITHER;
	}
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 5550 "src/mup/gram.y"
    {
		/* print number only */
		(yyval.intval) = PT_NUMBER;
	}
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 5557 "src/mup/gram.y"
    {
		if (*yytext == 'y') {
			(yyval.intval) = PT_BOTH;
		}
		else {
			yyerror("tuplet number/bracket qualifier must be y or n or num");
		}
	}
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 5569 "src/mup/gram.y"
    {
		begin_tuplet();
	}
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 5574 "src/mup/gram.y"
    {
		Getting_tup_dur = YES;
	}
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 5579 "src/mup/gram.y"
    {
		(yyval.intval) = PL_UNKNOWN;
	}
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 5585 "src/mup/gram.y"
    {
		if (yylval.intval == PL_BETWEEN) {
			yyerror("between not allowed for tuplet side");
			(yyval.intval) = PL_UNKNOWN;
		}
	}
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 5593 "src/mup/gram.y"
    {
		/* optional time value is missing */
		(yyval.ratval).n = 0;
		(yyval.ratval).d = 1;
	}
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 5601 "src/mup/gram.y"
    {
		(yyval.ratval) = (yyvsp[(2) - (2)].ratval);
	}
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 5606 "src/mup/gram.y"
    {
	}
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 5610 "src/mup/gram.y"
    {
		Last_grpsyl_p = Curr_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 5615 "src/mup/gram.y"
    {
		/* If user does "all" without specifying a place,
		 * all() will call dflt_place() which was really intended
		 * to only handle STUFF. So we have to tell it we have lyrics,
		 * not a true STUFF. */
		set_stuff_type(-1);
	}
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 5624 "src/mup/gram.y"
    {
		Using_staff = -1;
		Using_voice = -1;
	}
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 5631 "src/mup/gram.y"
    {
		Using_staff = (yyvsp[(2) - (2)].intval);
		Using_voice = 1;
	}
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 5638 "src/mup/gram.y"
    {
		Using_staff = (yyvsp[(2) - (3)].intval);
		Using_voice = (yyvsp[(3) - (3)].intval);
	}
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 5644 "src/mup/gram.y"
    {
		/* empty, use default */
		begin_range(PL_UNKNOWN);
		(yyval.intval) = PL_UNKNOWN;
	}
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 5652 "src/mup/gram.y"
    {
		begin_range((yyvsp[(1) - (1)].intval));
	}
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 5657 "src/mup/gram.y"
    {
		(yyval.intval)= PL_UNKNOWN;
	}
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 5663 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == PL_BETWEEN) {
			yyerror("place for ph, if specified, must be above or below, not between");
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 5674 "src/mup/gram.y"
    {
		/* means goes above or below all the staffs, regardless if
		 * some happen to be invisible at the moment, so find top
		 * or bottom visible staff as appropriate,and save that
		 * away as the staff range */
		all();
	}
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 5687 "src/mup/gram.y"
    {
		/* if staff_range == 0, then only one staff specified, so
		 * use first staff number for both beginning and end of range */
		save_staff_range((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)) );
	}
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 5694 "src/mup/gram.y"
    {
		/* empty */
		chk_range_type(NO);
		(yyval.intval) = 0;
	}
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 5702 "src/mup/gram.y"
    {
		chk_range_type(NO);
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 5712 "src/mup/gram.y"
    {
		chk_range_type(YES);
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 5721 "src/mup/gram.y"
    { Place = (yyvsp[(3) - (3)].intval); }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 5726 "src/mup/gram.y"
    {
	}
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 5731 "src/mup/gram.y"
    {
		if (*yytext != 'c') {
			yyerror("verse must be 'c' or number(s)");
		}
		else {
			save_vno_range(0, 0);
		}
	}
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 5742 "src/mup/gram.y"
    {
	}
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 5747 "src/mup/gram.y"
    {
	}
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 5752 "src/mup/gram.y"
    {
		/* if end of range is 0, not really a range, use first number
		 * for both beginning and end */
		lyr_verse((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)));
	}
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 5759 "src/mup/gram.y"
    {
		/* empty */
		(yyval.intval) = 0;
	}
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 5766 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 5771 "src/mup/gram.y"
    {
		/* null token to allocate a GRPSYL for a lyric */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_SYLLABLE);
		if (Last_grpsyl_p == (struct GRPSYL *) 0) {
			Lyrics_p = Curr_grpsyl_p;
		}
	}
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 5781 "src/mup/gram.y"
    {
		/* If user didn't specify a place, fix that. */
		if (Place == PL_UNKNOWN) {
			Place = PL_BELOW;
		}
		/* copies of the lyrics info has been made for all staffs/verses
		 * at this point, so get rid of master copy */
		free_grpsyls(Lyrics_p);
	}
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 5792 "src/mup/gram.y"
    {
		/* empty -- need to derive times from music */
		Lyrics_p = derive_lyrtime();
	}
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 5799 "src/mup/gram.y"
    {
		not_derived();
	}
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 5814 "src/mup/gram.y"
    {
		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		/* Save pointer to current GRPSYL in case the next
		 * group gets its time value based on this one,
		 * and there are additive times on this one. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* If there are additive times, add those in.
		 * We don't need to make extra groups for lyrics, because we
		 * don't need to tie groups together--the lyrics time
		 * can hold any legal RATIONAL, even those that aren't
		 * specifiable with a single time value. */
		if (Extra_time_p != 0) {
			struct TIMELIST *timelist_p;
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = timelist_p->next) {
				Curr_grpsyl_p->fulltime = radd(Curr_grpsyl_p->fulltime, timelist_p->fulltime);
			}
		}
	}
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 5836 "src/mup/gram.y"
    {
	}
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 5840 "src/mup/gram.y"
    {
		end_tuplet((yyvsp[(4) - (5)].intval), (yyvsp[(5) - (5)].ratval), NO, PL_UNKNOWN);
		Getting_tup_dur = NO;
	}
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 5846 "src/mup/gram.y"
    {
		/* empty, will fill in an actual syllable later */
		Curr_grpsyl_p->syl = (char *) 0;
	}
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 5853 "src/mup/gram.y"
    {
		/* space, not a lyric, so mark for later use */
		Curr_grpsyl_p->grpcont = GC_SPACE;
	}
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 5866 "src/mup/gram.y"
    {
		/* If no [verseno] is specified, use -1 as special flag
		 * to be resolved later to "one more than previous",
		 * or if there wasn't a previous, to verse 1.
		 */
		lyr_verse(-1, -1);
		proc_lyrics(Lyrics_p, (yyvsp[(1) - (2)].stringval));
	}
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 5877 "src/mup/gram.y"
    {
		proc_lyrics(Lyrics_p, (yyvsp[(4) - (5)].stringval));
	}
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 5882 "src/mup/gram.y"
    {
		/* If user set measnum=every N and did not already put some
		 * kind of reh mark on this bar, and this measure is a
		 * multiple of N, we add a mnum mark,
		 * but using measnumstyle */
		if (Currstruct_p != 0 && IS_EVERY(Score.measnum) &&
				Currstruct_p->u.bar_p->reh_type == REH_NONE &&
				Meas_num % Score.measnum == 0) {
			Currstruct_p->u.bar_p->reh_type = REH_BAR_MNUM;
			/* Do like the code in set_reh_string() except use the
			 * measnum* parameters for family, font, and size. */
			Currstruct_p->u.bar_p->reh_string =
					copy_string(num2str(Meas_num) + 2,
                        		Score.measnumfamily + Score.measnumfont,
                        		Score.measnumsize);
		}

		Currstruct_p = (struct MAINLL *) 0;
		/* If there are alternating time signature,
		 * add an implicit time signature SSV for the
		 * next time signature in the list.
		 */
		if (Alt_timesig_list != 0) {
			end_prev_context();
			Context = C_SCORE;
			Currstruct_p = newMAINLLstruct(S_SSV, -1);
			Currstruct_p->u.ssv_p->context = Context;
			if (Tsig_visibility == PTS_ALWAYS &&
					Next_alt_timesig != Alt_timesig_list) {
				/* If user wants alternating time signatures
				 * printed on every measure, if there is
				 * a multirest, we will print multiple
				 * time signatures there, and might have to
				 * wrap around to the beginning of the list.
				 * So make a copy of the entire list,
				 * starting from wherever we are now,
				 * wrapping around to the beginning,
				 * and ending just before where we are now.
				 * Most of the time,
				 * there probably won't be a multirest,
				 * so this will be a waste, but unfortunately,
				 * we don't know yet whether there will be
				 * one or not, so need to do the whole list
				 * just in case.
				 *
				 * Calculate length of the two pieces:
				 * from where we are to end, and from
				 * beginning to where we are.
				 */
				int remlength;
				int wraplength;
				remlength = strlen(Next_alt_timesig);
				wraplength = strlen(Alt_timesig_list)
						- remlength;
				/* need one more for terminator. */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
						remlength + wraplength + 1);

				/* copy remainder into beginning */
				strcpy(Currstruct_p->u.ssv_p->timerep,
						Next_alt_timesig);
				/* copy the wrap-around part of list,
				 * but move the TSR_ALTERNATING from the
				 * end of that part to between the two parts */
				Currstruct_p->u.ssv_p->timerep[remlength]
						= TSR_ALTERNATING;
				strncpy(Currstruct_p->u.ssv_p->timerep +
						remlength + 1, Alt_timesig_list,
						wraplength - 1);
				/* Add the terminator */
				Currstruct_p->u.ssv_p->timerep
						[remlength + wraplength]
						= TSR_END;

				assign_timesig(Currstruct_p, PTS_ALWAYS,
							&Next_alt_timesig);


				/* Make this new copy the new
				 * head of the list */
				Alt_timesig_list =
						Currstruct_p->u.ssv_p->timerep;
			}
			else {
				/* make a copy of the remaining alternating
				 * signatures and assign that */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
					strlen(Next_alt_timesig) + 1);
				strcpy(Currstruct_p->u.ssv_p->timerep,
							Next_alt_timesig);
				assign_timesig(Currstruct_p,
					(Tsig_visibility == PTS_ALWAYS ?
					PTS_ALWAYS : PTS_NEVER),
					&Next_alt_timesig);

				/* If we reached end of list, start over */
				if (Next_alt_timesig == 0) {
					Next_alt_timesig = Alt_timesig_list;
				}
			}

			asgnssv(Currstruct_p->u.ssv_p);
			end_prev_context();
			Context = C_MUSIC;
		}
	}
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 5997 "src/mup/gram.y"
    {
		struct MAINLL * mll_p;
		char *name;


		name = (yylval.intval == YES ? "newpage" : "newscore");

		(void) contextcheck(C_MUSIC | C_BLOCK, name);
		if (Mainlltc_p != 0 && Mainlltc_p->str == S_FEED) {
			/* Must be in block; Last thing on the list is a
			 * FEED, and it is illegal to have two FEEDs in a
			 * row, we just reuse the existing */
			Currstruct_p = Mainlltc_p;
			/* If this need feed is a pagefeed, set that in the
			 * existing struct. If not, leave it however it was.
			 * Otherwise if it was already a pagefeed, we would
			 * be downgrading, and we probably want to max */
			if ((yyvsp[(1) - (1)].intval) == YES) {
				Currstruct_p->u.feed_p->pagefeed = (yyvsp[(1) - (1)].intval);
			}
		}
		else {
			Currstruct_p = newMAINLLstruct(S_FEED, yylineno);
			Currstruct_p->u.feed_p->pagefeed = (yyvsp[(1) - (1)].intval);
		}

		/* make sure we're not in the middle of a measure. Go
		 * backwards in main list. If we hit STAFF before a BAR,
		 * then there is a problem.
		 */
		for (mll_p = Mainlltc_p; mll_p != (struct MAINLL *) 0;
					mll_p = mll_p->prev) {

			if (mll_p->str == S_BAR) {
				break;
			}
			else if (mll_p->str == S_STAFF) {
				l_yyerror(Curr_filename, yylineno,
					"%s not allowed in middle of measure",
					name);
				break;
			}
			else if (mll_p->str == S_FEED) {
				struct MAINLL *m_p;
				/* Need to look backwards for blocks, but need
				 * to ignore any SSVs that are in between */
				for (m_p = mll_p->prev;
						m_p != 0 && m_p->str == S_SSV;
						m_p = m_p->prev) {
					;
				}
				if (m_p != 0 && m_p->str == S_BLOCKHEAD) {
					/* This is a feed following a block.
					 * If it was an implicit feed,
					 * we can get rid of it, because
					 * user now put an explicit one.
					 */
					if (mll_p->inputlineno == -1) {
						unlinkMAINLL(mll_p);
						FREE(mll_p);
					}
					/* We must be in block context,
					 * so no need to check farther back.
					 */
					break;
				}
				else {
					l_yyerror(Curr_filename, yylineno,
						"consecutive newscore/newpage not allowed");
				}
				break;
			}
		}
		/* Add to main list, unless reuing the tail cell FEED */
		if (Currstruct_p != Mainlltc_p) {
			insertMAINLL(Currstruct_p, Mainlltc_p);
		}

		/* If this is inside a block, we need to create a new block
		 * and feed after it.
		 */
		if (Context == C_BLOCK) {
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			set_win_coord(Currblock_p->c);
			Next_print_link_p_p = &(Currblock_p->printdata_p);
			insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
			Mainlltc_p->u.blockhead_p = Currblock_p;
			insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
		}

	}
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 6090 "src/mup/gram.y"
    {
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 6113 "src/mup/gram.y"
    {
		int mot;	/* margin override type */

		if ((yyvsp[(3) - (4)].intval) == 0) {
			/* User didn't specify a sign, so this is an
			 * absolute, not relative value. Or auto. */
			if ((yyvsp[(4) - (4)].floatval) == MG_AUTO) {
				mot = MOT_AUTO;
			}
			else {
				mot = MOT_ABSOLUTE;
			}
		}
		else {
			mot = MOT_RELATIVE;
		}

		if ((yyvsp[(4) - (4)].floatval) > 0.0) {
			(yyvsp[(3) - (4)].intval) = adjust2inches((yyvsp[(3) - (4)].intval));	/* in case we are in centimeter mode */
		}
		if ((yyvsp[(1) - (4)].intval) == RIGHTMARGIN) {
			if (Currstruct_p->u.feed_p->right_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"rightmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->rightmargin = (yyvsp[(4) - (4)].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->rightmargin
						= Score.rightmargin + (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->right_mot = mot;
		}
		else if ((yyvsp[(1) - (4)].intval) == LEFTMARGIN) {
			if (mot == MG_AUTO) {
				l_warning(Curr_filename, yylineno,
					"auto can only be used with rightmargin, not leftmargin; ignoring");
				mot = MOT_UNUSED;
			}
			if (Currstruct_p->u.feed_p->left_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"leftmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->leftmargin = (yyvsp[(4) - (4)].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->leftmargin
						= Score.leftmargin + (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->left_mot = mot;
		}
		else {
			yyerror("unexpected parameter; only 'leftmargin' or 'rightmargin' allowed here");
		}
		chkmargin(Score.topmargin, Score.botmargin,
				Currstruct_p->u.feed_p->leftmargin,
				Currstruct_p->u.feed_p->rightmargin);
	}
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 6183 "src/mup/gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 6189 "src/mup/gram.y"
    {
		(yyval.floatval) = MG_AUTO;
	}
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 6195 "src/mup/gram.y"
    {
		if ( SEP_IS_VALID(Currstruct_p->u.feed_p->scoresep) ) {
			l_warning(Curr_filename, yylineno, "scoresep specified more than once, last being used");
		}
		if ( Currstruct_p->u.feed_p->pagefeed == YES) {
			l_warning(Curr_filename, yylineno, "scoresep ignored on newpage; only used on newscore");
		}
		frangecheck((yyvsp[(4) - (4)].floatval), -MAXSEPVAL, MAXSEPVAL, "scoresep value");
		Currstruct_p->u.feed_p->scoresep = (yyvsp[(3) - (4)].intval) *(yyvsp[(4) - (4)].floatval);
	}
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 6226 "src/mup/gram.y"
    {

		/* build a BAR struct and add it to the main list */
		if (contextcheck(C_MUSIC, "bar") == YES) {

			Currstruct_p = add_bar((yyvsp[(3) - (3)].intval), (yyvsp[(1) - (3)].intval), Endingloc,
						Endending_type, Mainlltc_p);
			Got_ending = NO;
		}
		if ((yyvsp[(3) - (3)].intval) == RESTART && Endingloc != NOITEM) {
			yyerror("restart cannot be used inside an ending");
		}

		/* User can specify bar type to use on preceding staff when
		 * a repeatstart gets moved to the next scores's pseudo-bar */
		if ((yyvsp[(2) - (3)].intval) != -1) {
			if ((yyvsp[(3) - (3)].intval) != REPEATSTART) {
				l_warning(Curr_filename, yylineno,
					"bar type for preceding score only allowed on repeatstart; ignoring");
			}
			else if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = (yyvsp[(2) - (3)].intval);
				if ((yyvsp[(2) - (3)].intval) != SINGLEBAR && (yyvsp[(2) - (3)].intval) != DOUBLEBAR &&
						(Linetype == L_DASHED ||
						Linetype == L_DOTTED)) {
					l_warning(Curr_filename, yylineno,
						"dashed/dotted only allowed on bar or dblbar; ignoring");
					Linetype = L_NORMAL;
				}
				Currstruct_p->u.bar_p->linetype = Linetype;
			}
		}
		else {
			/* Default is single bar. It could be argued that in
			 * the case of a key change on this bar, it really
		 	 * should be a dblbar, but user can force that
			 * if they want it. */
			if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = SINGLEBAR;
			}
		}
		/* Placement phase indirectly uses Doing_tab_staff when it
		 * calls notecomp, so clear it in case we don't get a
		 * non-tab staff input before the end of file.
		 * We could probably get by just doing after parsing is done,
		 * but this seems cleaner, and cheap enough.
		 */
		Doing_tab_staff = NO;
	}
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 6278 "src/mup/gram.y"
    {
		(yyval.intval) = -1;	/* special value to mean "none specified" */
		Linetype = L_NORMAL;
	}
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 6285 "src/mup/gram.y"
    {
		/* Parens wouldn't be strictly necessary to be able to parse,
		 * but seem useful semantically to make it clear this is
		 * optional, only applying when repeatstart is moved to
		 * next score's pseudo bar. */
		(yyval.intval) = (yyvsp[(3) - (4)].intval);
		if ((yyvsp[(2) - (4)].intval) == L_DOTTED || (yyvsp[(2) - (4)].intval) == L_DASHED) {
			if ((yyvsp[(3) - (4)].intval) != SINGLEBAR && (yyvsp[(3) - (4)].intval) != DOUBLEBAR) {
				l_warning(Curr_filename, yylineno,
					"Only bar or dblbar can be dashed or dotted; ignoring");
			}
			else {
				Linetype = (yyvsp[(2) - (4)].intval);
			}
		}
		else if ((yyvsp[(2) - (4)].intval) != L_NORMAL) {
			l_warning(Curr_filename, yylineno,
					"Bar line type modifier can only can be dashed or dotted; ignoring");
		}
	}
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 6307 "src/mup/gram.y"
    {
		/* Call proc_emptymeas() to free up the last buffer, if any,
		 * and return back to normal input stream. */
		proc_emptymeas(MAXSTAFFS+1);
		(yyval.intval) = (yyvsp[(1) - (2)].intval);
	}
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 6315 "src/mup/gram.y"
    {
		/* If there was any empty voices in the input for this
		 * measure which have emptymeas parameter set,
		 * proc_emptymeas() will arrange to create just-in-time
		 * virtual input for it that will get parsed via
		 * the emptymeas_input rule.
		 * We pass arg of 1 to tell it to start looking from
		 * staff 1. Subsequent calls to proc_emptymeas(), if any,
		 * will generate input for additional voices, until
		 * no more are needed for this measure.
		 */
		if ((yyvsp[(1) - (1)].intval) != RESTART) {
			EM_staff = proc_emptymeas(1);
		}
		else {
			/* don't create any music before a restart */
			EM_staff = MAXSTAFFS + 1;
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 6337 "src/mup/gram.y"
    {
	}
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 6342 "src/mup/gram.y"
    {
		/* See if there is any more virtual input needed */
		EM_staff = proc_emptymeas(EM_staff);
	}
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 6355 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->padding += (yyvsp[(1) - (1)].floatval) * STEPSIZE;
		}
	}
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 6363 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			/* fill in location info */
			if ((yyvsp[(2) - (2)].stringval) != (char *) 0) {
				addsym((yyvsp[(2) - (2)].stringval), Currstruct_p->u.bar_p->c, CT_BAR);
			}
		}
	}
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 6374 "src/mup/gram.y"
    {
		if (Got_ending == YES) {
			yyerror("Only one ending allowed per bar");
		}
		Got_ending = YES;

		if (Currstruct_p != (struct MAINLL *) 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				yyerror("ending not allowed on restart");
			}
			/* fill in ending label if any */
			Currstruct_p->u.bar_p->endinglabel = (yyvsp[(1) - (1)].stringval);
			Currstruct_p->u.bar_p->endingloc = Endingloc;
			Currstruct_p->u.bar_p->endending_type = Endending_type;
			ped_endings(Endingloc);

			/* for next time around, figure out what endingloc will
			 * be if user doesn't specify something different */
			switch (Endingloc) {
			case STARTITEM:
				Endingloc = INITEM;
				break;
			case ENDITEM:
				Endingloc = NOITEM;
				break;
			default:
				break;
			}
		}
	}
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 6407 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				l_warning(Curr_filename, yylineno,
					"hidechanges not allowed on restart; ignoring");
			}
			else {
				Currstruct_p->u.bar_p->hidechanges = YES;
			}
		}
	}
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 6420 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			set_mnum(Currstruct_p->u.bar_p, (yyvsp[(3) - (3)].intval));
		}
	}
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 6427 "src/mup/gram.y"
    {
		if (Currstruct_p != 0) {
			int newval;

			newval = Meas_num + ((yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval));
			if (newval < 1) {
				l_warning(Curr_filename, yylineno,
				"resulting measure number of %d is less than 1; using 1", newval);
				newval = 1;
			}
			set_mnum(Currstruct_p->u.bar_p, newval);
		}
	}
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 6442 "src/mup/gram.y"
    {
		/* +2 to skip font/size */
		init_reh(-1, (yyvsp[(3) - (3)].stringval) + 2, Currstruct_p);
	}
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 6448 "src/mup/gram.y"
    {
		init_reh((yyvsp[(3) - (3)].intval), (char *)0, Currstruct_p);
	}
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 6454 "src/mup/gram.y"
    {
		if (Currstruct_p != 0 && Currstruct_p->str == S_BAR) {
			if (Currstruct_p->u.bar_p->reh_string != 0) {
				/* This indicates user specified multiple
				 * rehearsal strings. We would have already
				 * given a warning message. */
				FREE(Currstruct_p->u.bar_p->reh_string);
				Currstruct_p->u.bar_p->reh_string = 0;
			}
			set_reh_string(Currstruct_p->u.bar_p, (yyvsp[(3) - (7)].intval), (yyvsp[(4) - (7)].intval), (yyvsp[(5) - (7)].intval), (yyvsp[(6) - (7)].stringval));
			Currstruct_p->u.bar_p->dist = Dist;
			Currstruct_p->u.bar_p->dist_usage = Dist_usage;
		}
	}
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 6471 "src/mup/gram.y"
    {
		(yyval.stringval) = (yyvsp[(2) - (2)].stringval);
		(void) fix_string((yyvsp[(2) - (2)].stringval), FONT_TR, DFLT_SIZE, Curr_filename, yylineno);
		Endingloc = STARTITEM;
		Endending_type = EE_DEFAULT;
	}
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 6480 "src/mup/gram.y"
    {
		if (Endingloc == NOITEM) {
			l_warning(Curr_filename, yylineno,
				"no ending in progress; extraneous 'endending' ignored");
			Endending_type = EE_DEFAULT;
		}
		else {
			Endingloc = ENDITEM;
			Endending_type = (yyvsp[(1) - (1)].intval);
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 6494 "src/mup/gram.y"
    {
		/* null token to check for more than one rehearsal mark
		 * on one BAR */
		if (Currstruct_p != (struct MAINLL *) 0 &&
				Currstruct_p->u.bar_p->reh_type != REH_NONE) {
			l_warning(Curr_filename, yylineno,
				"only one rehearsal mark allowed per bar; using last");
		}
	}
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 6505 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_STRING;
		}
	}
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 6513 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_MNUM;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 6522 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_NUM;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 6531 "src/mup/gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_LET;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 6539 "src/mup/gram.y"
    {
		(yyval.inpcoord_p) = (yyvsp[(2) - (6)].inpcoord_p);
		(yyvsp[(2) - (6)].inpcoord_p)->hexpr_p = (yyvsp[(3) - (6)].expr_p);
		(yyvsp[(2) - (6)].inpcoord_p)->vexpr_p = (yyvsp[(5) - (6)].expr_p);
	}
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 6546 "src/mup/gram.y"
    {
		/* null token to allocate an INPCOORD */
		CALLOC(INPCOORD, Curr_loc_info_p, 1);
		(yyval.inpcoord_p) = Curr_loc_info_p;
		/* set to positive in case input starts with an absolute
		 * x coordinate */
		Plus_minus = 1;
	}
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 6556 "src/mup/gram.y"
    {
		(yyval.intval) = Plus_minus = 1;
	}
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 6562 "src/mup/gram.y"
    {
		(yyval.intval) = Plus_minus = -1;
	}
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 6569 "src/mup/gram.y"
    {
		(yyval.expr_p) = (yyvsp[(2) - (2)].expr_p);
		Curr_timeref_tag_p = 0;
	}
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 6577 "src/mup/gram.y"
    {
		(yyval.expr_p) = (yyvsp[(1) - (1)].expr_p);

		/* Put lex back into normal (not coord arithemetic) mode */
		set_lex_mode(NO);
	}
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 6586 "src/mup/gram.y"
    {
		/* Put lex into special mode to return different tokens
		 * for arithmetic operators. This is just in case the
		 * precedence rules might mess up other rules if we used
		 * the same tokens. The + - * / symbols are used for very
		 * different things elsewhere in the grammer, where
		 * precedence doesn't make sense. It probably wouldn't hurt,
		 * but it seems better to be safe, and only do the precedence
		 * when really needed.
		 */
		set_lex_mode(YES);
		Curr_timeref_tag_p = 0;
	}
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 6604 "src/mup/gram.y"
    {
		(yyval.expr_p) = (yyvsp[(2) - (3)].expr_p);
	}
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 6610 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(2) - (3)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(1) - (3)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(3) - (3)].expr_p);
	}
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 6618 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(2) - (3)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(1) - (3)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(3) - (3)].expr_p);
	}
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 6626 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) == OP_SUB) {
			(yyval.expr_p) = newnode(OP_MUL);
			(yyval.expr_p)->left.lchild_p = newnode(OP_FLOAT_LITERAL);
			(yyval.expr_p)->left.lchild_p->left.value = -1.0;
			(yyval.expr_p)->right.rchild_p = (yyvsp[(2) - (2)].expr_p);
		}
		else {
			(yyval.expr_p) = (yyvsp[(2) - (2)].expr_p);
		}
	}
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 6640 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(1) - (4)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(3) - (4)].expr_p);
	}
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 6648 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(1) - (6)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(3) - (6)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(5) - (6)].expr_p);
	}
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 6656 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode(OP_FLOAT_LITERAL);
		(yyval.expr_p)->left.value = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 6663 "src/mup/gram.y"
    {
		(yyval.expr_p) = newnode(OP_TAG_REF);

		/* Get space to save info about this tag reference */
		MALLOC(TAG_REF, (yyval.expr_p)->left.ltag_p, 1);

		/* Get the address of the c[] associated with this tag.
		 * We also save which index into the c[]
		 */
		if (((yyval.expr_p)->left.ltag_p->c = symval((yyvsp[(1) - (3)].stringval), &((yyval.expr_p)->left.ltag_p->c))) != 0) {
			(yyval.expr_p)->left.ltag_p->c_index = (yyvsp[(3) - (3)].intval);
			save_tag_ref((yyval.expr_p)->left.ltag_p->c, &((yyval.expr_p)->left.ltag_p->c));
		}

		if (index_type((yyvsp[(3) - (3)].intval)) == AX) {
			/* Remember this tag, in case user
			 * wants to do a time offset relative to it.
			 * We always take time offsets relative
			 * to the most recent horizontal tag
			 * in the current expression.
			 * Since there may be expressions as arguments
			 * to functions, we keep a stack of these. */
			Curr_timeref_tag_p = (yyval.expr_p)->left.ltag_p;
		}

		/* If this is the first tag of the proper direction in the
		 * expression, that's the base tag used to determine
		 * which staff/score the tag is associated with, if any */
		if (index_type((yyvsp[(3) - (3)].intval)) == AX && Curr_loc_info_p->hor_p == 0) {
			Curr_loc_info_p->hor_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->hor_p,
						&(Curr_loc_info_p->hor_p));
		}
		else if (index_type((yyvsp[(3) - (3)].intval)) == AY && Curr_loc_info_p->vert_p == 0) {
			Curr_loc_info_p->vert_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->vert_p,
						&(Curr_loc_info_p->vert_p));
		}
	}
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 6705 "src/mup/gram.y"
    {
		if (Curr_timeref_tag_p == 0) {
			yyerror("time offset requires a prior horizontal tag reference");
			(yyval.expr_p) = 0;
		}
		else if (is_builtin_tag(Curr_timeref_tag_p->c)) {
			yyerror("cannot have a time offset relative to a builtin tag like _win or _page");
			(yyval.expr_p) = 0;
		}
		else {
			(yyval.expr_p) = newnode(OP_TIME_OFFSET);
			(yyval.expr_p)->left.value = (yyvsp[(2) - (2)].floatval);
			MALLOC(TAG_REF, (yyval.expr_p)->right.rtag_p, 1);
			(yyval.expr_p)->right.rtag_p = Curr_timeref_tag_p;
			save_tag_ref((yyval.expr_p)->right.rtag_p->c,
						&((yyval.expr_p)->right.rtag_p->c));
		}
	}
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 6727 "src/mup/gram.y"
    {
		/* only valid letters are w and y */
		if (*yytext == 'w') {
			(yyval.intval) = AW;
		}
		else if (*yytext == 'y') {
			(yyval.intval) = AY;
		}
		else {
			yyerror("invalid direction: must be x, y, e, w, n or s");
			/* Return something valid, so if any code tries
			 * to use it later, it won't core dump */
			(yyval.intval) = AX;
		}
	}
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 6744 "src/mup/gram.y"
    {
		(yyval.intval) = AX;
	}
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 6750 "src/mup/gram.y"
    {
		/* only valid value is e */
		if (*yytext != 'e') {
			yyerror("invalid direction: must be x, y, e, w, n or s");
		}
		(yyval.intval) = AE;
	}
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 6760 "src/mup/gram.y"
    {
		(yyval.intval) = AN;
	}
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 6766 "src/mup/gram.y"
    {
		(yyval.intval) = AS;
	}
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 6772 "src/mup/gram.y"
    {
		(yyval.floatval) = (float) (yyvsp[(1) - (1)].intval);
	}
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 6777 "src/mup/gram.y"
    {
		sprintf(Tmpbuff,"%d.%s", (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 6783 "src/mup/gram.y"
    {
		sprintf(Tmpbuff,"0.%s", (yyvsp[(2) - (2)].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 6789 "src/mup/gram.y"
    {
		/* no decimal fraction part of float number */
		(yyval.stringval) = "";
	}
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 6799 "src/mup/gram.y"
    {
		(yyval.stringval) = yytext;
	}
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 6807 "src/mup/gram.y"
    {
		Currstruct_p->u.line_p->linetype = (yyvsp[(1) - (7)].intval);
		Currstruct_p->u.line_p->start = *((yyvsp[(4) - (7)].inpcoord_p));
		Currstruct_p->u.line_p->end = *((yyvsp[(6) - (7)].inpcoord_p));
		rep_inpcoord((yyvsp[(4) - (7)].inpcoord_p), &(Currstruct_p->u.line_p->start));
		rep_inpcoord((yyvsp[(6) - (7)].inpcoord_p), &(Currstruct_p->u.line_p->end));
		Currstruct_p->u.line_p->string = (yyvsp[(7) - (7)].stringval);

		/* copies of the location info went into the LINE struct,
		 * so we can free the original copy of the information */
		if ((yyvsp[(4) - (7)].inpcoord_p)) {
			FREE((yyvsp[(4) - (7)].inpcoord_p));
		}
		if ((yyvsp[(6) - (7)].inpcoord_p)) {
			FREE((yyvsp[(6) - (7)].inpcoord_p));
		}
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 6828 "src/mup/gram.y"
    {
		/* null token to cause allocation of LINE struct */
		(void) contextcheck(C_MUSIC, "line");
		Currstruct_p = newMAINLLstruct(S_LINE, yylineno);
	}
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 6835 "src/mup/gram.y"
    {
		(yyval.intval) = L_NORMAL;
	}
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 6845 "src/mup/gram.y"
    {
		(yyval.stringval) = 0;
	}
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 6850 "src/mup/gram.y"
    {
		(yyval.stringval) = fix_string((yyvsp[(4) - (4)].stringval), Titlefont, Titlesize, Curr_filename, yylineno);
	}
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 6856 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (7)].intval) == L_WAVY) {
			l_warning(Curr_filename, yylineno,
						"wavy curve not allowed; using normal curve");
			(yyvsp[(1) - (7)].intval) = L_NORMAL;
		}
		Currstruct_p->u.curve_p->curvetype = (yyvsp[(1) - (7)].intval);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 6868 "src/mup/gram.y"
    {
		(void) contextcheck(C_MUSIC, "curve");
		Currstruct_p = newMAINLLstruct(S_CURVE, yylineno);

		/* get space for a list of locations and mark it as empty */
		Item_count = 0;
		Currstruct_p->u.curve_p->ncoord = (short) Item_count;
		Currstruct_p->u.curve_p->nbulge = (short) Item_count;
		MALLOC(INPCOORD, Currstruct_p->u.curve_p->coordlist, ITEMS);
		Max_items = ITEMS;
	}
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 6902 "src/mup/gram.y"
    {
		/* get enough space to store some values if don't have enough */
		if (Currstruct_p->u.curve_p->nbulge == 0) {
			MALLOCA(float, Currstruct_p->u.curve_p->bulgelist, ITEMS);
		}
		else if ( (Currstruct_p->u.curve_p->nbulge % ITEMS) == 0) {
			REALLOCA(float, Currstruct_p->u.curve_p->bulgelist,
				Currstruct_p->u.curve_p->nbulge + ITEMS);
		}

		/* fill in the value and increment the count of how many */
		Currstruct_p->u.curve_p->bulgelist[Currstruct_p->u.curve_p->nbulge] = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval);
		(Currstruct_p->u.curve_p->nbulge)++;
	}
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 6918 "src/mup/gram.y"
    {
		struct INPCOORD *curve_inpcoord_p;

		/* If ran off end of list, make list bigger.
		 * We cannot use REALLOC here, since we need to update
		 * the tag reference information on each individual array
		 * element, so we alloc all new space, copy the existing data,
		 * and update the tag references, then free the old space,
		 * and redirect the pointer to the new space. */
		if (Currstruct_p->u.curve_p->ncoord >= Max_items) {
			struct INPCOORD *newlist_p;
			int n;
			Max_items += ITEMS;
			MALLOC(INPCOORD, newlist_p, Max_items);
			for (n = 0; n < Currstruct_p->u.curve_p->ncoord; n++) {
				newlist_p[n] = Currstruct_p->u.curve_p->coordlist[n];
				rep_inpcoord(
				    &(Currstruct_p->u.curve_p->coordlist[n]),
				    &(newlist_p[n]));
			}
			FREE(Currstruct_p->u.curve_p->coordlist);
			Currstruct_p->u.curve_p->coordlist = newlist_p;
		}

		/* Add this entry to the end of the list, update the
		 * tag reference to point to this permanent copy rather
		 * the temporary one we will be deleting, and update the
		 * count of how many elements in the list. */
		curve_inpcoord_p = &(Currstruct_p->u.curve_p->coordlist
					[Currstruct_p->u.curve_p->ncoord]);
		*curve_inpcoord_p = *((yyvsp[(1) - (1)].inpcoord_p));
		rep_inpcoord((yyvsp[(1) - (1)].inpcoord_p), curve_inpcoord_p);
		(Currstruct_p->u.curve_p->ncoord)++;
		FREE((yyvsp[(1) - (1)].inpcoord_p));
	}
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 6955 "src/mup/gram.y"
    {
		attach_stuff();
		/* so reset flag */
		Defining_multiple = NO;
	}
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 6963 "src/mup/gram.y"
    {
		chk_stuff_header((yyvsp[(2) - (7)].intval), (yyvsp[(3) - (7)].intval), (yyvsp[(4) - (7)].intval), Dist_usage);
		add_to_sv_list();
	}
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 6970 "src/mup/gram.y"
    {
		/* Separate rule for phrase because it has the linetype
		 * modifier in front, unlike any other STUFF. The size,
		 * and dist are not really allowed, but we match them
		 * if they are there in order to give more clear error
		 * message than just "syntax error," since there was
		 * already code elsewhere to check for these errors.
		 */
		set_stuff_type(ST_PHRASE);
		chk_stuff_header((yyvsp[(3) - (6)].intval), (yyvsp[(1) - (6)].intval), (yyvsp[(4) - (6)].intval), Dist_usage);
		add_to_sv_list();
		Aligntag = NOALIGNTAG;
	}
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 6985 "src/mup/gram.y"
    {
		/* need a separate rule for midi, because it can include
		 * a voice as well as staff. It also cannot have the chord,
		 * size or place, although those are checked elsewhere anyway */
		chk_stuff_header(-1, NO, PL_UNKNOWN, SD_NONE);
		Aligntag = NOALIGNTAG;
	}
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 6995 "src/mup/gram.y"
    {
		set_stuff_type(ST_MIDI);
		begin_range(PL_UNKNOWN);
	}
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 7005 "src/mup/gram.y"
    {
		all();
		add_to_sv_list();
	}
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 7012 "src/mup/gram.y"
    {
		/* dummy token for sole purpose of saving away current
		 * stuff type. We have to do this in order to have it in
		 * time to figure out the default place for "all" */
		set_stuff_type((yyvsp[(1) - (1)].intval));
	}
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 7021 "src/mup/gram.y"
    {
		Curr_family = (yyvsp[(1) - (2)].intval);

		switch ((yyvsp[(2) - (2)].intval)) {
		case FONT_TR:
			(yyval.intval) = ST_ROM;
			break;
		case FONT_TI:
			(yyval.intval) = ST_ITAL;
			break;
		case FONT_TB:
			(yyval.intval) = ST_BOLD;
			break;
		case FONT_TX:
			(yyval.intval) = ST_BOLDITAL;
			break;
		default:
			pfatal("unknown font");
			break;
		}
	}
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 7045 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != L_NORMAL) {
			/* user used 'dotted' or 'dashed' which applies only
			 * to use of T_L_ANGLE for slurs. Use generic error
			 * message so looks like any other similar error. */
			yyerror("syntax error");
		}
		(yyval.intval) = ST_CRESC;
	}
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 7057 "src/mup/gram.y"
    {
		(yyval.intval) = ST_DECRESC;
	}
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 7063 "src/mup/gram.y"
    {
		(yyval.intval) = ST_PEDAL;
	}
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 7069 "src/mup/gram.y"
    {
		(yyval.intval) = ST_MUSSYM;
	}
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 7075 "src/mup/gram.y"
    {
		(yyval.intval) = ST_OCTAVE;
	}
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 7081 "src/mup/gram.y"
    {
		/* use -1 to indicate user didn't specify so must use default */
		(yyval.intval) = -1;
	}
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 7088 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 7093 "src/mup/gram.y"
    {
		(yyval.intval) = TM_NONE;
	}
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 7099 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 7104 "src/mup/gram.y"
    {
		Dist = 0.0;
		Dist_usage = SD_NONE;
	}
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 7111 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) != DIST) {
			yyerror("unexpected parameter name instead of 'dist'");
		}
		else {
			if (frangecheck((yyvsp[(2) - (2)].floatval), -MAXDIST, MAXDIST, "dist") == YES) {
				Dist = (yyvsp[(2) - (2)].floatval);
			}
		}
	}
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 7124 "src/mup/gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (2)].floatval);
	}
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 7130 "src/mup/gram.y"
    {
		if (Dist_usage != SD_FORCE) {
			l_warning(Curr_filename, yylineno,
				"negative dist requires !, setting to 0");
			(yyval.floatval) = 0.0;
		}
		else {
			(yyval.floatval) = - (yyvsp[(2) - (3)].floatval);
		}
	}
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 7142 "src/mup/gram.y"
    {
		Dist_usage = SD_MIN;
	}
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 7148 "src/mup/gram.y"
    {
		Dist_usage = SD_FORCE;
	}
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 7153 "src/mup/gram.y"
    {
		Aligntag = NOALIGNTAG;
	}
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 7159 "src/mup/gram.y"
    {
		if (rangecheck((yyvsp[(2) - (2)].intval), MINALIGNTAG, MAXALIGNTAG, "align tag number") == YES) {
			Aligntag = (yyvsp[(2) - (2)].intval);
		}
		else {
			Aligntag = NOALIGNTAG;
		}
	}
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 7177 "src/mup/gram.y"
    {
		add_stuff_item((yyvsp[(1) - (5)].floatval), (yyvsp[(2) - (5)].floatval), Start_gracebackup, (yyvsp[(3) - (5)].stringval),
			Til_bars, Til_offset, Til_steps, End_gracebackup,
			Dist, Dist_usage, Aligntag);
	}
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 7185 "src/mup/gram.y"
    {
		Til_bars = 0;
		Til_offset = 0.0;
		Til_steps = 0.0;
		(yyval.floatval) = (yyvsp[(1) - (2)].floatval);
		Start_gracebackup = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 7194 "src/mup/gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 7200 "src/mup/gram.y"
    {
		(yyval.intval) = (yyvsp[(3) - (4)].intval);
	}
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 7205 "src/mup/gram.y"
    {
		(yyval.floatval) = 0.0;
	}
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 7211 "src/mup/gram.y"
    {
		(yyval.floatval) = (yyvsp[(3) - (4)].floatval) * (float) (yyvsp[(2) - (4)].intval);
	}
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 7216 "src/mup/gram.y"
    {
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 7222 "src/mup/gram.y"
    {
		if (get_stuff_type() != ST_PEDAL) {
			yyerror("'*' only valid with pedal");
		}
		MALLOCA(char, (yyval.stringval), 12);
		(yyval.stringval)[0] = FONT_MUSIC;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "\\(endped)");
	}
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 7234 "src/mup/gram.y"
    {
		(yyval.stringval) = (yyvsp[(1) - (1)].stringval);
	}
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 7239 "src/mup/gram.y"
    {
		End_gracebackup = 0;
	}
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 7245 "src/mup/gram.y"
    {
	}
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 7250 "src/mup/gram.y"
    {
		/** if there is a non-empty til_suffix, the floatnum better
		 ** have been an integer, and is really the number
		 * of bars. **/
		if ((yyvsp[(2) - (2)].intval) == YES) {
			Til_bars = (int) (yyvsp[(1) - (2)].floatval);
			if ((yyvsp[(1) - (2)].floatval) - Til_bars != 0.0) {
				yyerror("number of measures in til clause must be a whole number");
			}
		}
		else {
			/* only a number, that means it was really a beat offset */
			Til_offset = (yyvsp[(1) - (2)].floatval);
		}
	}
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 7268 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
		End_gracebackup = (yyvsp[(1) - (2)].intval);
		Til_steps = (yyvsp[(2) - (2)].floatval);
	}
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 7276 "src/mup/gram.y"
    {
		(yyval.intval) = YES;
	}
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 7282 "src/mup/gram.y"
    {
		Til_offset = 0.0;
		Til_steps = (yyvsp[(2) - (2)].floatval);
		End_gracebackup = (yyvsp[(1) - (2)].intval);
	}
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 7290 "src/mup/gram.y"
    {
		Til_offset = (yyvsp[(2) - (4)].floatval);
		Til_steps = (yyvsp[(4) - (4)].floatval);
		End_gracebackup = (yyvsp[(3) - (4)].intval);
	}
    break;

  case 743:
/* Line 1792 of yacc.c  */
#line 7300 "src/mup/gram.y"
    {
		newROLLINFO();
	}
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 7306 "src/mup/gram.y"
    {
		newROLLINFO();
		setrolldir(UP);
	}
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 7313 "src/mup/gram.y"
    {
		newROLLINFO();
		setrolldir(DOWN);
	}
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 7324 "src/mup/gram.y"
    {
		/* save staffnum and voice 1 for start of roll */
		rollparam((yyvsp[(1) - (1)].intval), 1, -1, -1);
	}
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 7331 "src/mup/gram.y"
    {
		/* save staff and voice for start of roll */
		rollparam((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval), -1, -1);
	}
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 7340 "src/mup/gram.y"
    {
		/* save staffnum, voice 1 for end of roll */
		rollparam(-1, -1, (yyvsp[(2) - (2)].intval), 1);
	}
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 7347 "src/mup/gram.y"
    {
		/* save staffnum and voice for end of roll */
		rollparam(-1, -1, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval));
	}
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 7354 "src/mup/gram.y"
    {
		rolloffset( (double) (yyvsp[(1) - (2)].floatval));
	}
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 7360 "src/mup/gram.y"
    {	
		rolloffset( (double) (yyvsp[(2) - (3)].floatval));
	}
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 7365 "src/mup/gram.y"
    {
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		String1 = (yyvsp[(3) - (3)].stringval);
		Extra = extra_needed(Curr_family + Curr_font, Curr_size, &String1);
		proc_printcmd((yyvsp[(1) - (3)].intval), Curr_loc_info_p, String1,
			Curr_family + Curr_font, Curr_size, (yyvsp[(2) - (3)].intval),
			NO, PU_NORMAL, NO, 0,
			((yyvsp[(2) - (3)].intval) == YES ? Extra : (double) 0.0));
	}
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 7379 "src/mup/gram.y"
    {
		proc_printcmd(J_NONE, Curr_loc_info_p, (yyvsp[(5) - (5)].stringval), FONT_UNKNOWN,
				DFLT_SIZE, NO, YES, (yyvsp[(2) - (5)].intval), (yyvsp[(4) - (5)].intval), (yyvsp[(3) - (5)].export_p), (double) 0.0);
		if ((yyvsp[(4) - (5)].intval) == NO) {
			end_raw();
		}
	}
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 7389 "src/mup/gram.y"
    {
	}
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 7393 "src/mup/gram.y"
    {
		begin_raw();
		(yyval.intval) = NO;
	}
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 7400 "src/mup/gram.y"
    {
		(yyval.intval) = YES;
	}
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 7406 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == YES) {
			warning("nl ignored for postscript");
		}
		(yyval.intval) = PU_NORMAL;
	}
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 7415 "src/mup/gram.y"
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 7421 "src/mup/gram.y"
    {
		(yyval.export_p) = 0;
	}
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 7427 "src/mup/gram.y"
    {
		(yyval.export_p) = (yyvsp[(2) - (2)].export_p);
	}
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 7436 "src/mup/gram.y"
    {
		/* add onto list and return the list */
		struct VAR_EXPORT *exp_p;
		for (exp_p = (yyvsp[(1) - (3)].export_p); exp_p->next != 0; exp_p = exp_p->next) {
			;
		}
		exp_p->next = (yyvsp[(3) - (3)].export_p);
		(yyval.export_p) = (yyvsp[(1) - (3)].export_p);
	}
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 7448 "src/mup/gram.y"
    {
		(yyvsp[(1) - (1)].export_p)->tag_addr = symval((yyvsp[(1) - (1)].export_p)->name, &((yyvsp[(1) - (1)].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[(1) - (1)].export_p);
	}
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 7455 "src/mup/gram.y"
    {
		(yyvsp[(1) - (1)].export_p)->tag_addr = symval((yyvsp[(1) - (1)].export_p)->name, &((yyvsp[(1) - (1)].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[(1) - (1)].export_p);
	}
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 7462 "src/mup/gram.y"
    {
		if ((yyvsp[(1) - (3)].export_p)->index == NUMCTYPE && (yyvsp[(3) - (3)].export_p)->index != NUMCTYPE && (yyvsp[(3) - (3)].export_p)->index != EXPORT_ALL_STAFFS) {
			l_yyerror(Curr_filename, yylineno,
			"if alias does not have a dot and direction, tag must not either");
		}
		if ((yyvsp[(1) - (3)].export_p)->index != NUMCTYPE && (yyvsp[(3) - (3)].export_p)->index == NUMCTYPE) {
			l_yyerror(Curr_filename, yylineno,
			"if alias has dot and direction, tag must also");
		}
		(yyvsp[(3) - (3)].export_p)->alias = (yyvsp[(1) - (3)].export_p);
		(yyval.export_p) = (yyvsp[(3) - (3)].export_p);
	}
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 7476 "src/mup/gram.y"
    {
		(yyval.export_p) = (yyvsp[(1) - (1)].export_p);
	}
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 7482 "src/mup/gram.y"
    {
		if (strcmp((yyvsp[(1) - (1)].stringval), "_staff") != 0) {
			pfatal("got arraytag other than _staff");
		}
		(yyval.export_p) = add_export((yyvsp[(1) - (1)].stringval), EXPORT_ALL_STAFFS);
	}
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 7491 "src/mup/gram.y"
    {
		(yyval.export_p) = (yyvsp[(1) - (1)].export_p);
	}
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 7497 "src/mup/gram.y"
    {
		/* export all six [nsewxy] values */
		(yyval.export_p) = add_export((yyvsp[(1) - (1)].stringval), NUMCTYPE);
	}
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 7504 "src/mup/gram.y"
    {
		(yyval.export_p) = add_export((yyvsp[(1) - (3)].stringval), (yyvsp[(3) - (3)].intval));
	}
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 7512 "src/mup/gram.y"
    {
		/* this means print at default location */
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = NO;
	}
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 7520 "src/mup/gram.y"
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = YES;
	}
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 7527 "src/mup/gram.y"
    {
		(yyval.intval) = NO;
	}
    break;


/* Line 1792 of yacc.c  */
#line 10966 "src/mup/ytab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 7532 "src/mup/gram.y"


#include <stdio.h>


/* print error message along with current filename and line number */

int
yyerror(msg)

char *msg;

{
	if (strncmp(msg, "syntax error", 12) == 0 ||
			strncmp(msg, "parse error", 11) == 0) {
		/* beef up yacc's default syntax error message */
		if (*yytext == '\n') {
			l_yyerror(Curr_filename, yylineno,
				"error detected at end of line (maybe missing semicolon or other required element?)");
		}
		else if (is_internal_token(yytext) == YES) { 
			/* We add some funny tokens for our internal use
			 * when doing emptymeas parameter expansion.
			 * It is conceivable that there could be
			 * some (rare) scenarios where a user error
			 * in their value for that parameter would cause the
			 * parser to detect the error when it got to our
			 * funny token, and it would be very confusing to the
			 * user if we printed that out as the offending token,
			 * since they didn't input it, and it is chosen
			 * specifically to be strange looking.
			 */
			l_yyerror(Curr_filename, yylineno,
				"error detected during internal emptymeas parameter processing");
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"error detected at '%s'", yytext);
		}
	}
	else {
		l_yyerror(Curr_filename, yylineno, "%s", msg);
	}

	/* return something to keep lint happy */
	return(0);
}


/* if argument is surrounded by double quotes, remove them and return the
 * unquoted string. Actually just NULL out the end quote and return a
 * pointer to beyond the leading quote */

static char *
stripquotes(string)

char *string;

{
	char *p;

	p = string + strlen(string) - 1;
	if (*p == '"') {
		*p = '\0';
	}
	return( *string == '"' ? string + 1 : string);
}


/* Check if the given header/footer type has already been specified,
 * and if so, issue a warning. In any case, set Currblock_p
 * to the passed in BLOCKHEAD pointer. */

static void
chkdup_headfoot(bit, which, block_p)

int bit;	/* which GOT_* bit is associated with this head/foot thing */
char *which;	/* header, footer, header2, footer2 or left/right versions */
struct BLOCKHEAD *block_p;	/* assign this to Currblock_p */

{
	if ((bit & Gotheadfoot) != 0) {
		l_yyerror(Curr_filename, yylineno,
				"%s context specified more than once", which);
	}
	Gotheadfoot |= bit;
	Currblock_p = block_p;
}


/* If the given top/bot block has already been set without having been used,
 * issue a warning. In any case, set it to the Currblock_p value.
 */

static void
chkdup_topbot(block_p_p, blocktype)

struct BLOCKHEAD **block_p_p;	/* address of a FEED field like top_p, bot2_p,
				 * lefttop_p, rightbot_p, etc. What it points
				 * to will be updated with the value of
				 * Currblock_p. */
char *blocktype;		/* Name to be used on error message if the
				 * field was already set before. */

{
	if (*block_p_p != 0) {
		warning("%s redefined before being used", blocktype);
	}
	*block_p_p = Currblock_p;

}


/* when entering new context, need to save away everything about current one */

static void
end_prev_context()

{
	struct MAINLL *place_p;		/* where to insert SSV in main list */


	/* assume we will place at the end of main list. Later we'll set
	 * the right value if that assumption is wrong */
	place_p = Mainlltc_p;

	/* If current main list item hasn't been added to list yet,
	 * do that now. */
	if (Currstruct_p != (struct MAINLL *) 0 && Currstruct_p != place_p) {

		if (Currstruct_p->str == S_SSV) {

			if (List_of_staffs_p != (struct MAINLL *) 0) {
				yyerror("can't change context inside a measure");
				Currstruct_p = (struct MAINLL *) 0;
				return;
			}

			check_beamstyle(Currstruct_p->u.ssv_p);

			/* if is an SSV struct, we also need to set the
			 * correct values at this point, because the
			 * parser needs to know current values of some
			 * things (like font and point size) */
			asgnssv(Currstruct_p->u.ssv_p);

			/* if this SSV is after a FEED, we have to move it
			 * before the FEED in order to follow the rules of
			 * what comes when on the main list */
			for (   ; place_p != (struct MAINLL *) 0 &&
					place_p->str == S_FEED;
					place_p = place_p->prev) {
			}
		}

		insertMAINLL(Currstruct_p, place_p);
	}

	if (Currstruct_p != 0 && Currstruct_p->str == S_SSV) {
		/* memorize or recall beamstyle and timeunit if appropriate */
		remember_tsig_params(Currstruct_p);

		/* If user specified multiple staffs/voices, clone the
		 * necessary SSV nows */
		if (Currstruct_p->u.ssv_p->context == C_STAFF) {
			clone_staff_ssvs(place_p);
			free_rlists();
		}
		else if (Currstruct_p->u.ssv_p->context == C_VOICE) {
			clone_voice_ssvs(place_p);
			free_rlists();
		}
		Defining_multiple = NO;
	}

	if (Curr_usym_p != 0) {
		define_usym();
		Curr_usym_p = 0;
	}

	Curr_grpsyl_p = (struct GRPSYL *) 0;
	Currblock_p = (struct BLOCKHEAD *) 0;
	Currstruct_p = (struct MAINLL *) 0;
	set_win_coord(0);
}


/* If user gave a list of staffs for a "staff" context, clone copies of
 * the SSV that we made for the first on the list for the rest of the list. */

static void
clone_staff_ssvs(insert_p)

struct MAINLL *insert_p;
{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */

	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
		for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
			for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
				if (clone_src_p->staffno == s) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, clone_src_p->voiceno);
			}
		}
	}
}


/* If user gave a list of staffs and/or voices  for a "voice" context,
 * clone copies of the SSV that we made for the first on the list
 * for the rest of the list. */

static void
clone_voice_ssvs(insert_p)

struct MAINLL *insert_p;

{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */
	int have_non_v3 = NO;		/* If any voice other than voice 3 */


	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) {
			for (v = vr_p->begin; v <= vr_p->end && v <= numvoices; v++) {
				if (v != 3) {
					have_non_v3 = YES;
				}
				if (clone_src_p->staffno == s
						&& clone_src_p->voiceno == v) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, v);
			}
		    }
		}
	    }
	}

	if (clone_src_p->used[ALIGNRESTS] == YES && have_non_v3 == NO) {
		l_warning(Curr_filename, yylineno,
				"alignrests not used for voice 3; ignoring");
	}
}

/* Clone the given SSV and insert it in the specified place in the main list.
 * Change the copied versions staffno/voiceno to the specified values,
 * and do any additional error checks and processsing as needed.
 */

static void
clone1ssv(clone_src_p, insert_p, staffno, voiceno)

struct SSV *clone_src_p;
struct MAINLL *insert_p;
int staffno;
int voiceno;

{
	struct MAINLL *newmllssv_p;	/* the cloned SSV */

	newmllssv_p = newMAINLLstruct(S_SSV, Currstruct_p->inputlineno);
	memcpy(newmllssv_p->u.ssv_p, clone_src_p, sizeof(struct SSV));
	newmllssv_p->u.ssv_p->staffno = staffno;
	newmllssv_p->u.ssv_p->voiceno = voiceno;
	/* Fix beamstyle/timeunit. It could be different for each clone */
	remember_tsig_params(newmllssv_p);
	insertMAINLL(newmllssv_p, insert_p);

	/* Make sure any tab staffs have non-tabs above them.
	 * One disadvantage of waiting till making the clone to check this is
	 * that if there is a user error, the line number will be the end
	 * of the context rather than the one with "stafflines" on it.
	 * But the error message will tell them which staff is the problem,
	 * and this should be pretty rare--they have to be setting stafflines
	 * in a staff context for multiple staffs where the combination of
	 * staffs is illegal--so it doesn't seem worth the extra work it would
	 * be to be more precise. */
	if (newmllssv_p->u.ssv_p->context == C_STAFF &&
				newmllssv_p->u.ssv_p->used[STAFFLINES] == YES) {
		chk_tab(newmllssv_p);
	}
	asgnssv(newmllssv_p->u.ssv_p);
}


/* Check that the staffs/voices specified for an SSV are valid.
 * We only give a warning if all values specified are out of range.
 * If at least one is valid, we assume user did something like
 * 	voice 1-40 3
 * to set something for voice 3 on all staffs without having to worry
 * about which staffs actually have a voice 3.
 */

static void
chk_ssv_ranges(context)

UINT32B context;	/* expected to only be either C_STAFF or C_VOICE */

{
	struct SVRANGELIST *svr_p;	/* list of staff/voice ranges */
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */


	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end; s++) {
		    if (context == C_STAFF) {
			if (s >= MINSTAFFS && s <= Score.staffs) {
				/* Found a valid one. One is all we need. */
				return;
			}
			continue;
		    }

		    /* a voice context */
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) { 
			for (v = vr_p->begin; v <= vr_p->end; v++) {
			    if (s >= MINSTAFFS && s <= Score.staffs &&
					v >= MINVOICES && v <= numvoices) {
				/* Found a valid one. One is all we need. */
				return;
			    }
			}
		    }
		}
	    }
	}
	/* Fell through all the loops without finding a single valid case */
	if (context == C_STAFF) {
		l_warning(Curr_filename, yylineno,
			"staff out of range; must be between %d and %d",
			MINSTAFFS, Score.staffs);
	}
	else {
		l_warning(Curr_filename, yylineno,
			"staff/voice combination out of range; staff must be between %d and %d, voice between %d and %d and within vscheme limit for the staff",
			MINSTAFFS, MAXSTAFFS, MINVOICES, MAXVOICES);
	}
}


/* if defining more than one voice at the moment, not valid to set
 * a location variable. Print message and reset flag so we don't
 * give any more of the same message this measure */

static void
var_valid()

{
	if (Defining_multiple == YES) {
		yyerror("location tag is only allowed when defining a single voice");
		Defining_multiple = NO;
	}
	else if (Chord_at_a_time == YES) {
		yyerror("location tag not allowed with chord-at-a-time input");
	}
}


/* Save information about a Mup variable that the user wants to have
 * exported to their PostScript */

static struct VAR_EXPORT *
add_export(varname, index)

char *varname;	/* Name of variable to be exported */
int index;	/* AX, AW, etc or NUMCTYPE if all are to be exported,
		 * or EXPORT_ALL_STAFFS for all indexes of all staffs */

{
	struct VAR_EXPORT *var_p;

	MALLOC(VAR_EXPORT, var_p, 1);
	var_p->name = strdup(varname);
	/* For now we set the alias to ourself. If the user specifies an
	 * alias, then that will be set later. But by defaulting to pointing
	 * to ourself, code can assume there is always an alias. */
	var_p->alias = var_p;
	var_p->index = index;
	var_p->next = 0;
	return(var_p);
}


/* do a print command like left, right, or center. Allocate a PRINTDATA
 * struct and fill in all the information about what to print and where
 * to print it. */

static void
proc_printcmd(justifytype, inpc_p, str, font, size, got_nl, isPostScript, ps_usage, isfilename, export_p, extra)

int justifytype;	/* J_LEFT, etc */
struct INPCOORD *inpc_p;	/* where to print */
char *str;		/* the string to print */
int font;
int size;
int got_nl;	/* YES if should go to next line before printing */
int isPostScript;	/* YES if is raw PostScript rather than normal print */
int ps_usage;		/* PU_* value; tells how is PostScript is used */
int isfilename;		/* Yes if the string is the name of a file containing PostScript */
struct VAR_EXPORT *export_p; /* Mup vars to export to user PostScript */
double extra;	/* how much extra vertical padding to add */

{
	struct PRINTDATA *curr_print_p;
	struct EXPR_NODE *node_p;
	int htype;


	(void) contextcheck(C_MUSIC | C_BLOCKHEAD, "print");

	/* save all the info in a PRINTDATA struct */
	MALLOC(PRINTDATA, curr_print_p, 1);

	if (inpc_p == (struct INPCOORD *) 0) {

		/* print at default location */
		curr_print_p->location.vert_p = symval("_cur", (float **) 0);
		/* Create an expression that is _cur - extra */
		node_p = newnode(OP_SUB);
		curr_print_p->location.vexpr_p = node_p;

		node_p->left.lchild_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, node_p->left.lchild_p->left.ltag_p, 1);
		node_p->left.lchild_p->left.ltag_p->c = curr_print_p->location.vert_p;
		node_p->left.lchild_p->left.ltag_p->c_index = AY;
		save_tag_ref(node_p->left.lchild_p->left.ltag_p->c,
					&(node_p->left.lchild_p->left.ltag_p->c));

		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = extra;

		switch (justifytype) {
		case J_LEFT:
		case J_RAGPARA:
		case J_JUSTPARA:
			/* default x is relative to _win.w */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AW;
			break;
		case J_RIGHT:
			/* default x is relative to _win.e */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AE;
			break;
		case J_CENTER:
			/* default x is relative to _win.x */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AX;
			break;
		case J_NONE:
		default:
			/* default is at current location */
			curr_print_p->location.hor_p = symval("_cur", (float **) 0);
			htype = AX;
			break;
		}

		curr_print_p->location.hexpr_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, curr_print_p->location.hexpr_p->left.ltag_p, 1);
		curr_print_p->location.hexpr_p->left.ltag_p->c = curr_print_p->location.hor_p;
		curr_print_p->location.hexpr_p->left.ltag_p->c_index = htype;
		save_tag_ref(curr_print_p->location.hexpr_p->left.ltag_p->c,
			&(curr_print_p->location.hexpr_p->left.ltag_p->c));

		/* If this is the first print command in a block,
		 * we implicitly go down by the font ascent. */
		if (isPostScript == NO && Currblock_p != 0
					&& Next_print_link_p_p
					== &(Currblock_p->printdata_p) ) {
			/* Alter expression, to subtract the fontascent */
			node_p = newnode(OP_SUB);
			node_p->left.lchild_p = curr_print_p->location.vexpr_p;
			curr_print_p->location.vexpr_p = node_p;
			node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
			node_p->right.rchild_p->left.value = fontascent(font, size) / STEPSIZE;

			got_nl = NO;
		}

	}
	else {
		curr_print_p->location = *(inpc_p);
		rep_inpcoord(inpc_p, &(curr_print_p->location) );
		FREE(inpc_p);
	}

	curr_print_p->isPostScript = isPostScript;
	curr_print_p->ps_usage = ps_usage;
	curr_print_p->export_p = export_p;
	if (isPostScript == YES) {
		curr_print_p->width = 0.0;
	}
	else {
		curr_print_p->width = strwidth(str);
	}
	curr_print_p->isfilename = isfilename;
	curr_print_p->justifytype = (short) justifytype;
	curr_print_p->string = str;
	curr_print_p->inputfile = Curr_filename;
	curr_print_p->inputlineno = (short) yylineno;

	/* For PostScript hooks that apply once to the entire file,
	 * store directly into hook table. */
	switch (ps_usage) {
	case PU_AFTERPROLOG:
	case PU_BEFORETRAILER:
		if (PostScript_hooks[ps_usage] != 0) {
		l_warning(Curr_filename, yylineno, "PostScript hook already set on line %d of %s; using last",
			PostScript_hooks[ps_usage]->inputlineno,
			PostScript_hooks[ps_usage]->inputfile);
		}
		PostScript_hooks[ps_usage]  = curr_print_p;
		return;
	default:
		break;
	}

	/* special case of user asking that this be printed
	 * on the next line. In this case we go down by the
	 * current point size */
	if (got_nl) {
		node_p = newnode(OP_SUB);
		node_p->left.lchild_p = curr_print_p->location.vexpr_p;
		curr_print_p->location.vexpr_p = node_p;
		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = fontheight(font, size) / STEPSIZE;
	}

	/* Now link onto proper list -- could be in BLOCKHEAD
	 * context or doing a PRHEAD. If we are in BLOCKHEAD context, we
	 * definitely have something in the main list to attach to.
	 * If in C_MUSIC, we may or may not depending on whether
	 * this is the first in a series of print commands. */
	if ( ((Context & C_BLOCKHEAD) != 0)
		|| ((Currstruct_p != (struct MAINLL *) 0) &&
		(Currstruct_p->str == S_PRHEAD) ) ) {
			if (Next_print_link_p_p == (struct PRINTDATA **) 0) {
				pfatal("Next_print_link_p_p is null");
			}
			/* this means the value of Next_print_link_p_p
			 * is valid and will tell us where to link */
			*Next_print_link_p_p = curr_print_p;
	}
	else {
		/* We must be in music context, but the last
		 * thing we saw wasn't a print command, so
		 * we have to allocate a PRHEAD and put it
		 * in the main list and attach to that. */
		/* allocate a new struct, put on main list and attach
		 * the print command to it */
		Currstruct_p = newMAINLLstruct(S_PRHEAD, yylineno);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p->u.prhead_p->printdata_p = curr_print_p;
		Currstruct_p = (struct MAINLL *) 0;
	}

	/* in any case, if we get another print command right away, it
	 * should be linked onto this one, so remember where we are */
	Next_print_link_p_p = &(curr_print_p->next);
	curr_print_p->next = (struct PRINTDATA *) 0;
}


/* if the given string has a higher ascent than the given font/size, return
 * the amount is it higher, in stepsizes */

static double
extra_needed(font, size, string_p)

int font;	/* default font for this string */
int size;	/* default size for this string */
char **string_p;/* string, before being put in internal format,
		 * which might contain \s(xx) to make it bigger than normal.
		 * If it is key-mapped, the passed-in pointer will be
		 * updated to point to the mapped string. */

{
	double usual_ascent;
	double this_string_ascent;


	/* get expected ascent for this font/size and actual for string */
	usual_ascent = fontascent(font, size);
	(void) fix_string(*string_p, font, size, Curr_filename, yylineno);
	*string_p = map_print_str(*string_p, Curr_filename, yylineno);
	this_string_ascent = strascent(*string_p);

	/* if this string is too tall, return by how much it is too tall */
	if (this_string_ascent > usual_ascent) {
		return (this_string_ascent - usual_ascent) / STEPSIZE;
	}
	else {
		return(0.0);
	}
}


/* Sometimes lexer will recognize something as a keyword, but it's
 * really a bunch of note letters, due to context. This function turns
 * the mistaken keyword into notes. It handles a through g and r and s, and
 * us, but not n, which would also be troublesome, but which we don't (yet)
 * need to handle.
 */

static void
keyword_notes(str)

char *str;

{
	for (  ; *str != '\0'; str++) {
		if (*str == 'u' && *(str+1) == 's') {
			str++;
			continue;
		}

		/* On the last letter, if it's a true pitch, have to
		 * push it back into input, because it could be followed
		 * by an accidental or octave mark or tick or something. */
		if (*(str+1) == '\0' && *str >= 'a' && *str <= 'g') {
			pushback(*str);
		}
		else {
			add_note(Curr_grpsyl_p, (int) *str, No_accs,
					USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		}
	}
}


/* Free up the current additive time list, if any */

static void
free_extra_time()
{
	struct TIMELIST *tl_p;

	/* If this was the most recently allocated list, we can free it.
	 * We can't free otherwise, since Extra_time_p might be
	 * pointing to one from an SSV, which must be kept around. */
	if (Extra_time_p == Last_alloced_timelist_p) {
		while (Extra_time_p != 0) {
			tl_p = Extra_time_p->next;
			FREE(Extra_time_p);
			Extra_time_p = tl_p;
		}
	}
	Extra_time_p = 0;
	Last_alloced_timelist_p = 0;
	Curr_timelist_p = 0;
}


/* Add an item to the internal representation of the time signature
 * currently being collected */

static void
tsig_item(item)

int item;	/* the byte to add to timerep */

{
	if (Tsig_offset >= MAXTSLEN  - 1) {
		l_ufatal(Curr_filename, yylineno,
				"time signature is too complicated");
	}
	Timerep[Tsig_offset++] = (char) item;
}


/* Allocate a new expression node, fill in its opearator field, and return it. */

static struct EXPR_NODE *
newnode(op)

int op;		/* OP_* value for the new node */

{
	struct EXPR_NODE * node_p;

	CALLOC(EXPR_NODE, node_p, 1);
	node_p->op = op;
	return(node_p);
}


/* Zero out the list of accidentals for the current note */

static void
clear_curr_accs()

{
	CLEAR_ACCS(Curr_accs);
	Acc_offset = 0;
}


/* Add given accidental to the list of accidental for the current note.
 * (if it is valid and there is room) */

static void
add_acc(acc_name)

char *acc_name;

{
	int code;
	int font;

	if (Acc_offset >= 2 * MAX_ACCS) {
		l_yyerror(Curr_filename, yylineno,
				"Too many accidentals (%d max)", MAX_ACCS);
		return;
	}
	if (is_bad_char((code = find_char(acc_name, &font, NO, NO))) == YES) {
		l_yyerror(Curr_filename, yylineno,
			"No symbol named %s to use as accidental", acc_name);
		return;
	}

	/* Note that probably the font should be either one of the music
	 * fonts or user defined font, but we go ahead and allow anything. */
	Curr_accs[Acc_offset++] = font;
	Curr_accs[Acc_offset++] = code;

	/* If we have a non standard accidental, or if the accidentals
	 * net out to something outside the range of double flat to
	 * double sharp, mark Tuning_used, because we can't use simple
	 * ordinary MIDI commands. */
	if (accs_offset(Curr_accs) == BAD_ACCS_OFFSET) {
		Tuning_used = YES;
	}
}


/* Add another entry to the list of accidentals in accidentals context.
 * It is passed the name of the accidental. It allocates an entry,
 * if necessary, sets Curr_acc_index to the index of the entry, fills in
 * the code and font, and sets offsets to a negative value to indicate
 * "not yet filled in."
 */

static void
new_acc_entry(acc_name)

char *acc_name;		/* like "sharp" or "dlbflat" or a user name */

{
	int i;
	int is_small;


	if (Acc_contexts_list_p == 0) {
		/* must have been an earlier error */
		return;
	}

	/* Check for already defined */
	for (i = 0; i < Acc_contexts_list_p->size; i++) {
		if (strcmp(acc_name, get_charname(
				Acc_contexts_list_p->info[i].code,
				Acc_contexts_list_p->info[i].font))
				== 0) {
			/* Use the existing entry */
			Curr_acc_index = i;
			return;
		}
	}

	/* If space is full, alloc another chunk */
	if (Acc_contexts_list_p->size % ITEMS == 0
				&& Acc_contexts_list_p->size > 0) {
		REALLOC(ACCINFO, Acc_contexts_list_p->info,
				Acc_contexts_list_p->size + ITEMS);
	}

	/* Use the next available slot */
	Curr_acc_index = Acc_contexts_list_p->size;

	/* One more slot being used */
	(Acc_contexts_list_p->size)++;

	/* Fill in all the offset slots with an illegal
	 * (i.e., negative) value, so we can tell later which the user
	 * has set. Normally I wouldn't hard-code a 7, but if the
	 * number of "white keys" a-g changes from 7, we have
	 * much bigger problems ;-). 
	 */
	for (i = 0; i < 7; i++) {
		CURR_ACC_ENTRY.offset[i] = -1.0;
	}

	/* Translate symbol name to code and font */
	CURR_ACC_ENTRY.code = find_char(acc_name,
					&(CURR_ACC_ENTRY.font), &is_small, YES);
}


/* Fill in an element of the offset[] array for a accidental,
 * in accidentals context. 
 */

static void
add_acc_offset(letter, offset)

int letter;	/* which index into offset[], 'a' is 0, 'b' is 1, etc */
double offset;	/* what value to fill in */

{
	int index;

	if (Context != C_ACCIDENTALS) {
		return;
	}
	if (Acc_contexts_list_p == 0) {
		/* Must have been earlier error */
		return;
	}

	index = letter - 'a';

	/* Check if already has been set */
	if (CURR_ACC_ENTRY.offset[index] >= 0 ) {
		l_warning(Curr_filename, yylineno,
			"offset for accidental '%s' specified more than once, using last", get_charname(CURR_ACC_ENTRY.code, CURR_ACC_ENTRY.font));
	}

	/* Warn about outrageous values. We consider an accidental
	 * that changes by more than a major third outrageous. */
	if (offset < 0.8 || offset > 1.25) {
		l_warning(Curr_filename, yylineno,
			"dubious accidental offset (factor of %f alters pitch by more than a major third)", offset);
	}

	/* Fill in the value */
	CURR_ACC_ENTRY.offset[index] = offset;
}


static int
comp_subbar(item1_p, item2_p)

#ifdef __STDC__
const void *item1_p;            /* the subbars to compare */
const void *item2_p;
#else
char *item1_p;          	/* the subbars to compare */
char *item2_p;
#endif

{
	struct SUBBAR_INSTANCE *sb1_p, *sb2_p;

	sb1_p = (struct SUBBAR_INSTANCE *) item1_p;
	sb2_p = (struct SUBBAR_INSTANCE *) item2_p;
	if (sb1_p->count < sb2_p->count) {
		return(-1);
	}
	else if (sb1_p->count > sb2_p->count) {
		return(1);
	}
	else {
		return(0);
	}
}
